# ibl_mobile_core_frontend.api.AiApi

## Load the API package
```dart
import 'package:ibl_mobile_core_frontend/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**aiAccountOrgsCredentialCreate**](AiApi.md#aiaccountorgscredentialcreate) | **POST** /api/ai/account/orgs/{org}/credential/ | 
[**aiAccountOrgsCredentialPartialUpdate**](AiApi.md#aiaccountorgscredentialpartialupdate) | **PATCH** /api/ai/account/orgs/{org}/credential/ | 
[**aiAccountOrgsCredentialRetrieve**](AiApi.md#aiaccountorgscredentialretrieve) | **GET** /api/ai/account/orgs/{org}/credential/ | 
[**aiAccountOrgsIntegrationCredentialCreate**](AiApi.md#aiaccountorgsintegrationcredentialcreate) | **POST** /api/ai/account/orgs/{org}/integration-credential/ | 
[**aiAccountOrgsIntegrationCredentialPartialUpdate**](AiApi.md#aiaccountorgsintegrationcredentialpartialupdate) | **PATCH** /api/ai/account/orgs/{org}/integration-credential/ | 
[**aiAccountOrgsIntegrationCredentialRetrieve**](AiApi.md#aiaccountorgsintegrationcredentialretrieve) | **GET** /api/ai/account/orgs/{org}/integration-credential/ | 
[**aiAccountOrgsPlatformMetadataCreate**](AiApi.md#aiaccountorgsplatformmetadatacreate) | **POST** /api/ai/account/orgs/{org}/platform-metadata/ | 
[**aiAccountOrgsPlatformMetadataRetrieve**](AiApi.md#aiaccountorgsplatformmetadataretrieve) | **GET** /api/ai/account/orgs/{org}/platform-metadata/ | 
[**aiAccountOrgsPlatformMetadataUpdate**](AiApi.md#aiaccountorgsplatformmetadataupdate) | **PUT** /api/ai/account/orgs/{org}/platform-metadata/ | 
[**aiAccountOrgsTokensList**](AiApi.md#aiaccountorgstokenslist) | **GET** /api/ai/account/orgs/{org}/tokens/ | 
[**aiBotV1BotsBotCommandsCreate**](AiApi.md#aibotv1botsbotcommandscreate) | **POST** /api/ai/bot/v1/bots/{org}/bot-commands/ | 
[**aiBotV1BotsBotCommandsDestroy**](AiApi.md#aibotv1botsbotcommandsdestroy) | **DELETE** /api/ai/bot/v1/bots/{org}/bot-commands/{id}/ | 
[**aiBotV1BotsBotCommandsList**](AiApi.md#aibotv1botsbotcommandslist) | **GET** /api/ai/bot/v1/bots/{org}/bot-commands/ | 
[**aiBotV1BotsBotCommandsPartialUpdate**](AiApi.md#aibotv1botsbotcommandspartialupdate) | **PATCH** /api/ai/bot/v1/bots/{org}/bot-commands/{id}/ | 
[**aiBotV1BotsBotCommandsRetrieve**](AiApi.md#aibotv1botsbotcommandsretrieve) | **GET** /api/ai/bot/v1/bots/{org}/bot-commands/{id}/ | 
[**aiBotV1BotsBotCommandsUpdate**](AiApi.md#aibotv1botsbotcommandsupdate) | **PUT** /api/ai/bot/v1/bots/{org}/bot-commands/{id}/ | 
[**aiBotV1BotsBotCreate**](AiApi.md#aibotv1botsbotcreate) | **POST** /api/ai/bot/v1/bots/{org}/bot/ | 
[**aiBotV1BotsBotDestroy**](AiApi.md#aibotv1botsbotdestroy) | **DELETE** /api/ai/bot/v1/bots/{org}/bot/{id}/ | 
[**aiBotV1BotsBotList**](AiApi.md#aibotv1botsbotlist) | **GET** /api/ai/bot/v1/bots/{org}/bot/ | 
[**aiBotV1BotsBotPartialUpdate**](AiApi.md#aibotv1botsbotpartialupdate) | **PATCH** /api/ai/bot/v1/bots/{org}/bot/{id}/ | 
[**aiBotV1BotsBotRetrieve**](AiApi.md#aibotv1botsbotretrieve) | **GET** /api/ai/bot/v1/bots/{org}/bot/{id}/ | 
[**aiBotV1BotsBotUpdate**](AiApi.md#aibotv1botsbotupdate) | **PUT** /api/ai/bot/v1/bots/{org}/bot/{id}/ | 
[**aiBotV1BotsWebhooksDiscordCreate**](AiApi.md#aibotv1botswebhooksdiscordcreate) | **POST** /api/ai/bot/v1/bots/webhooks/{org}/discord/ | 
[**aiBotV1BotsWebhooksSlackCreate**](AiApi.md#aibotv1botswebhooksslackcreate) | **POST** /api/ai/bot/v1/bots/webhooks/{org}/slack/ | 
[**aiBotV1BotsWebhooksWebexCreate**](AiApi.md#aibotv1botswebhookswebexcreate) | **POST** /api/ai/bot/v1/bots/webhooks/{org}/webex/ | 
[**aiBotV1BotsWebhooksWhatsappCreate**](AiApi.md#aibotv1botswebhookswhatsappcreate) | **POST** /api/ai/bot/v1/bots/webhooks/{org}/whatsapp/ | 
[**aiBotV1BotsWebhooksWhatsappRetrieve**](AiApi.md#aibotv1botswebhookswhatsappretrieve) | **GET** /api/ai/bot/v1/bots/webhooks/{org}/whatsapp/ | 
[**aiIndexOrgsUsersDocumentsRetrieverDocumentsRetrieve**](AiApi.md#aiindexorgsusersdocumentsretrieverdocumentsretrieve) | **GET** /api/ai/index/orgs/{org}/users/{user_id}/documents/{document_id}/retriever_documents/ | 
[**aiIndexOrgsUsersDocumentsRetrieverDocumentsUpdate**](AiApi.md#aiindexorgsusersdocumentsretrieverdocumentsupdate) | **PUT** /api/ai/index/orgs/{org}/users/{user_id}/documents/{document_id}/retriever_documents/ | 
[**aiIndexOrgsUsersMultilingualRetrieverTrainCreate**](AiApi.md#aiindexorgsusersmultilingualretrievertraincreate) | **POST** /api/ai/index/orgs/{org}/users/{user_id}/multilingual_retriever_train/ | 
[**aiIndexOrgsUsersPathwaysRetrieverDocumentsRetrieve**](AiApi.md#aiindexorgsuserspathwaysretrieverdocumentsretrieve) | **GET** /api/ai/index/orgs/{org}/users/{user_id}/pathways/{pathway}/retriever_documents/ | 
[**aiIndexOrgsUsersRetrieverSearchCreate**](AiApi.md#aiindexorgsusersretrieversearchcreate) | **POST** /api/ai/index/orgs/{org}/users/{user_id}/retriever_search/ | 
[**aiIndexOrgsUsersRetrieverTrainCreate**](AiApi.md#aiindexorgsusersretrievertraincreate) | **POST** /api/ai/index/orgs/{org}/users/{user_id}/retriever_train/ | 
[**aiIndexOrgsUsersSourcesCreate**](AiApi.md#aiindexorgsuserssourcescreate) | **POST** /api/ai/index/orgs/{org}/users/{user_id}/sources/ | 
[**aiIndexOrgsUsersTasksRetrieve**](AiApi.md#aiindexorgsuserstasksretrieve) | **GET** /api/ai/index/orgs/{org}/users/{user_id}/tasks/{task_id}/ | 
[**aiIndexOrgsUsersTrainDocumentCreate**](AiApi.md#aiindexorgsuserstraindocumentcreate) | **POST** /api/ai/index/orgs/{org}/users/{user_id}/train-document/ | 
[**aiIndexOrgsUsersTrainSessionDocumentSessionsCreate**](AiApi.md#aiindexorgsuserstrainsessiondocumentsessionscreate) | **POST** /api/ai/index/orgs/{org}/users/{user_id}/train-session-document/sessions/{session_id}/ | 
[**aiMathMathMathStudentsCreate**](AiApi.md#aimathmathmathstudentscreate) | **POST** /api/ai/math/math/{org}/math-students/ | 
[**aiMathMathMathStudentsDestroy**](AiApi.md#aimathmathmathstudentsdestroy) | **DELETE** /api/ai/math/math/{org}/math-students/{id}/ | 
[**aiMathMathMathStudentsList**](AiApi.md#aimathmathmathstudentslist) | **GET** /api/ai/math/math/{org}/math-students/ | 
[**aiMathMathMathStudentsPartialUpdate**](AiApi.md#aimathmathmathstudentspartialupdate) | **PATCH** /api/ai/math/math/{org}/math-students/{id}/ | 
[**aiMathMathMathStudentsRetrieve**](AiApi.md#aimathmathmathstudentsretrieve) | **GET** /api/ai/math/math/{org}/math-students/{id}/ | 
[**aiMathMathMathStudentsUpdate**](AiApi.md#aimathmathmathstudentsupdate) | **PUT** /api/ai/math/math/{org}/math-students/{id}/ | 
[**aiMathMathQuestionsDestroy**](AiApi.md#aimathmathquestionsdestroy) | **DELETE** /api/ai/math/math/{org}/questions/{id}/ | 
[**aiMathMathQuestionsList**](AiApi.md#aimathmathquestionslist) | **GET** /api/ai/math/math/{org}/questions/ | 
[**aiMathMathQuestionsPartialUpdate**](AiApi.md#aimathmathquestionspartialupdate) | **PATCH** /api/ai/math/math/{org}/questions/{id}/ | 
[**aiMathMathQuestionsRetrieve**](AiApi.md#aimathmathquestionsretrieve) | **GET** /api/ai/math/math/{org}/questions/{id}/ | 
[**aiMathMathSampleQuestionsCreate**](AiApi.md#aimathmathsamplequestionscreate) | **POST** /api/ai/math/math/{org}/sample-questions/ | 
[**aiMathMathSampleQuestionsDestroy**](AiApi.md#aimathmathsamplequestionsdestroy) | **DELETE** /api/ai/math/math/{org}/sample-questions/{id}/ | 
[**aiMathMathSampleQuestionsList**](AiApi.md#aimathmathsamplequestionslist) | **GET** /api/ai/math/math/{org}/sample-questions/ | 
[**aiMathMathSampleQuestionsRetrieve**](AiApi.md#aimathmathsamplequestionsretrieve) | **GET** /api/ai/math/math/{org}/sample-questions/{id}/ | 
[**aiMathMathSkillsCreate**](AiApi.md#aimathmathskillscreate) | **POST** /api/ai/math/math/{org}/skills/ | 
[**aiMathMathSkillsDestroy**](AiApi.md#aimathmathskillsdestroy) | **DELETE** /api/ai/math/math/{org}/skills/{id}/ | 
[**aiMathMathSkillsList**](AiApi.md#aimathmathskillslist) | **GET** /api/ai/math/math/{org}/skills/ | 
[**aiMathMathSkillsPartialUpdate**](AiApi.md#aimathmathskillspartialupdate) | **PATCH** /api/ai/math/math/{org}/skills/{id}/ | 
[**aiMathMathSkillsRetrieve**](AiApi.md#aimathmathskillsretrieve) | **GET** /api/ai/math/math/{org}/skills/{id}/ | 
[**aiMathMathSkillsUpdate**](AiApi.md#aimathmathskillsupdate) | **PUT** /api/ai/math/math/{org}/skills/{id}/ | 
[**aiMathMathStudentAnswersCreate**](AiApi.md#aimathmathstudentanswerscreate) | **POST** /api/ai/math/math/{org}/student-answers/ | 
[**aiMathMathStudentAnswersDestroy**](AiApi.md#aimathmathstudentanswersdestroy) | **DELETE** /api/ai/math/math/{org}/student-answers/{id}/ | 
[**aiMathMathStudentAnswersList**](AiApi.md#aimathmathstudentanswerslist) | **GET** /api/ai/math/math/{org}/student-answers/ | 
[**aiMathMathStudentAnswersPartialUpdate**](AiApi.md#aimathmathstudentanswerspartialupdate) | **PATCH** /api/ai/math/math/{org}/student-answers/{id}/ | 
[**aiMathMathStudentAnswersRetrieve**](AiApi.md#aimathmathstudentanswersretrieve) | **GET** /api/ai/math/math/{org}/student-answers/{id}/ | 
[**aiMathMathStudentAnswersUpdate**](AiApi.md#aimathmathstudentanswersupdate) | **PUT** /api/ai/math/math/{org}/student-answers/{id}/ | 
[**aiMentorGenerationsStopGenerationCreate**](AiApi.md#aimentorgenerationsstopgenerationcreate) | **POST** /api/ai/mentor/generations/{generation_id}/stop-generation/ | 
[**aiMentorOrgsFreeUsageCountRetrieve**](AiApi.md#aimentororgsfreeusagecountretrieve) | **GET** /api/ai/mentor/orgs/{org}/free-usage-count/ | 
[**aiMentorOrgsMentorFeedbackCreateCreate**](AiApi.md#aimentororgsmentorfeedbackcreatecreate) | **POST** /api/ai/mentor/orgs/{org}/mentor-feedback/create/ | 
[**aiMentorOrgsMentorFeedbackRetrieve**](AiApi.md#aimentororgsmentorfeedbackretrieve) | **GET** /api/ai/mentor/orgs/{org}/mentor-feedback/{feedback_id}/ | 
[**aiMentorOrgsMentorFeedbackUpdate**](AiApi.md#aimentororgsmentorfeedbackupdate) | **PUT** /api/ai/mentor/orgs/{org}/mentor-feedback/{feedback_id}/ | 
[**aiMentorOrgsMentorFromTemplateCreate**](AiApi.md#aimentororgsmentorfromtemplatecreate) | **POST** /api/ai/mentor/orgs/{org}/mentor-from-template/ | 
[**aiMentorOrgsMentorLlmsRetrieve**](AiApi.md#aimentororgsmentorllmsretrieve) | **GET** /api/ai/mentor/orgs/{org}/mentor-llms/ | 
[**aiMentorOrgsMentorWithSettingsCreate**](AiApi.md#aimentororgsmentorwithsettingscreate) | **POST** /api/ai/mentor/orgs/{org}/mentor-with-settings/ | 
[**aiMentorOrgsMentorsPublicSettingsRetrieve**](AiApi.md#aimentororgsmentorspublicsettingsretrieve) | **GET** /api/ai/mentor/orgs/{org}/mentors/{mentor}/public-settings/ | 
[**aiMentorOrgsMentorsSettingsRetrieve**](AiApi.md#aimentororgsmentorssettingsretrieve) | **GET** /api/ai/mentor/orgs/{org}/mentors/{mentor}/settings/ | 
[**aiMentorOrgsMentorsSettingsUpdate**](AiApi.md#aimentororgsmentorssettingsupdate) | **PUT** /api/ai/mentor/orgs/{org}/mentors/{mentor}/settings/ | 
[**aiMentorOrgsMentorsUsersRetrieve**](AiApi.md#aimentororgsmentorsusersretrieve) | **GET** /api/ai/mentor/orgs/{org}/mentors/{mentor}/users/{user_id}/ | 
[**aiMentorOrgsPredictiveAnalyticsCreate**](AiApi.md#aimentororgspredictiveanalyticscreate) | **POST** /api/ai/mentor/orgs/{org}/predictive-analytics/ | 
[**aiMentorOrgsSessionsAskCreate**](AiApi.md#aimentororgssessionsaskcreate) | **POST** /api/ai/mentor/orgs/{org}/sessions/{session_id}/ask/ | 
[**aiMentorOrgsSessionsCreate**](AiApi.md#aimentororgssessionscreate) | **POST** /api/ai/mentor/orgs/{org}/sessions/ | 
[**aiMentorOrgsSessionsUsersAskCreate**](AiApi.md#aimentororgssessionsusersaskcreate) | **POST** /api/ai/mentor/orgs/{org}/sessions/{session_id}/users/{user_id}/ask/ | 
[**aiMentorOrgsUsageRetrieve**](AiApi.md#aimentororgsusageretrieve) | **GET** /api/ai/mentor/orgs/{org}/usage/ | 
[**aiMentorOrgsUsersAudioToTextCreate**](AiApi.md#aimentororgsusersaudiototextcreate) | **POST** /api/ai/mentor/orgs/{org}/users/{user_id}/audio-to-text/ | 
[**aiMentorOrgsUsersCategoryCreate**](AiApi.md#aimentororgsuserscategorycreate) | **POST** /api/ai/mentor/orgs/{org}/users/{user_id}/category | 
[**aiMentorOrgsUsersCategoryDestroy**](AiApi.md#aimentororgsuserscategorydestroy) | **DELETE** /api/ai/mentor/orgs/{org}/users/{user_id}/category | 
[**aiMentorOrgsUsersCategoryRetrieve**](AiApi.md#aimentororgsuserscategoryretrieve) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/category | 
[**aiMentorOrgsUsersCreate**](AiApi.md#aimentororgsuserscreate) | **POST** /api/ai/mentor/orgs/{org}/users/{user_id}/ | 
[**aiMentorOrgsUsersDestroy**](AiApi.md#aimentororgsusersdestroy) | **DELETE** /api/ai/mentor/orgs/{org}/users/{user_id}/{name}/ | 
[**aiMentorOrgsUsersGuidedPromptsSessionsRetrieve**](AiApi.md#aimentororgsusersguidedpromptssessionsretrieve) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/guided-prompts/sessions/{session_id}/ | 
[**aiMentorOrgsUsersList**](AiApi.md#aimentororgsuserslist) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/ | 
[**aiMentorOrgsUsersMentorsRetrieve**](AiApi.md#aimentororgsusersmentorsretrieve) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/ | 
[**aiMentorOrgsUsersMentorsSuggestedPromptsCreate**](AiApi.md#aimentororgsusersmentorssuggestedpromptscreate) | **POST** /api/ai/mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/suggested-prompts/ | 
[**aiMentorOrgsUsersMentorsSuggestedPromptsDestroy**](AiApi.md#aimentororgsusersmentorssuggestedpromptsdestroy) | **DELETE** /api/ai/mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/suggested-prompts/ | 
[**aiMentorOrgsUsersMentorsSuggestedPromptsRetrieve**](AiApi.md#aimentororgsusersmentorssuggestedpromptsretrieve) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/suggested-prompts/ | 
[**aiMentorOrgsUsersMentorsSuggestedPromptsUpdate**](AiApi.md#aimentororgsusersmentorssuggestedpromptsupdate) | **PUT** /api/ai/mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/suggested-prompts/ | 
[**aiMentorOrgsUsersPartialUpdate**](AiApi.md#aimentororgsuserspartialupdate) | **PATCH** /api/ai/mentor/orgs/{org}/users/{user_id}/{name}/ | 
[**aiMentorOrgsUsersPinMessageCreate**](AiApi.md#aimentororgsuserspinmessagecreate) | **POST** /api/ai/mentor/orgs/{org}/users/{user_id}/pin-message/ | 
[**aiMentorOrgsUsersPinMessageDestroy**](AiApi.md#aimentororgsuserspinmessagedestroy) | **DELETE** /api/ai/mentor/orgs/{org}/users/{user_id}/pin-message/ | 
[**aiMentorOrgsUsersPinMessageRetrieve**](AiApi.md#aimentororgsuserspinmessageretrieve) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/pin-message/ | 
[**aiMentorOrgsUsersPromptCreate**](AiApi.md#aimentororgsuserspromptcreate) | **POST** /api/ai/mentor/orgs/{org}/users/{user_id}/prompt/ | 
[**aiMentorOrgsUsersPromptDestroy**](AiApi.md#aimentororgsuserspromptdestroy) | **DELETE** /api/ai/mentor/orgs/{org}/users/{user_id}/prompt/{id}/ | 
[**aiMentorOrgsUsersPromptList**](AiApi.md#aimentororgsuserspromptlist) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/prompt/ | 
[**aiMentorOrgsUsersPromptPartialUpdate**](AiApi.md#aimentororgsuserspromptpartialupdate) | **PATCH** /api/ai/mentor/orgs/{org}/users/{user_id}/prompt/{id}/ | 
[**aiMentorOrgsUsersPromptRetrieve**](AiApi.md#aimentororgsuserspromptretrieve) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/prompt/{id}/ | 
[**aiMentorOrgsUsersPromptUpdate**](AiApi.md#aimentororgsuserspromptupdate) | **PUT** /api/ai/mentor/orgs/{org}/users/{user_id}/prompt/{id}/ | 
[**aiMentorOrgsUsersRecentMessagesRetrieve**](AiApi.md#aimentororgsusersrecentmessagesretrieve) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/recent-messages/ | 
[**aiMentorOrgsUsersRecommendCoursesRetrieve**](AiApi.md#aimentororgsusersrecommendcoursesretrieve) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/recommend-courses/ | 
[**aiMentorOrgsUsersRetrieve**](AiApi.md#aimentororgsusersretrieve) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/{name}/ | 
[**aiMentorOrgsUsersSessionidList**](AiApi.md#aimentororgsuserssessionidlist) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/sessionid/ | 
[**aiMentorOrgsUsersSessionsCreate**](AiApi.md#aimentororgsuserssessionscreate) | **POST** /api/ai/mentor/orgs/{org}/users/{user_id}/sessions/ | 
[**aiMentorOrgsUsersSessionsDestroy**](AiApi.md#aimentororgsuserssessionsdestroy) | **DELETE** /api/ai/mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/ | 
[**aiMentorOrgsUsersSessionsDownloadSessionRetrieve**](AiApi.md#aimentororgsuserssessionsdownloadsessionretrieve) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/download-session | 
[**aiMentorOrgsUsersSessionsRetrieve**](AiApi.md#aimentororgsuserssessionsretrieve) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/ | 
[**aiMentorOrgsUsersSessionsSuggestionRetrieve**](AiApi.md#aimentororgsuserssessionssuggestionretrieve) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/suggestion | 
[**aiMentorOrgsUsersSessionsTasksRetrieve**](AiApi.md#aimentororgsuserssessionstasksretrieve) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/tasks/{task_id}/ | 
[**aiMentorOrgsUsersSessionsUpdate**](AiApi.md#aimentororgsuserssessionsupdate) | **PUT** /api/ai/mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/ | 
[**aiMentorOrgsUsersTasksRetrieve**](AiApi.md#aimentororgsuserstasksretrieve) | **GET** /api/ai/mentor/orgs/{org}/users/{user_id}/tasks/{task_id} | 
[**aiMentorOrgsUsersTasksSessionsCreate**](AiApi.md#aimentororgsuserstaskssessionscreate) | **POST** /api/ai/mentor/orgs/{org}/users/{user_id}/tasks/sessions/{session_id}/ | 
[**aiMentorOrgsUsersUpdate**](AiApi.md#aimentororgsusersupdate) | **PUT** /api/ai/mentor/orgs/{org}/users/{user_id}/{name}/ | 


# **aiAccountOrgsCredentialCreate**
> LLMCredential aiAccountOrgsCredentialCreate(org, lLMCredential)



API View to manage LLM credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final lLMCredential = LLMCredential(); // LLMCredential | 

try {
    final result = api_instance.aiAccountOrgsCredentialCreate(org, lLMCredential);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiAccountOrgsCredentialCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **lLMCredential** | [**LLMCredential**](LLMCredential.md)|  | 

### Return type

[**LLMCredential**](LLMCredential.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsCredentialPartialUpdate**
> LLMCredential aiAccountOrgsCredentialPartialUpdate(org, patchedLLMCredential)



API View to manage LLM credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final patchedLLMCredential = PatchedLLMCredential(); // PatchedLLMCredential | 

try {
    final result = api_instance.aiAccountOrgsCredentialPartialUpdate(org, patchedLLMCredential);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiAccountOrgsCredentialPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **patchedLLMCredential** | [**PatchedLLMCredential**](PatchedLLMCredential.md)|  | [optional] 

### Return type

[**LLMCredential**](LLMCredential.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsCredentialRetrieve**
> LLMCredential aiAccountOrgsCredentialRetrieve(org)



API View to manage LLM credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 

try {
    final result = api_instance.aiAccountOrgsCredentialRetrieve(org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiAccountOrgsCredentialRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**LLMCredential**](LLMCredential.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsIntegrationCredentialCreate**
> IntegrationCredential aiAccountOrgsIntegrationCredentialCreate(org, integrationCredential)



API View to manage Integration credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final integrationCredential = IntegrationCredential(); // IntegrationCredential | 

try {
    final result = api_instance.aiAccountOrgsIntegrationCredentialCreate(org, integrationCredential);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiAccountOrgsIntegrationCredentialCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **integrationCredential** | [**IntegrationCredential**](IntegrationCredential.md)|  | 

### Return type

[**IntegrationCredential**](IntegrationCredential.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsIntegrationCredentialPartialUpdate**
> IntegrationCredential aiAccountOrgsIntegrationCredentialPartialUpdate(org, patchedIntegrationCredential)



API View to manage Integration credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final patchedIntegrationCredential = PatchedIntegrationCredential(); // PatchedIntegrationCredential | 

try {
    final result = api_instance.aiAccountOrgsIntegrationCredentialPartialUpdate(org, patchedIntegrationCredential);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiAccountOrgsIntegrationCredentialPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **patchedIntegrationCredential** | [**PatchedIntegrationCredential**](PatchedIntegrationCredential.md)|  | [optional] 

### Return type

[**IntegrationCredential**](IntegrationCredential.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsIntegrationCredentialRetrieve**
> IntegrationCredential aiAccountOrgsIntegrationCredentialRetrieve(org)



API View to manage Integration credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 

try {
    final result = api_instance.aiAccountOrgsIntegrationCredentialRetrieve(org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiAccountOrgsIntegrationCredentialRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**IntegrationCredential**](IntegrationCredential.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsPlatformMetadataCreate**
> IBLAIPlatformMeta aiAccountOrgsPlatformMetadataCreate(org, iBLAIPlatformMeta)



In order to use google as your LLM provider, you need to specify `google_project` (your google cloud project id) and `google_location`, which defaults to `us-central1`

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final iBLAIPlatformMeta = IBLAIPlatformMeta(); // IBLAIPlatformMeta | 

try {
    final result = api_instance.aiAccountOrgsPlatformMetadataCreate(org, iBLAIPlatformMeta);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiAccountOrgsPlatformMetadataCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **iBLAIPlatformMeta** | [**IBLAIPlatformMeta**](IBLAIPlatformMeta.md)|  | [optional] 

### Return type

[**IBLAIPlatformMeta**](IBLAIPlatformMeta.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsPlatformMetadataRetrieve**
> IBLAIPlatformMeta aiAccountOrgsPlatformMetadataRetrieve(org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 

try {
    final result = api_instance.aiAccountOrgsPlatformMetadataRetrieve(org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiAccountOrgsPlatformMetadataRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**IBLAIPlatformMeta**](IBLAIPlatformMeta.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsPlatformMetadataUpdate**
> IBLAIPlatformMeta aiAccountOrgsPlatformMetadataUpdate(org, iBLAIPlatformMeta)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final iBLAIPlatformMeta = IBLAIPlatformMeta(); // IBLAIPlatformMeta | 

try {
    final result = api_instance.aiAccountOrgsPlatformMetadataUpdate(org, iBLAIPlatformMeta);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiAccountOrgsPlatformMetadataUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **iBLAIPlatformMeta** | [**IBLAIPlatformMeta**](IBLAIPlatformMeta.md)|  | [optional] 

### Return type

[**IBLAIPlatformMeta**](IBLAIPlatformMeta.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiAccountOrgsTokensList**
> List<APITokenCost> aiAccountOrgsTokensList(org)



     Token count     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 

try {
    final result = api_instance.aiAccountOrgsTokensList(org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiAccountOrgsTokensList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**List<APITokenCost>**](APITokenCost.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotCommandsCreate**
> BotCommand aiBotV1BotsBotCommandsCreate(org, botCommand)



Create slash commands for a specific bot eg. /iblai-baseline

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final botCommand = BotCommand(); // BotCommand | 

try {
    final result = api_instance.aiBotV1BotsBotCommandsCreate(org, botCommand);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsBotCommandsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **botCommand** | [**BotCommand**](BotCommand.md)|  | 

### Return type

[**BotCommand**](BotCommand.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotCommandsDestroy**
> aiBotV1BotsBotCommandsDestroy(id, org)



Create slash commands for a specific bot eg. /iblai-baseline

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this bot command.
final org = org_example; // String | 

try {
    api_instance.aiBotV1BotsBotCommandsDestroy(id, org);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsBotCommandsDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this bot command. | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotCommandsList**
> List<BotCommand> aiBotV1BotsBotCommandsList(org)



Create slash commands for a specific bot eg. /iblai-baseline

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 

try {
    final result = api_instance.aiBotV1BotsBotCommandsList(org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsBotCommandsList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**List<BotCommand>**](BotCommand.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotCommandsPartialUpdate**
> BotCommand aiBotV1BotsBotCommandsPartialUpdate(id, org, patchedBotCommand)



Create slash commands for a specific bot eg. /iblai-baseline

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this bot command.
final org = org_example; // String | 
final patchedBotCommand = PatchedBotCommand(); // PatchedBotCommand | 

try {
    final result = api_instance.aiBotV1BotsBotCommandsPartialUpdate(id, org, patchedBotCommand);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsBotCommandsPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this bot command. | 
 **org** | **String**|  | 
 **patchedBotCommand** | [**PatchedBotCommand**](PatchedBotCommand.md)|  | [optional] 

### Return type

[**BotCommand**](BotCommand.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotCommandsRetrieve**
> BotCommand aiBotV1BotsBotCommandsRetrieve(id, org)



Create slash commands for a specific bot eg. /iblai-baseline

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this bot command.
final org = org_example; // String | 

try {
    final result = api_instance.aiBotV1BotsBotCommandsRetrieve(id, org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsBotCommandsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this bot command. | 
 **org** | **String**|  | 

### Return type

[**BotCommand**](BotCommand.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotCommandsUpdate**
> BotCommand aiBotV1BotsBotCommandsUpdate(id, org, botCommand)



Create slash commands for a specific bot eg. /iblai-baseline

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this bot command.
final org = org_example; // String | 
final botCommand = BotCommand(); // BotCommand | 

try {
    final result = api_instance.aiBotV1BotsBotCommandsUpdate(id, org, botCommand);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsBotCommandsUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this bot command. | 
 **org** | **String**|  | 
 **botCommand** | [**BotCommand**](BotCommand.md)|  | 

### Return type

[**BotCommand**](BotCommand.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotCreate**
> BotCreate aiBotV1BotsBotCreate(org, botCreate)



Create modify and update bot information for a specific tenant.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final botCreate = BotCreate(); // BotCreate | 

try {
    final result = api_instance.aiBotV1BotsBotCreate(org, botCreate);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsBotCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **botCreate** | [**BotCreate**](BotCreate.md)|  | 

### Return type

[**BotCreate**](BotCreate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotDestroy**
> aiBotV1BotsBotDestroy(id, org)



Create modify and update bot information for a specific tenant.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this bot.
final org = org_example; // String | 

try {
    api_instance.aiBotV1BotsBotDestroy(id, org);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsBotDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this bot. | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotList**
> List<Bot> aiBotV1BotsBotList(org)



Create modify and update bot information for a specific tenant.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 

try {
    final result = api_instance.aiBotV1BotsBotList(org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsBotList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**List<Bot>**](Bot.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotPartialUpdate**
> BotCreate aiBotV1BotsBotPartialUpdate(id, org, patchedBotCreate)



Create modify and update bot information for a specific tenant.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this bot.
final org = org_example; // String | 
final patchedBotCreate = PatchedBotCreate(); // PatchedBotCreate | 

try {
    final result = api_instance.aiBotV1BotsBotPartialUpdate(id, org, patchedBotCreate);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsBotPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this bot. | 
 **org** | **String**|  | 
 **patchedBotCreate** | [**PatchedBotCreate**](PatchedBotCreate.md)|  | [optional] 

### Return type

[**BotCreate**](BotCreate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotRetrieve**
> Bot aiBotV1BotsBotRetrieve(id, org)



Create modify and update bot information for a specific tenant.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this bot.
final org = org_example; // String | 

try {
    final result = api_instance.aiBotV1BotsBotRetrieve(id, org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsBotRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this bot. | 
 **org** | **String**|  | 

### Return type

[**Bot**](Bot.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsBotUpdate**
> BotCreate aiBotV1BotsBotUpdate(id, org, botCreate)



Create modify and update bot information for a specific tenant.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this bot.
final org = org_example; // String | 
final botCreate = BotCreate(); // BotCreate | 

try {
    final result = api_instance.aiBotV1BotsBotUpdate(id, org, botCreate);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsBotUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this bot. | 
 **org** | **String**|  | 
 **botCreate** | [**BotCreate**](BotCreate.md)|  | 

### Return type

[**BotCreate**](BotCreate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsWebhooksDiscordCreate**
> DiscordWebhook aiBotV1BotsWebhooksDiscordCreate(org, discordWebhook)



Webhook endpoint to receive and process discord messages.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final discordWebhook = DiscordWebhook(); // DiscordWebhook | 

try {
    final result = api_instance.aiBotV1BotsWebhooksDiscordCreate(org, discordWebhook);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsWebhooksDiscordCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **discordWebhook** | [**DiscordWebhook**](DiscordWebhook.md)|  | 

### Return type

[**DiscordWebhook**](DiscordWebhook.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, multipart/form-data, application/x-www-form-urlencoded
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsWebhooksSlackCreate**
> SlackWebhook aiBotV1BotsWebhooksSlackCreate(org, slackWebhook)



### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final slackWebhook = SlackWebhook(); // SlackWebhook | 

try {
    final result = api_instance.aiBotV1BotsWebhooksSlackCreate(org, slackWebhook);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsWebhooksSlackCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **slackWebhook** | [**SlackWebhook**](SlackWebhook.md)|  | 

### Return type

[**SlackWebhook**](SlackWebhook.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, multipart/form-data, application/x-www-form-urlencoded
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsWebhooksWebexCreate**
> WebexWebhook aiBotV1BotsWebhooksWebexCreate(org, webexWebhook)



Webhook endpoint to receive and process discord messages.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final webexWebhook = WebexWebhook(); // WebexWebhook | 

try {
    final result = api_instance.aiBotV1BotsWebhooksWebexCreate(org, webexWebhook);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsWebhooksWebexCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **webexWebhook** | [**WebexWebhook**](WebexWebhook.md)|  | 

### Return type

[**WebexWebhook**](WebexWebhook.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, multipart/form-data, application/x-www-form-urlencoded
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsWebhooksWhatsappCreate**
> WhatAppWebHook aiBotV1BotsWebhooksWhatsappCreate(org, whatAppWebHook)



Webhook endpoint to receive and process whatsapp messages.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final whatAppWebHook = WhatAppWebHook(); // WhatAppWebHook | 

try {
    final result = api_instance.aiBotV1BotsWebhooksWhatsappCreate(org, whatAppWebHook);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsWebhooksWhatsappCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **whatAppWebHook** | [**WhatAppWebHook**](WhatAppWebHook.md)|  | 

### Return type

[**WhatAppWebHook**](WhatAppWebHook.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, multipart/form-data, application/x-www-form-urlencoded
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiBotV1BotsWebhooksWhatsappRetrieve**
> WhatAppWebHook aiBotV1BotsWebhooksWhatsappRetrieve(org)



Respond to whatsapp's webhook challenge.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 

try {
    final result = api_instance.aiBotV1BotsWebhooksWhatsappRetrieve(org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiBotV1BotsWebhooksWhatsappRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**WhatAppWebHook**](WhatAppWebHook.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersDocumentsRetrieverDocumentsRetrieve**
> RetrieverDocumentEmbedding aiIndexOrgsUsersDocumentsRetrieverDocumentsRetrieve(documentId, org, userId)



     Get document resource details for a tenant     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final documentId = documentId_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiIndexOrgsUsersDocumentsRetrieverDocumentsRetrieve(documentId, org, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiIndexOrgsUsersDocumentsRetrieverDocumentsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **documentId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**RetrieverDocumentEmbedding**](RetrieverDocumentEmbedding.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersDocumentsRetrieverDocumentsUpdate**
> RetrieverDocumentEmbedding aiIndexOrgsUsersDocumentsRetrieverDocumentsUpdate(documentId, org, userId, retrieverDocumentEmbeddingRequest)



     Update document resource details for a tenant     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final documentId = documentId_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 
final retrieverDocumentEmbeddingRequest = RetrieverDocumentEmbeddingRequest(); // RetrieverDocumentEmbeddingRequest | 

try {
    final result = api_instance.aiIndexOrgsUsersDocumentsRetrieverDocumentsUpdate(documentId, org, userId, retrieverDocumentEmbeddingRequest);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiIndexOrgsUsersDocumentsRetrieverDocumentsUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **documentId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **retrieverDocumentEmbeddingRequest** | [**RetrieverDocumentEmbeddingRequest**](RetrieverDocumentEmbeddingRequest.md)|  | 

### Return type

[**RetrieverDocumentEmbedding**](RetrieverDocumentEmbedding.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersMultilingualRetrieverTrainCreate**
> RetreiverTrainViewResponse aiIndexOrgsUsersMultilingualRetrieverTrainCreate(org, userId, retreiverTrainViewRequest)



     Train document from other languages to english     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 
final retreiverTrainViewRequest = RetreiverTrainViewRequest(); // RetreiverTrainViewRequest | 

try {
    final result = api_instance.aiIndexOrgsUsersMultilingualRetrieverTrainCreate(org, userId, retreiverTrainViewRequest);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiIndexOrgsUsersMultilingualRetrieverTrainCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **retreiverTrainViewRequest** | [**RetreiverTrainViewRequest**](RetreiverTrainViewRequest.md)|  | 

### Return type

[**RetreiverTrainViewResponse**](RetreiverTrainViewResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersPathwaysRetrieverDocumentsRetrieve**
> RetrieverDocumentEmbedding aiIndexOrgsUsersPathwaysRetrieverDocumentsRetrieve(org, pathway, userId)



     Get document resources for a tenant     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final pathway = pathway_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiIndexOrgsUsersPathwaysRetrieverDocumentsRetrieve(org, pathway, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiIndexOrgsUsersPathwaysRetrieverDocumentsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **pathway** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**RetrieverDocumentEmbedding**](RetrieverDocumentEmbedding.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersRetrieverSearchCreate**
> RetrieverResponseSearch aiIndexOrgsUsersRetrieverSearchCreate(org, userId, retrieverRequestSearch)



     Retrieve similar documents to the query     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 
final retrieverRequestSearch = RetrieverRequestSearch(); // RetrieverRequestSearch | 

try {
    final result = api_instance.aiIndexOrgsUsersRetrieverSearchCreate(org, userId, retrieverRequestSearch);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiIndexOrgsUsersRetrieverSearchCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **retrieverRequestSearch** | [**RetrieverRequestSearch**](RetrieverRequestSearch.md)|  | 

### Return type

[**RetrieverResponseSearch**](RetrieverResponseSearch.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersRetrieverTrainCreate**
> RetreiverTrainViewResponse aiIndexOrgsUsersRetrieverTrainCreate(org, userId, retreiverTrainViewRequest)



     Train documents     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 
final retreiverTrainViewRequest = RetreiverTrainViewRequest(); // RetreiverTrainViewRequest | 

try {
    final result = api_instance.aiIndexOrgsUsersRetrieverTrainCreate(org, userId, retreiverTrainViewRequest);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiIndexOrgsUsersRetrieverTrainCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **retreiverTrainViewRequest** | [**RetreiverTrainViewRequest**](RetreiverTrainViewRequest.md)|  | 

### Return type

[**RetreiverTrainViewResponse**](RetreiverTrainViewResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersSourcesCreate**
> RetrieverRequestSearchDocument aiIndexOrgsUsersSourcesCreate(org, userId, retrieverRequestSearch)



     Retrieve similar documents sources to the query     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 
final retrieverRequestSearch = RetrieverRequestSearch(); // RetrieverRequestSearch | 

try {
    final result = api_instance.aiIndexOrgsUsersSourcesCreate(org, userId, retrieverRequestSearch);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiIndexOrgsUsersSourcesCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **retrieverRequestSearch** | [**RetrieverRequestSearch**](RetrieverRequestSearch.md)|  | 

### Return type

[**RetrieverRequestSearchDocument**](RetrieverRequestSearchDocument.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersTasksRetrieve**
> CheckDocumentTrainingStatus aiIndexOrgsUsersTasksRetrieve(org, taskId, userId)



     Check document status of training     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final taskId = taskId_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiIndexOrgsUsersTasksRetrieve(org, taskId, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiIndexOrgsUsersTasksRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **taskId** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**CheckDocumentTrainingStatus**](CheckDocumentTrainingStatus.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersTrainDocumentCreate**
> TrainDocumentViewResponse aiIndexOrgsUsersTrainDocumentCreate(org, userId, trainDocumentViewRequest)



     Train documents     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 
final trainDocumentViewRequest = TrainDocumentViewRequest(); // TrainDocumentViewRequest | 

try {
    final result = api_instance.aiIndexOrgsUsersTrainDocumentCreate(org, userId, trainDocumentViewRequest);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiIndexOrgsUsersTrainDocumentCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **trainDocumentViewRequest** | [**TrainDocumentViewRequest**](TrainDocumentViewRequest.md)|  | 

### Return type

[**TrainDocumentViewResponse**](TrainDocumentViewResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiIndexOrgsUsersTrainSessionDocumentSessionsCreate**
> TrainChatSessionDocumentView aiIndexOrgsUsersTrainSessionDocumentSessionsCreate(org, sessionId, userId)



     Train in chat session documents     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final sessionId = sessionId_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiIndexOrgsUsersTrainSessionDocumentSessionsCreate(org, sessionId, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiIndexOrgsUsersTrainSessionDocumentSessionsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**TrainChatSessionDocumentView**](TrainChatSessionDocumentView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathMathStudentsCreate**
> MathStudent aiMathMathMathStudentsCreate(org, mathStudent)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final mathStudent = MathStudent(); // MathStudent | 

try {
    final result = api_instance.aiMathMathMathStudentsCreate(org, mathStudent);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathMathStudentsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **mathStudent** | [**MathStudent**](MathStudent.md)|  | [optional] 

### Return type

[**MathStudent**](MathStudent.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathMathStudentsDestroy**
> aiMathMathMathStudentsDestroy(id, org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this math student.
final org = org_example; // String | 

try {
    api_instance.aiMathMathMathStudentsDestroy(id, org);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathMathStudentsDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this math student. | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathMathStudentsList**
> List<MathStudent> aiMathMathMathStudentsList(org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 

try {
    final result = api_instance.aiMathMathMathStudentsList(org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathMathStudentsList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**List<MathStudent>**](MathStudent.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathMathStudentsPartialUpdate**
> MathStudent aiMathMathMathStudentsPartialUpdate(id, org, patchedMathStudent)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this math student.
final org = org_example; // String | 
final patchedMathStudent = PatchedMathStudent(); // PatchedMathStudent | 

try {
    final result = api_instance.aiMathMathMathStudentsPartialUpdate(id, org, patchedMathStudent);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathMathStudentsPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this math student. | 
 **org** | **String**|  | 
 **patchedMathStudent** | [**PatchedMathStudent**](PatchedMathStudent.md)|  | [optional] 

### Return type

[**MathStudent**](MathStudent.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathMathStudentsRetrieve**
> MathStudent aiMathMathMathStudentsRetrieve(id, org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this math student.
final org = org_example; // String | 

try {
    final result = api_instance.aiMathMathMathStudentsRetrieve(id, org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathMathStudentsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this math student. | 
 **org** | **String**|  | 

### Return type

[**MathStudent**](MathStudent.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathMathStudentsUpdate**
> MathStudent aiMathMathMathStudentsUpdate(id, org, mathStudent)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this math student.
final org = org_example; // String | 
final mathStudent = MathStudent(); // MathStudent | 

try {
    final result = api_instance.aiMathMathMathStudentsUpdate(id, org, mathStudent);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathMathStudentsUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this math student. | 
 **org** | **String**|  | 
 **mathStudent** | [**MathStudent**](MathStudent.md)|  | [optional] 

### Return type

[**MathStudent**](MathStudent.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathQuestionsDestroy**
> aiMathMathQuestionsDestroy(id, org)



Retrieve, update and delete math questions.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this math question.
final org = org_example; // String | 

try {
    api_instance.aiMathMathQuestionsDestroy(id, org);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathQuestionsDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this math question. | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathQuestionsList**
> List<MathQuestion> aiMathMathQuestionsList(org)



Retrieve, update and delete math questions.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 

try {
    final result = api_instance.aiMathMathQuestionsList(org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathQuestionsList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**List<MathQuestion>**](MathQuestion.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathQuestionsPartialUpdate**
> MathQuestion aiMathMathQuestionsPartialUpdate(id, org, patchedMathQuestion)



Retrieve, update and delete math questions.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this math question.
final org = org_example; // String | 
final patchedMathQuestion = PatchedMathQuestion(); // PatchedMathQuestion | 

try {
    final result = api_instance.aiMathMathQuestionsPartialUpdate(id, org, patchedMathQuestion);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathQuestionsPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this math question. | 
 **org** | **String**|  | 
 **patchedMathQuestion** | [**PatchedMathQuestion**](PatchedMathQuestion.md)|  | [optional] 

### Return type

[**MathQuestion**](MathQuestion.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathQuestionsRetrieve**
> MathQuestion aiMathMathQuestionsRetrieve(id, org)



Retrieve, update and delete math questions.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this math question.
final org = org_example; // String | 

try {
    final result = api_instance.aiMathMathQuestionsRetrieve(id, org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathQuestionsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this math question. | 
 **org** | **String**|  | 

### Return type

[**MathQuestion**](MathQuestion.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSampleQuestionsCreate**
> SampleQuestionsDocument aiMathMathSampleQuestionsCreate(org, sampleQuestionsDocument)



Upload documents to provide sample questions of reference to generate more math questions from.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final sampleQuestionsDocument = SampleQuestionsDocument(); // SampleQuestionsDocument | 

try {
    final result = api_instance.aiMathMathSampleQuestionsCreate(org, sampleQuestionsDocument);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathSampleQuestionsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sampleQuestionsDocument** | [**SampleQuestionsDocument**](SampleQuestionsDocument.md)|  | 

### Return type

[**SampleQuestionsDocument**](SampleQuestionsDocument.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSampleQuestionsDestroy**
> aiMathMathSampleQuestionsDestroy(id, org)



Upload documents to provide sample questions of reference to generate more math questions from.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this sample questions document.
final org = org_example; // String | 

try {
    api_instance.aiMathMathSampleQuestionsDestroy(id, org);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathSampleQuestionsDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this sample questions document. | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSampleQuestionsList**
> List<SampleQuestionsDocument> aiMathMathSampleQuestionsList(org)



Upload documents to provide sample questions of reference to generate more math questions from.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 

try {
    final result = api_instance.aiMathMathSampleQuestionsList(org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathSampleQuestionsList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**List<SampleQuestionsDocument>**](SampleQuestionsDocument.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSampleQuestionsRetrieve**
> SampleQuestionsDocument aiMathMathSampleQuestionsRetrieve(id, org)



Upload documents to provide sample questions of reference to generate more math questions from.

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this sample questions document.
final org = org_example; // String | 

try {
    final result = api_instance.aiMathMathSampleQuestionsRetrieve(id, org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathSampleQuestionsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this sample questions document. | 
 **org** | **String**|  | 

### Return type

[**SampleQuestionsDocument**](SampleQuestionsDocument.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSkillsCreate**
> Skill aiMathMathSkillsCreate(org, skill)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final skill = Skill(); // Skill | 

try {
    final result = api_instance.aiMathMathSkillsCreate(org, skill);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathSkillsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **skill** | [**Skill**](Skill.md)|  | 

### Return type

[**Skill**](Skill.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSkillsDestroy**
> aiMathMathSkillsDestroy(id, org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this skill.
final org = org_example; // String | 

try {
    api_instance.aiMathMathSkillsDestroy(id, org);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathSkillsDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this skill. | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSkillsList**
> List<Skill> aiMathMathSkillsList(org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 

try {
    final result = api_instance.aiMathMathSkillsList(org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathSkillsList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**List<Skill>**](Skill.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSkillsPartialUpdate**
> Skill aiMathMathSkillsPartialUpdate(id, org, patchedSkill)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this skill.
final org = org_example; // String | 
final patchedSkill = PatchedSkill(); // PatchedSkill | 

try {
    final result = api_instance.aiMathMathSkillsPartialUpdate(id, org, patchedSkill);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathSkillsPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this skill. | 
 **org** | **String**|  | 
 **patchedSkill** | [**PatchedSkill**](PatchedSkill.md)|  | [optional] 

### Return type

[**Skill**](Skill.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSkillsRetrieve**
> Skill aiMathMathSkillsRetrieve(id, org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this skill.
final org = org_example; // String | 

try {
    final result = api_instance.aiMathMathSkillsRetrieve(id, org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathSkillsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this skill. | 
 **org** | **String**|  | 

### Return type

[**Skill**](Skill.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathSkillsUpdate**
> Skill aiMathMathSkillsUpdate(id, org, skill)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this skill.
final org = org_example; // String | 
final skill = Skill(); // Skill | 

try {
    final result = api_instance.aiMathMathSkillsUpdate(id, org, skill);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathSkillsUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this skill. | 
 **org** | **String**|  | 
 **skill** | [**Skill**](Skill.md)|  | 

### Return type

[**Skill**](Skill.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathStudentAnswersCreate**
> StudentAnswer aiMathMathStudentAnswersCreate(org, studentAnswer)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final studentAnswer = StudentAnswer(); // StudentAnswer | 

try {
    final result = api_instance.aiMathMathStudentAnswersCreate(org, studentAnswer);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathStudentAnswersCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **studentAnswer** | [**StudentAnswer**](StudentAnswer.md)|  | 

### Return type

[**StudentAnswer**](StudentAnswer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathStudentAnswersDestroy**
> aiMathMathStudentAnswersDestroy(id, org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this student answer.
final org = org_example; // String | 

try {
    api_instance.aiMathMathStudentAnswersDestroy(id, org);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathStudentAnswersDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this student answer. | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathStudentAnswersList**
> List<StudentAnswer> aiMathMathStudentAnswersList(org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 

try {
    final result = api_instance.aiMathMathStudentAnswersList(org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathStudentAnswersList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**List<StudentAnswer>**](StudentAnswer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathStudentAnswersPartialUpdate**
> StudentAnswer aiMathMathStudentAnswersPartialUpdate(id, org, patchedStudentAnswer)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this student answer.
final org = org_example; // String | 
final patchedStudentAnswer = PatchedStudentAnswer(); // PatchedStudentAnswer | 

try {
    final result = api_instance.aiMathMathStudentAnswersPartialUpdate(id, org, patchedStudentAnswer);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathStudentAnswersPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this student answer. | 
 **org** | **String**|  | 
 **patchedStudentAnswer** | [**PatchedStudentAnswer**](PatchedStudentAnswer.md)|  | [optional] 

### Return type

[**StudentAnswer**](StudentAnswer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathStudentAnswersRetrieve**
> StudentAnswer aiMathMathStudentAnswersRetrieve(id, org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this student answer.
final org = org_example; // String | 

try {
    final result = api_instance.aiMathMathStudentAnswersRetrieve(id, org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathStudentAnswersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this student answer. | 
 **org** | **String**|  | 

### Return type

[**StudentAnswer**](StudentAnswer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMathMathStudentAnswersUpdate**
> StudentAnswer aiMathMathStudentAnswersUpdate(id, org, studentAnswer)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this student answer.
final org = org_example; // String | 
final studentAnswer = StudentAnswer(); // StudentAnswer | 

try {
    final result = api_instance.aiMathMathStudentAnswersUpdate(id, org, studentAnswer);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMathMathStudentAnswersUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this student answer. | 
 **org** | **String**|  | 
 **studentAnswer** | [**StudentAnswer**](StudentAnswer.md)|  | 

### Return type

[**StudentAnswer**](StudentAnswer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorGenerationsStopGenerationCreate**
> WebSocketStopGenerationView aiMentorGenerationsStopGenerationCreate(generationId)



     Stop websocket generation     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final generationId = generationId_example; // String | 

try {
    final result = api_instance.aiMentorGenerationsStopGenerationCreate(generationId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorGenerationsStopGenerationCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **generationId** | **String**|  | 

### Return type

[**WebSocketStopGenerationView**](WebSocketStopGenerationView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsFreeUsageCountRetrieve**
> FreeUsageCount aiMentorOrgsFreeUsageCountRetrieve(org)



Retrieve the number of questions left for a tenant

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 

try {
    final result = api_instance.aiMentorOrgsFreeUsageCountRetrieve(org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsFreeUsageCountRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**FreeUsageCount**](FreeUsageCount.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsMentorFeedbackCreateCreate**
> UserChatFeedback aiMentorOrgsMentorFeedbackCreateCreate(org, userChatFeedback)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userChatFeedback = UserChatFeedback(); // UserChatFeedback | 

try {
    final result = api_instance.aiMentorOrgsMentorFeedbackCreateCreate(org, userChatFeedback);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsMentorFeedbackCreateCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userChatFeedback** | [**UserChatFeedback**](UserChatFeedback.md)|  | 

### Return type

[**UserChatFeedback**](UserChatFeedback.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsMentorFeedbackRetrieve**
> UserChatFeedback aiMentorOrgsMentorFeedbackRetrieve(feedbackId, org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final feedbackId = 56; // int | 
final org = org_example; // String | 

try {
    final result = api_instance.aiMentorOrgsMentorFeedbackRetrieve(feedbackId, org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsMentorFeedbackRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **feedbackId** | **int**|  | 
 **org** | **String**|  | 

### Return type

[**UserChatFeedback**](UserChatFeedback.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsMentorFeedbackUpdate**
> UserChatFeedback aiMentorOrgsMentorFeedbackUpdate(feedbackId, org, userChatFeedback)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final feedbackId = 56; // int | 
final org = org_example; // String | 
final userChatFeedback = UserChatFeedback(); // UserChatFeedback | 

try {
    final result = api_instance.aiMentorOrgsMentorFeedbackUpdate(feedbackId, org, userChatFeedback);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsMentorFeedbackUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **feedbackId** | **int**|  | 
 **org** | **String**|  | 
 **userChatFeedback** | [**UserChatFeedback**](UserChatFeedback.md)|  | 

### Return type

[**UserChatFeedback**](UserChatFeedback.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsMentorFromTemplateCreate**
> Mentor aiMentorOrgsMentorFromTemplateCreate(org, mentorFromTemplateRequest)



View to create a mentor from a template

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final mentorFromTemplateRequest = MentorFromTemplateRequest(); // MentorFromTemplateRequest | 

try {
    final result = api_instance.aiMentorOrgsMentorFromTemplateCreate(org, mentorFromTemplateRequest);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsMentorFromTemplateCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **mentorFromTemplateRequest** | [**MentorFromTemplateRequest**](MentorFromTemplateRequest.md)|  | 

### Return type

[**Mentor**](Mentor.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsMentorLlmsRetrieve**
> MentorLLMFlowResponse aiMentorOrgsMentorLlmsRetrieve(org)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 

try {
    final result = api_instance.aiMentorOrgsMentorLlmsRetrieve(org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsMentorLlmsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**MentorLLMFlowResponse**](MentorLLMFlowResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsMentorWithSettingsCreate**
> Mentor aiMentorOrgsMentorWithSettingsCreate(org, mentorFromTemplateWithSettingRequest)



View to create a mentor from a template with settings

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final mentorFromTemplateWithSettingRequest = MentorFromTemplateWithSettingRequest(); // MentorFromTemplateWithSettingRequest | 

try {
    final result = api_instance.aiMentorOrgsMentorWithSettingsCreate(org, mentorFromTemplateWithSettingRequest);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsMentorWithSettingsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **mentorFromTemplateWithSettingRequest** | [**MentorFromTemplateWithSettingRequest**](MentorFromTemplateWithSettingRequest.md)|  | 

### Return type

[**Mentor**](Mentor.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsMentorsPublicSettingsRetrieve**
> MentorSettings aiMentorOrgsMentorsPublicSettingsRetrieve(mentor, org)



Get mentor settings

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final mentor = mentor_example; // String | 
final org = org_example; // String | 

try {
    final result = api_instance.aiMentorOrgsMentorsPublicSettingsRetrieve(mentor, org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsMentorsPublicSettingsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 

### Return type

[**MentorSettings**](MentorSettings.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsMentorsSettingsRetrieve**
> MentorSettings aiMentorOrgsMentorsSettingsRetrieve(mentor, org)



Get mentor settings

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final mentor = mentor_example; // String | 
final org = org_example; // String | 

try {
    final result = api_instance.aiMentorOrgsMentorsSettingsRetrieve(mentor, org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsMentorsSettingsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 

### Return type

[**MentorSettings**](MentorSettings.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsMentorsSettingsUpdate**
> MentorSettings aiMentorOrgsMentorsSettingsUpdate(mentor, org, mentorSettingsRequest)



Update mentor settings

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final mentor = mentor_example; // String | 
final org = org_example; // String | 
final mentorSettingsRequest = MentorSettingsRequest(); // MentorSettingsRequest | 

try {
    final result = api_instance.aiMentorOrgsMentorsSettingsUpdate(mentor, org, mentorSettingsRequest);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsMentorsSettingsUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 
 **mentorSettingsRequest** | [**MentorSettingsRequest**](MentorSettingsRequest.md)|  | [optional] 

### Return type

[**MentorSettings**](MentorSettings.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsMentorsUsersRetrieve**
> SessionDetail aiMentorOrgsMentorsUsersRetrieve(mentor, org, userId)



Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final mentor = mentor_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiMentorOrgsMentorsUsersRetrieve(mentor, org, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsMentorsUsersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**SessionDetail**](SessionDetail.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsPredictiveAnalyticsCreate**
> PredictiveAnalyticsResponse aiMentorOrgsPredictiveAnalyticsCreate(org, predictiveAnalyticsRequest)



     Send data  for  predictions     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final predictiveAnalyticsRequest = PredictiveAnalyticsRequest(); // PredictiveAnalyticsRequest | 

try {
    final result = api_instance.aiMentorOrgsPredictiveAnalyticsCreate(org, predictiveAnalyticsRequest);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsPredictiveAnalyticsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **predictiveAnalyticsRequest** | [**PredictiveAnalyticsRequest**](PredictiveAnalyticsRequest.md)|  | 

### Return type

[**PredictiveAnalyticsResponse**](PredictiveAnalyticsResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsSessionsAskCreate**
> AskMentorResponse aiMentorOrgsSessionsAskCreate(org, sessionId, askMentorRequest)



     Send a custom json from langflow to answer a question     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final askMentorRequest = AskMentorRequest(); // AskMentorRequest | 

try {
    final result = api_instance.aiMentorOrgsSessionsAskCreate(org, sessionId, askMentorRequest);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsSessionsAskCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **askMentorRequest** | [**AskMentorRequest**](AskMentorRequest.md)|  | [optional] 

### Return type

[**AskMentorResponse**](AskMentorResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, multipart/form-data, application/x-www-form-urlencoded
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsSessionsCreate**
> ChatSessionResponse aiMentorOrgsSessionsCreate(org, chatSessionRequest)



Create a new chat session

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final chatSessionRequest = ChatSessionRequest(); // ChatSessionRequest | 

try {
    final result = api_instance.aiMentorOrgsSessionsCreate(org, chatSessionRequest);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsSessionsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **chatSessionRequest** | [**ChatSessionRequest**](ChatSessionRequest.md)|  | 

### Return type

[**ChatSessionResponse**](ChatSessionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsSessionsUsersAskCreate**
> AskMentorResponse aiMentorOrgsSessionsUsersAskCreate(org, sessionId, userId, askMentorRequest)



     Send a custom json from langflow to answer a question     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final userId = userId_example; // String | 
final askMentorRequest = AskMentorRequest(); // AskMentorRequest | 

try {
    final result = api_instance.aiMentorOrgsSessionsUsersAskCreate(org, sessionId, userId, askMentorRequest);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsSessionsUsersAskCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 
 **askMentorRequest** | [**AskMentorRequest**](AskMentorRequest.md)|  | [optional] 

### Return type

[**AskMentorResponse**](AskMentorResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, multipart/form-data, application/x-www-form-urlencoded
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsageRetrieve**
> Usage aiMentorOrgsUsageRetrieve(org)



View to return the usage summary of a tenant

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 

try {
    final result = api_instance.aiMentorOrgsUsageRetrieve(org);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsageRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**Usage**](Usage.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersAudioToTextCreate**
> AudioToTextResponse aiMentorOrgsUsersAudioToTextCreate(org, userId, audioToTextRequest)



     Convert audio to text     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 
final audioToTextRequest = AudioToTextRequest(); // AudioToTextRequest | 

try {
    final result = api_instance.aiMentorOrgsUsersAudioToTextCreate(org, userId, audioToTextRequest);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersAudioToTextCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **audioToTextRequest** | [**AudioToTextRequest**](AudioToTextRequest.md)|  | 

### Return type

[**AudioToTextResponse**](AudioToTextResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersCategoryCreate**
> PromptCategory aiMentorOrgsUsersCategoryCreate(org, userId, promptCategory)



View to create/retrieve a prompt category  Only users with the IsAdminUserOrStudentDRFMixin permission can view the categories Only users with the IsPlatformAdminDRFMixin permission can create categories

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 
final promptCategory = PromptCategory(); // PromptCategory | 

try {
    final result = api_instance.aiMentorOrgsUsersCategoryCreate(org, userId, promptCategory);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersCategoryCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **promptCategory** | [**PromptCategory**](PromptCategory.md)|  | 

### Return type

[**PromptCategory**](PromptCategory.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersCategoryDestroy**
> aiMentorOrgsUsersCategoryDestroy(org, userId)



View to create/retrieve a prompt category  Only users with the IsAdminUserOrStudentDRFMixin permission can view the categories Only users with the IsPlatformAdminDRFMixin permission can create categories

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    api_instance.aiMentorOrgsUsersCategoryDestroy(org, userId);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersCategoryDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersCategoryRetrieve**
> PromptCategory aiMentorOrgsUsersCategoryRetrieve(org, userId)



View to create/retrieve a prompt category  Only users with the IsAdminUserOrStudentDRFMixin permission can view the categories Only users with the IsPlatformAdminDRFMixin permission can create categories

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiMentorOrgsUsersCategoryRetrieve(org, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersCategoryRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**PromptCategory**](PromptCategory.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersCreate**
> Mentor aiMentorOrgsUsersCreate(org, userId, mentor)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 
final mentor = Mentor(); // Mentor | 

try {
    final result = api_instance.aiMentorOrgsUsersCreate(org, userId, mentor);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **mentor** | [**Mentor**](Mentor.md)|  | 

### Return type

[**Mentor**](Mentor.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersDestroy**
> aiMentorOrgsUsersDestroy(name, org, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final name = name_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    api_instance.aiMentorOrgsUsersDestroy(name, org, userId);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersGuidedPromptsSessionsRetrieve**
> GuidedPromptsResponse aiMentorOrgsUsersGuidedPromptsSessionsRetrieve(org, sessionId, userId)



     Get suggested AI prompts based on chat history     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiMentorOrgsUsersGuidedPromptsSessionsRetrieve(org, sessionId, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersGuidedPromptsSessionsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**GuidedPromptsResponse**](GuidedPromptsResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersList**
> PaginatedMentorList aiMentorOrgsUsersList(org, userId, page, pageSize)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 
final page = 56; // int | A page number within the paginated result set.
final pageSize = 56; // int | Number of results to return per page.

try {
    final result = api_instance.aiMentorOrgsUsersList(org, userId, page, pageSize);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **page** | **int**| A page number within the paginated result set. | [optional] 
 **pageSize** | **int**| Number of results to return per page. | [optional] 

### Return type

[**PaginatedMentorList**](PaginatedMentorList.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersMentorsRetrieve**
> Mentor aiMentorOrgsUsersMentorsRetrieve(mentor, org, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final mentor = mentor_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiMentorOrgsUsersMentorsRetrieve(mentor, org, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersMentorsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**Mentor**](Mentor.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersMentorsSuggestedPromptsCreate**
> DefaultResponse aiMentorOrgsUsersMentorsSuggestedPromptsCreate(mentor, org, userId, suggestedPrompt)



Suggested Prompts Endpoint

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final mentor = mentor_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 
final suggestedPrompt = SuggestedPrompt(); // SuggestedPrompt | 

try {
    final result = api_instance.aiMentorOrgsUsersMentorsSuggestedPromptsCreate(mentor, org, userId, suggestedPrompt);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersMentorsSuggestedPromptsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **suggestedPrompt** | [**SuggestedPrompt**](SuggestedPrompt.md)|  | 

### Return type

[**DefaultResponse**](DefaultResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersMentorsSuggestedPromptsDestroy**
> aiMentorOrgsUsersMentorsSuggestedPromptsDestroy(mentor, org, userId)



Request body  {\"index\": 0}

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final mentor = mentor_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    api_instance.aiMentorOrgsUsersMentorsSuggestedPromptsDestroy(mentor, org, userId);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersMentorsSuggestedPromptsDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersMentorsSuggestedPromptsRetrieve**
> SuggestedPrompts aiMentorOrgsUsersMentorsSuggestedPromptsRetrieve(mentor, org, userId)



Suggested Prompts Endpoint

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final mentor = mentor_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiMentorOrgsUsersMentorsSuggestedPromptsRetrieve(mentor, org, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersMentorsSuggestedPromptsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**SuggestedPrompts**](SuggestedPrompts.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersMentorsSuggestedPromptsUpdate**
> DefaultResponse aiMentorOrgsUsersMentorsSuggestedPromptsUpdate(mentor, org, userId, suggestedPromptIndex)



Suggested Prompts Endpoint

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final mentor = mentor_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 
final suggestedPromptIndex = SuggestedPromptIndex(); // SuggestedPromptIndex | 

try {
    final result = api_instance.aiMentorOrgsUsersMentorsSuggestedPromptsUpdate(mentor, org, userId, suggestedPromptIndex);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersMentorsSuggestedPromptsUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **mentor** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **suggestedPromptIndex** | [**SuggestedPromptIndex**](SuggestedPromptIndex.md)|  | 

### Return type

[**DefaultResponse**](DefaultResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersPartialUpdate**
> Mentor aiMentorOrgsUsersPartialUpdate(name, org, userId, patchedMentor)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final name = name_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 
final patchedMentor = PatchedMentor(); // PatchedMentor | 

try {
    final result = api_instance.aiMentorOrgsUsersPartialUpdate(name, org, userId, patchedMentor);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **patchedMentor** | [**PatchedMentor**](PatchedMentor.md)|  | [optional] 

### Return type

[**Mentor**](Mentor.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersPinMessageCreate**
> PinnedMessageCreate aiMentorOrgsUsersPinMessageCreate(org, userId, pinnedMessageCreate)



View to create/retrieve a pinned message

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 
final pinnedMessageCreate = PinnedMessageCreate(); // PinnedMessageCreate | 

try {
    final result = api_instance.aiMentorOrgsUsersPinMessageCreate(org, userId, pinnedMessageCreate);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersPinMessageCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **pinnedMessageCreate** | [**PinnedMessageCreate**](PinnedMessageCreate.md)|  | 

### Return type

[**PinnedMessageCreate**](PinnedMessageCreate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersPinMessageDestroy**
> aiMentorOrgsUsersPinMessageDestroy(org, userId)



View to create/retrieve a pinned message

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    api_instance.aiMentorOrgsUsersPinMessageDestroy(org, userId);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersPinMessageDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersPinMessageRetrieve**
> PinnedMessageCreate aiMentorOrgsUsersPinMessageRetrieve(org, userId)



View to create/retrieve a pinned message

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiMentorOrgsUsersPinMessageRetrieve(org, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersPinMessageRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**PinnedMessageCreate**](PinnedMessageCreate.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersPromptCreate**
> Prompt aiMentorOrgsUsersPromptCreate(org, userId, prompt)



View to create/retrieve a prompt

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 
final prompt = Prompt(); // Prompt | 

try {
    final result = api_instance.aiMentorOrgsUsersPromptCreate(org, userId, prompt);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersPromptCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **prompt** | [**Prompt**](Prompt.md)|  | 

### Return type

[**Prompt**](Prompt.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersPromptDestroy**
> aiMentorOrgsUsersPromptDestroy(id, org, userId)



View to create/retrieve a prompt

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this prompt.
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    api_instance.aiMentorOrgsUsersPromptDestroy(id, org, userId);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersPromptDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this prompt. | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersPromptList**
> List<Prompt> aiMentorOrgsUsersPromptList(org, userId)



View to create/retrieve a prompt

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiMentorOrgsUsersPromptList(org, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersPromptList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**List<Prompt>**](Prompt.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersPromptPartialUpdate**
> Prompt aiMentorOrgsUsersPromptPartialUpdate(id, org, userId, patchedPrompt)



View to create/retrieve a prompt

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this prompt.
final org = org_example; // String | 
final userId = userId_example; // String | 
final patchedPrompt = PatchedPrompt(); // PatchedPrompt | 

try {
    final result = api_instance.aiMentorOrgsUsersPromptPartialUpdate(id, org, userId, patchedPrompt);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersPromptPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this prompt. | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **patchedPrompt** | [**PatchedPrompt**](PatchedPrompt.md)|  | [optional] 

### Return type

[**Prompt**](Prompt.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersPromptRetrieve**
> Prompt aiMentorOrgsUsersPromptRetrieve(id, org, userId)



View to create/retrieve a prompt

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this prompt.
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiMentorOrgsUsersPromptRetrieve(id, org, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersPromptRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this prompt. | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**Prompt**](Prompt.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersPromptUpdate**
> Prompt aiMentorOrgsUsersPromptUpdate(id, org, userId, prompt)



View to create/retrieve a prompt

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final id = 56; // int | A unique integer value identifying this prompt.
final org = org_example; // String | 
final userId = userId_example; // String | 
final prompt = Prompt(); // Prompt | 

try {
    final result = api_instance.aiMentorOrgsUsersPromptUpdate(id, org, userId, prompt);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersPromptUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **int**| A unique integer value identifying this prompt. | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **prompt** | [**Prompt**](Prompt.md)|  | 

### Return type

[**Prompt**](Prompt.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersRecentMessagesRetrieve**
> ChatSessionWithMessage aiMentorOrgsUsersRecentMessagesRetrieve(org, userId)



Paginated view to return recent messages

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiMentorOrgsUsersRecentMessagesRetrieve(org, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersRecentMessagesRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**ChatSessionWithMessage**](ChatSessionWithMessage.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersRecommendCoursesRetrieve**
> RecommendCourseResponse aiMentorOrgsUsersRecommendCoursesRetrieve(org, userId, includeLearnerSkills, rankByDifficulty, returnCourseData, returnNumber, searchTerms)



     Recommend courses for a user     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 
final includeLearnerSkills = true; // bool | Include available learner skills for search
final rankByDifficulty = true; // bool | Rank by course difficulty
final returnCourseData = true; // bool | Return course data
final returnNumber = 56; // int | Number of courses to return
final searchTerms = searchTerms_example; // String | Terms to be searched

try {
    final result = api_instance.aiMentorOrgsUsersRecommendCoursesRetrieve(org, userId, includeLearnerSkills, rankByDifficulty, returnCourseData, returnNumber, searchTerms);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersRecommendCoursesRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **includeLearnerSkills** | **bool**| Include available learner skills for search | [optional] [default to true]
 **rankByDifficulty** | **bool**| Rank by course difficulty | [optional] [default to false]
 **returnCourseData** | **bool**| Return course data | [optional] [default to false]
 **returnNumber** | **int**| Number of courses to return | [optional] 
 **searchTerms** | **String**| Terms to be searched | [optional] 

### Return type

[**RecommendCourseResponse**](RecommendCourseResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersRetrieve**
> Mentor aiMentorOrgsUsersRetrieve(name, org, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final name = name_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiMentorOrgsUsersRetrieve(name, org, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**Mentor**](Mentor.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersSessionidList**
> List<ChatHistorySessionId> aiMentorOrgsUsersSessionidList(endDate, org, startDate, userId)



View to get the sessions of a particular user filterable by start date and end date without pagination

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final endDate = endDate_example; // String | 
final org = org_example; // String | 
final startDate = startDate_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiMentorOrgsUsersSessionidList(endDate, org, startDate, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersSessionidList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **endDate** | **String**|  | 
 **org** | **String**|  | 
 **startDate** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**List<ChatHistorySessionId>**](ChatHistorySessionId.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersSessionsCreate**
> ChatSessionResponse aiMentorOrgsUsersSessionsCreate(org, userId, chatSessionRequest)



Create a new chat session

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final userId = userId_example; // String | 
final chatSessionRequest = ChatSessionRequest(); // ChatSessionRequest | 

try {
    final result = api_instance.aiMentorOrgsUsersSessionsCreate(org, userId, chatSessionRequest);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersSessionsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **chatSessionRequest** | [**ChatSessionRequest**](ChatSessionRequest.md)|  | 

### Return type

[**ChatSessionResponse**](ChatSessionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersSessionsDestroy**
> aiMentorOrgsUsersSessionsDestroy(org, sessionId, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final userId = userId_example; // String | 

try {
    api_instance.aiMentorOrgsUsersSessionsDestroy(org, sessionId, userId);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersSessionsDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersSessionsDownloadSessionRetrieve**
> ChatHistoryItem aiMentorOrgsUsersSessionsDownloadSessionRetrieve(org, sessionId, userId)



View to add the downloadable message for a session

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiMentorOrgsUsersSessionsDownloadSessionRetrieve(org, sessionId, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersSessionsDownloadSessionRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**ChatHistoryItem**](ChatHistoryItem.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersSessionsRetrieve**
> MessageView aiMentorOrgsUsersSessionsRetrieve(org, sessionId, userId, share)



     Get chat messages     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final userId = userId_example; // String | 
final share = true; // bool | 

try {
    final result = api_instance.aiMentorOrgsUsersSessionsRetrieve(org, sessionId, userId, share);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersSessionsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 
 **share** | **bool**|  | [optional] [default to false]

### Return type

[**MessageView**](MessageView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersSessionsSuggestionRetrieve**
> RelatedText aiMentorOrgsUsersSessionsSuggestionRetrieve(org, sessionId, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiMentorOrgsUsersSessionsSuggestionRetrieve(org, sessionId, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersSessionsSuggestionRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**RelatedText**](RelatedText.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersSessionsTasksRetrieve**
> ChatHistoryItem aiMentorOrgsUsersSessionsTasksRetrieve(org, sessionId, taskId, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final taskId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiMentorOrgsUsersSessionsTasksRetrieve(org, sessionId, taskId, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersSessionsTasksRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **taskId** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**ChatHistoryItem**](ChatHistoryItem.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersSessionsUpdate**
> MessageViewUpdatResponse aiMentorOrgsUsersSessionsUpdate(org, sessionId, userId, messageViewRequest)



     Update Chat session details     

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final userId = userId_example; // String | 
final messageViewRequest = MessageViewRequest(); // MessageViewRequest | 

try {
    final result = api_instance.aiMentorOrgsUsersSessionsUpdate(org, sessionId, userId, messageViewRequest);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersSessionsUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 
 **messageViewRequest** | [**MessageViewRequest**](MessageViewRequest.md)|  | [optional] 

### Return type

[**MessageViewUpdatResponse**](MessageViewUpdatResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersTasksRetrieve**
> RetrieveTask aiMentorOrgsUsersTasksRetrieve(org, taskId, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final taskId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.aiMentorOrgsUsersTasksRetrieve(org, taskId, userId);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersTasksRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **taskId** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**RetrieveTask**](RetrieveTask.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersTasksSessionsCreate**
> TaskView aiMentorOrgsUsersTasksSessionsCreate(org, sessionId, userId, taskView)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final org = org_example; // String | 
final sessionId = 38400000-8cf0-11bd-b23e-10b96e4ef00d; // String | 
final userId = userId_example; // String | 
final taskView = TaskView(); // TaskView | 

try {
    final result = api_instance.aiMentorOrgsUsersTasksSessionsCreate(org, sessionId, userId, taskView);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersTasksSessionsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **sessionId** | **String**|  | 
 **userId** | **String**|  | 
 **taskView** | [**TaskView**](TaskView.md)|  | 

### Return type

[**TaskView**](TaskView.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **aiMentorOrgsUsersUpdate**
> Mentor aiMentorOrgsUsersUpdate(name, org, userId, mentor)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = AiApi();
final name = name_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 
final mentor = Mentor(); // Mentor | 

try {
    final result = api_instance.aiMentorOrgsUsersUpdate(name, org, userId, mentor);
    print(result);
} catch (e) {
    print('Exception when calling AiApi->aiMentorOrgsUsersUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **mentor** | [**Mentor**](Mentor.md)|  | 

### Return type

[**Mentor**](Mentor.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

