# ibl_mobile_core_frontend.api.FinanceApi

## Load the API package
```dart
import 'package:ibl_mobile_core_frontend/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**financeOrgsProductsOrdersRetrieve**](FinanceApi.md#financeorgsproductsordersretrieve) | **GET** /api/finance/orgs/{org}/products/{slug}/orders | 
[**financeOrgsProductsRetrieve**](FinanceApi.md#financeorgsproductsretrieve) | **GET** /api/finance/orgs/{org}/products | 
[**financeOrgsProductsSalesOverTimeRetrieve**](FinanceApi.md#financeorgsproductssalesovertimeretrieve) | **GET** /api/finance/orgs/{org}/products/{slug}/sales-over-time | 
[**financeOrgsRevenueNetOverTimeRetrieve**](FinanceApi.md#financeorgsrevenuenetovertimeretrieve) | **GET** /api/finance/orgs/{org}/revenue/net-over-time | 
[**financeOrgsRevenueProductsRetrieve**](FinanceApi.md#financeorgsrevenueproductsretrieve) | **GET** /api/finance/orgs/{org}/revenue/products | 


# **financeOrgsProductsOrdersRetrieve**
> Order financeOrgsProductsOrdersRetrieve(org, slug, endDate, startDate)



Return list of WooCommerce orders for product slug over optional date range

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = FinanceApi();
final org = org_example; // String | 
final slug = slug_example; // String | 
final endDate = endDate_example; // String | End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
final startDate = startDate_example; // String | Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.

try {
    final result = api_instance.financeOrgsProductsOrdersRetrieve(org, slug, endDate, startDate);
    print(result);
} catch (e) {
    print('Exception when calling FinanceApi->financeOrgsProductsOrdersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **slug** | **String**|  | 
 **endDate** | **String**| End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time. | [optional] 
 **startDate** | **String**| Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time. | [optional] 

### Return type

[**Order**](Order.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **financeOrgsProductsRetrieve**
> Product financeOrgsProductsRetrieve(org)



Returns table listing products and product info for all or specific org

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = FinanceApi();
final org = org_example; // String | 

try {
    final result = api_instance.financeOrgsProductsRetrieve(org);
    print(result);
} catch (e) {
    print('Exception when calling FinanceApi->financeOrgsProductsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**Product**](Product.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **financeOrgsProductsSalesOverTimeRetrieve**
> NetRevenueOverTime financeOrgsProductsSalesOverTimeRetrieve(org, slug, endDate, startDate)



Returns Net Revenue over time for org and slug

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = FinanceApi();
final org = org_example; // String | 
final slug = slug_example; // String | 
final endDate = endDate_example; // String | End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
final startDate = startDate_example; // String | Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.

try {
    final result = api_instance.financeOrgsProductsSalesOverTimeRetrieve(org, slug, endDate, startDate);
    print(result);
} catch (e) {
    print('Exception when calling FinanceApi->financeOrgsProductsSalesOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **slug** | **String**|  | 
 **endDate** | **String**| End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time. | [optional] 
 **startDate** | **String**| Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time. | [optional] 

### Return type

[**NetRevenueOverTime**](NetRevenueOverTime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **financeOrgsRevenueNetOverTimeRetrieve**
> NetRevenueOverTime financeOrgsRevenueNetOverTimeRetrieve(org, endDate, startDate)



Returns Net Revenue over time for org and slug

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = FinanceApi();
final org = org_example; // String | 
final endDate = endDate_example; // String | End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
final startDate = startDate_example; // String | Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.

try {
    final result = api_instance.financeOrgsRevenueNetOverTimeRetrieve(org, endDate, startDate);
    print(result);
} catch (e) {
    print('Exception when calling FinanceApi->financeOrgsRevenueNetOverTimeRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time. | [optional] 
 **startDate** | **String**| Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time. | [optional] 

### Return type

[**NetRevenueOverTime**](NetRevenueOverTime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **financeOrgsRevenueProductsRetrieve**
> RevenueByProduct financeOrgsRevenueProductsRetrieve(org, endDate, startDate)



Returns Revenue by Product + summary for specific org

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = FinanceApi();
final org = org_example; // String | 
final endDate = endDate_example; // String | End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
final startDate = startDate_example; // String | Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.

try {
    final result = api_instance.financeOrgsRevenueProductsRetrieve(org, endDate, startDate);
    print(result);
} catch (e) {
    print('Exception when calling FinanceApi->financeOrgsRevenueProductsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time. | [optional] 
 **startDate** | **String**| Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time. | [optional] 

### Return type

[**RevenueByProduct**](RevenueByProduct.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

