# ibl_mobile_core_frontend.api.PlatformApi

## Load the API package
```dart
import 'package:ibl_mobile_core_frontend/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**platformOrgsCoursesCountRetrieve**](PlatformApi.md#platformorgscoursescountretrieve) | **GET** /api/platform/orgs/{org}/courses/count | 
[**platformOrgsCoursesGradesRetrieve**](PlatformApi.md#platformorgscoursesgradesretrieve) | **GET** /api/platform/orgs/{org}/courses/grades | 
[**platformOrgsCoursesProgressAverageDaysToCompleteRetrieve**](PlatformApi.md#platformorgscoursesprogressaveragedaystocompleteretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/progress/average-days-to-complete | 
[**platformOrgsCoursesProgressAverageTimeToCompleteRetrieve**](PlatformApi.md#platformorgscoursesprogressaveragetimetocompleteretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/progress/average-time-to-complete | 
[**platformOrgsCoursesProgressCompletedRetrieve**](PlatformApi.md#platformorgscoursesprogresscompletedretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/progress/completed | 
[**platformOrgsCoursesProgressCompletionRateRetrieve**](PlatformApi.md#platformorgscoursesprogresscompletionrateretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/progress/completion-rate | 
[**platformOrgsCoursesProgressInProgressRetrieve**](PlatformApi.md#platformorgscoursesprogressinprogressretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/progress/in-progress | 
[**platformOrgsCoursesProgressRetrieve**](PlatformApi.md#platformorgscoursesprogressretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/progress/ | 
[**platformOrgsCoursesProgressStartedRetrieve**](PlatformApi.md#platformorgscoursesprogressstartedretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/progress/started | 
[**platformOrgsCoursesUsersGradesPassedRetrieve**](PlatformApi.md#platformorgscoursesusersgradespassedretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/users/{user_id}/grades/passed | 
[**platformOrgsCoursesUsersProgressDaysToCompleteRetrieve**](PlatformApi.md#platformorgscoursesusersprogressdaystocompleteretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/users/{user_id}/progress/days-to-complete | 
[**platformOrgsCoursesUsersProgressRetrieve**](PlatformApi.md#platformorgscoursesusersprogressretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/users/{user_id}/progress | 
[**platformOrgsCoursesUsersTimeCountRetrieve**](PlatformApi.md#platformorgscoursesuserstimecountretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/users/{user_id}/time/count | 
[**platformOrgsCoursesUsersVideosCountRetrieve**](PlatformApi.md#platformorgscoursesusersvideoscountretrieve) | **GET** /api/platform/orgs/{org}/courses/{course_id}/users/{user_id}/videos/count | 
[**platformOrgsCoursesVideosRetrieve**](PlatformApi.md#platformorgscoursesvideosretrieve) | **GET** /api/platform/orgs/{org}/courses/videos | 
[**platformOrgsCoursesVideosRetrieve2**](PlatformApi.md#platformorgscoursesvideosretrieve2) | **GET** /api/platform/orgs/{org}/courses/{course_id}/videos/ | 
[**platformOrgsProgressCompletedRetrieve**](PlatformApi.md#platformorgsprogresscompletedretrieve) | **GET** /api/platform/orgs/{org}/progress/completed | 
[**platformOrgsProgressCompletionRateRetrieve**](PlatformApi.md#platformorgsprogresscompletionrateretrieve) | **GET** /api/platform/orgs/{org}/progress/completion-rate | 
[**platformOrgsProgressInProgressRetrieve**](PlatformApi.md#platformorgsprogressinprogressretrieve) | **GET** /api/platform/orgs/{org}/progress/in-progress | 
[**platformOrgsProgressStartedRetrieve**](PlatformApi.md#platformorgsprogressstartedretrieve) | **GET** /api/platform/orgs/{org}/progress/started | 
[**platformOrgsRetrieve**](PlatformApi.md#platformorgsretrieve) | **GET** /api/platform/orgs/{org}/ | 
[**platformOrgsTimeCountRetrieve**](PlatformApi.md#platformorgstimecountretrieve) | **GET** /api/platform/orgs/{org}/time/count | 
[**platformOrgsUsersActiveCountRetrieve**](PlatformApi.md#platformorgsusersactivecountretrieve) | **GET** /api/platform/orgs/{org}/users/active/count | 
[**platformOrgsUsersCountRetrieve**](PlatformApi.md#platformorgsuserscountretrieve) | **GET** /api/platform/orgs/{org}/users/count | 
[**platformOrgsUsersCoursesCompletedCountRetrieve**](PlatformApi.md#platformorgsuserscoursescompletedcountretrieve) | **GET** /api/platform/orgs/{org}/users/courses-completed/count | 


# **platformOrgsCoursesCountRetrieve**
> Count platformOrgsCoursesCountRetrieve(org, format, groupId)



Total courses on the platform

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final org = org_example; // String | 
final format = format_example; // String | Format  * `json` - json
final groupId = 56; // int | Cohort Group ID

try {
    final result = api_instance.platformOrgsCoursesCountRetrieve(org, format, groupId);
    print(result);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsCoursesCountRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**Count**](Count.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsCoursesGradesRetrieve**
> platformOrgsCoursesGradesRetrieve(org)



Grading information on a per course basis

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final org = org_example; // String | 

try {
    api_instance.platformOrgsCoursesGradesRetrieve(org);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsCoursesGradesRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsCoursesProgressAverageDaysToCompleteRetrieve**
> platformOrgsCoursesProgressAverageDaysToCompleteRetrieve(courseId, org)



Average days used to complete a course  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final courseId = courseId_example; // String | 
final org = org_example; // String | 

try {
    api_instance.platformOrgsCoursesProgressAverageDaysToCompleteRetrieve(courseId, org);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsCoursesProgressAverageDaysToCompleteRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsCoursesProgressAverageTimeToCompleteRetrieve**
> platformOrgsCoursesProgressAverageTimeToCompleteRetrieve(courseId, org)



Average time used to complete a course in secs  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final courseId = courseId_example; // String | 
final org = org_example; // String | 

try {
    api_instance.platformOrgsCoursesProgressAverageTimeToCompleteRetrieve(courseId, org);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsCoursesProgressAverageTimeToCompleteRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsCoursesProgressCompletedRetrieve**
> platformOrgsCoursesProgressCompletedRetrieve(courseId, org)



For platform :  Total users who have completed atleast a course on the platform For course : Total completions in course For learner : Total completed courses  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final courseId = courseId_example; // String | 
final org = org_example; // String | 

try {
    api_instance.platformOrgsCoursesProgressCompletedRetrieve(courseId, org);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsCoursesProgressCompletedRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsCoursesProgressCompletionRateRetrieve**
> platformOrgsCoursesProgressCompletionRateRetrieve(courseId, org)



Average of total completed units

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final courseId = courseId_example; // String | 
final org = org_example; // String | 

try {
    api_instance.platformOrgsCoursesProgressCompletionRateRetrieve(courseId, org);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsCoursesProgressCompletionRateRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsCoursesProgressInProgressRetrieve**
> platformOrgsCoursesProgressInProgressRetrieve(courseId, org)



In Progress means any unit completion in the past 30 days  For platform :  Total users who have atleast a course in_progress on the platform For course : Total users For learner : Total courses in progress  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final courseId = courseId_example; // String | 
final org = org_example; // String | 

try {
    api_instance.platformOrgsCoursesProgressInProgressRetrieve(courseId, org);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsCoursesProgressInProgressRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsCoursesProgressRetrieve**
> platformOrgsCoursesProgressRetrieve(courseId, org)



Completion information per enrolled user  Gives Percentage of units completed in course  Query Params course_id <required> user_id <optional>

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final courseId = courseId_example; // String | 
final org = org_example; // String | 

try {
    api_instance.platformOrgsCoursesProgressRetrieve(courseId, org);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsCoursesProgressRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsCoursesProgressStartedRetrieve**
> platformOrgsCoursesProgressStartedRetrieve(courseId, org)



Started means an enrollment  For platform :  Total users who have atleast an enrollment For course : Total users enrolled For learner : Total courses in progress  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final courseId = courseId_example; // String | 
final org = org_example; // String | 

try {
    api_instance.platformOrgsCoursesProgressStartedRetrieve(courseId, org);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsCoursesProgressStartedRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsCoursesUsersGradesPassedRetrieve**
> platformOrgsCoursesUsersGradesPassedRetrieve(courseId, org, userId)



A GET View that validates QueryParams and returns results to a serializer

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final courseId = courseId_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    api_instance.platformOrgsCoursesUsersGradesPassedRetrieve(courseId, org, userId);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsCoursesUsersGradesPassedRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsCoursesUsersProgressDaysToCompleteRetrieve**
> platformOrgsCoursesUsersProgressDaysToCompleteRetrieve(courseId, org, userId)



Average days used to complete a course  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final courseId = courseId_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    api_instance.platformOrgsCoursesUsersProgressDaysToCompleteRetrieve(courseId, org, userId);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsCoursesUsersProgressDaysToCompleteRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsCoursesUsersProgressRetrieve**
> PerlearnerCourseProgress platformOrgsCoursesUsersProgressRetrieve(courseId, org, userId, format, groupId)



Gives Percentage of units completed in course for a specific learner

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final courseId = courseId_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 
final format = format_example; // String | Format  * `json` - json
final groupId = 56; // int | Cohort Group ID

try {
    final result = api_instance.platformOrgsCoursesUsersProgressRetrieve(courseId, org, userId, format, groupId);
    print(result);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsCoursesUsersProgressRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**PerlearnerCourseProgress**](PerlearnerCourseProgress.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsCoursesUsersTimeCountRetrieve**
> Count platformOrgsCoursesUsersTimeCountRetrieve(courseId, org, userId, endDate, format, groupId, startDate)



Time spent count in seconds within a course by a learner

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final courseId = courseId_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 
final endDate = endDate_example; // String | end date. ISO 8601
final format = format_example; // String | Format  * `json` - json
final groupId = 56; // int | Cohort Group ID
final startDate = startDate_example; // String | start date. ISO 8601

try {
    final result = api_instance.platformOrgsCoursesUsersTimeCountRetrieve(courseId, org, userId, endDate, format, groupId, startDate);
    print(result);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsCoursesUsersTimeCountRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Count**](Count.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsCoursesUsersVideosCountRetrieve**
> VideosCount platformOrgsCoursesUsersVideosCountRetrieve(courseId, org, userId, format, groupId)



Total videos watched / Total Course Videos

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final courseId = courseId_example; // String | 
final org = org_example; // String | 
final userId = userId_example; // String | 
final format = format_example; // String | Format  * `json` - json
final groupId = 56; // int | Cohort Group ID

try {
    final result = api_instance.platformOrgsCoursesUsersVideosCountRetrieve(courseId, org, userId, format, groupId);
    print(result);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsCoursesUsersVideosCountRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 
 **userId** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**VideosCount**](VideosCount.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsCoursesVideosRetrieve**
> WatchedVideosPerCourse platformOrgsCoursesVideosRetrieve(org, format, groupId)



Aggregated count of video plays on a per-course basis

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final org = org_example; // String | 
final format = format_example; // String | Format  * `json` - json
final groupId = 56; // int | Cohort Group ID

try {
    final result = api_instance.platformOrgsCoursesVideosRetrieve(org, format, groupId);
    print(result);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsCoursesVideosRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 

### Return type

[**WatchedVideosPerCourse**](WatchedVideosPerCourse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsCoursesVideosRetrieve2**
> platformOrgsCoursesVideosRetrieve2(courseId, org)



Count of total videos in a course  Query Params course_id  e.g course-v1:Org+Course4+Run

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final courseId = courseId_example; // String | 
final org = org_example; // String | 

try {
    api_instance.platformOrgsCoursesVideosRetrieve2(courseId, org);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsCoursesVideosRetrieve2: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **courseId** | **String**|  | 
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsProgressCompletedRetrieve**
> platformOrgsProgressCompletedRetrieve(org)



For platform :  Total users who have completed atleast a course on the platform For course : Total completions in course For learner : Total completed courses  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final org = org_example; // String | 

try {
    api_instance.platformOrgsProgressCompletedRetrieve(org);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsProgressCompletedRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsProgressCompletionRateRetrieve**
> platformOrgsProgressCompletionRateRetrieve(org)



Average of total completed units

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final org = org_example; // String | 

try {
    api_instance.platformOrgsProgressCompletionRateRetrieve(org);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsProgressCompletionRateRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsProgressInProgressRetrieve**
> platformOrgsProgressInProgressRetrieve(org)



In Progress means any unit completion in the past 30 days  For platform :  Total users who have atleast a course in_progress on the platform For course : Total users For learner : Total courses in progress  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final org = org_example; // String | 

try {
    api_instance.platformOrgsProgressInProgressRetrieve(org);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsProgressInProgressRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsProgressStartedRetrieve**
> platformOrgsProgressStartedRetrieve(org)



Started means an enrollment  For platform :  Total users who have atleast an enrollment For course : Total users enrolled For learner : Total courses in progress  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final org = org_example; // String | 

try {
    api_instance.platformOrgsProgressStartedRetrieve(org);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsProgressStartedRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsRetrieve**
> platformOrgsRetrieve(org)



Learners list with email name and date_joined

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final org = org_example; // String | 

try {
    api_instance.platformOrgsRetrieve(org);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsTimeCountRetrieve**
> platformOrgsTimeCountRetrieve(org)



Total time spent count on the platform within specified range or all time  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default result is all time

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final org = org_example; // String | 

try {
    api_instance.platformOrgsTimeCountRetrieve(org);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsTimeCountRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsUsersActiveCountRetrieve**
> Overtime platformOrgsUsersActiveCountRetrieve(org, endDate, format, groupId, startDate)



Count of users with activity on the platform within specified range or all time  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default is all time

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final org = org_example; // String | 
final endDate = endDate_example; // String | end date. ISO 8601
final format = format_example; // String | Format  * `json` - json
final groupId = 56; // int | Cohort Group ID
final startDate = startDate_example; // String | start date. ISO 8601

try {
    final result = api_instance.platformOrgsUsersActiveCountRetrieve(org, endDate, format, groupId, startDate);
    print(result);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsUsersActiveCountRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Overtime**](Overtime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsUsersCountRetrieve**
> Overtime platformOrgsUsersCountRetrieve(org, endDate, format, groupId, startDate)



Count of users enrolled on the platform within specified range or all time  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default is all time

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final org = org_example; // String | 
final endDate = endDate_example; // String | end date. ISO 8601
final format = format_example; // String | Format  * `json` - json
final groupId = 56; // int | Cohort Group ID
final startDate = startDate_example; // String | start date. ISO 8601

try {
    final result = api_instance.platformOrgsUsersCountRetrieve(org, endDate, format, groupId, startDate);
    print(result);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsUsersCountRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Overtime**](Overtime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **platformOrgsUsersCoursesCompletedCountRetrieve**
> Overtime platformOrgsUsersCoursesCompletedCountRetrieve(org, endDate, format, groupId, startDate)



Count of users who have completed a course on the platform within specified range or all time  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default is all time

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = PlatformApi();
final org = org_example; // String | 
final endDate = endDate_example; // String | end date. ISO 8601
final format = format_example; // String | Format  * `json` - json
final groupId = 56; // int | Cohort Group ID
final startDate = startDate_example; // String | start date. ISO 8601

try {
    final result = api_instance.platformOrgsUsersCoursesCompletedCountRetrieve(org, endDate, format, groupId, startDate);
    print(result);
} catch (e) {
    print('Exception when calling PlatformApi->platformOrgsUsersCoursesCompletedCountRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **endDate** | **String**| end date. ISO 8601 | [optional] 
 **format** | **String**| Format  * `json` - json | [optional] [default to 'json']
 **groupId** | **int**| Cohort Group ID | [optional] 
 **startDate** | **String**| start date. ISO 8601 | [optional] 

### Return type

[**Overtime**](Overtime.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

