# ibl_mobile_core_frontend.api.SaasApi

## Load the API package
```dart
import 'package:ibl_mobile_core_frontend/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**saasAwsSubscriptionExpiryWebhookCreate**](SaasApi.md#saasawssubscriptionexpirywebhookcreate) | **POST** /api/saas/aws/subscription/expiry/webhook/ | 
[**saasCreateStripeCustomerCreate**](SaasApi.md#saascreatestripecustomercreate) | **POST** /api/saas/create/stripe/customer/ | 
[**saasCreateStripeCustomerPortalCreate**](SaasApi.md#saascreatestripecustomerportalcreate) | **POST** /api/saas/create/stripe/customer/portal/ | 
[**saasCreateSubscriptionRetrieve**](SaasApi.md#saascreatesubscriptionretrieve) | **GET** /api/saas/create/subscription/ | 
[**saasCustomerPortalWebhookRetrieve**](SaasApi.md#saascustomerportalwebhookretrieve) | **GET** /api/saas/customer/portal/webhook/ | 
[**saasLaunchTenantCreate**](SaasApi.md#saaslaunchtenantcreate) | **POST** /api/saas/launch/tenant/ | 
[**saasPaymentCancelRetrieve**](SaasApi.md#saaspaymentcancelretrieve) | **GET** /api/saas/payment/cancel/ | 
[**saasPaymentSuccessRetrieve**](SaasApi.md#saaspaymentsuccessretrieve) | **GET** /api/saas/payment/success/ | 
[**saasStripeProductPurchaseRetrieve**](SaasApi.md#saasstripeproductpurchaseretrieve) | **GET** /api/saas/stripe/product/purchase/ | 
[**saasSubscriptionCancelRetrieve**](SaasApi.md#saassubscriptioncancelretrieve) | **GET** /api/saas/subscription/cancel/ | 
[**saasSubscriptionSuccessRetrieve**](SaasApi.md#saassubscriptionsuccessretrieve) | **GET** /api/saas/subscription/success/ | 


# **saasAwsSubscriptionExpiryWebhookCreate**
> saasAwsSubscriptionExpiryWebhookCreate()



Update subscription expiry date

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SaasApi();

try {
    api_instance.saasAwsSubscriptionExpiryWebhookCreate();
} catch (e) {
    print('Exception when calling SaasApi->saasAwsSubscriptionExpiryWebhookCreate: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **saasCreateStripeCustomerCreate**
> saasCreateStripeCustomerCreate()



Stripe customer portal

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SaasApi();

try {
    api_instance.saasCreateStripeCustomerCreate();
} catch (e) {
    print('Exception when calling SaasApi->saasCreateStripeCustomerCreate: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **saasCreateStripeCustomerPortalCreate**
> saasCreateStripeCustomerPortalCreate()



### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SaasApi();

try {
    api_instance.saasCreateStripeCustomerPortalCreate();
} catch (e) {
    print('Exception when calling SaasApi->saasCreateStripeCustomerPortalCreate: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **saasCreateSubscriptionRetrieve**
> saasCreateSubscriptionRetrieve()



Stripe product payment intent initiation class

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SaasApi();

try {
    api_instance.saasCreateSubscriptionRetrieve();
} catch (e) {
    print('Exception when calling SaasApi->saasCreateSubscriptionRetrieve: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **saasCustomerPortalWebhookRetrieve**
> saasCustomerPortalWebhookRetrieve()



Create a customer portal

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SaasApi();

try {
    api_instance.saasCustomerPortalWebhookRetrieve();
} catch (e) {
    print('Exception when calling SaasApi->saasCustomerPortalWebhookRetrieve: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **saasLaunchTenantCreate**
> saasLaunchTenantCreate()



User/tenant creation flow

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SaasApi();

try {
    api_instance.saasLaunchTenantCreate();
} catch (e) {
    print('Exception when calling SaasApi->saasLaunchTenantCreate: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **saasPaymentCancelRetrieve**
> saasPaymentCancelRetrieve()



Stripe cancel webhook

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SaasApi();

try {
    api_instance.saasPaymentCancelRetrieve();
} catch (e) {
    print('Exception when calling SaasApi->saasPaymentCancelRetrieve: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **saasPaymentSuccessRetrieve**
> saasPaymentSuccessRetrieve()



Stripe success webhook

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SaasApi();

try {
    api_instance.saasPaymentSuccessRetrieve();
} catch (e) {
    print('Exception when calling SaasApi->saasPaymentSuccessRetrieve: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **saasStripeProductPurchaseRetrieve**
> saasStripeProductPurchaseRetrieve()



Stripe product payment intent initiation class

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SaasApi();

try {
    api_instance.saasStripeProductPurchaseRetrieve();
} catch (e) {
    print('Exception when calling SaasApi->saasStripeProductPurchaseRetrieve: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **saasSubscriptionCancelRetrieve**
> saasSubscriptionCancelRetrieve()



Stripe cancel webhook

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SaasApi();

try {
    api_instance.saasSubscriptionCancelRetrieve();
} catch (e) {
    print('Exception when calling SaasApi->saasSubscriptionCancelRetrieve: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **saasSubscriptionSuccessRetrieve**
> saasSubscriptionSuccessRetrieve()



Stripe success webhook

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SaasApi();

try {
    api_instance.saasSubscriptionSuccessRetrieve();
} catch (e) {
    print('Exception when calling SaasApi->saasSubscriptionSuccessRetrieve: $e\n');
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

