# ibl_mobile_core_frontend.api.SkillsApi

## Load the API package
```dart
import 'package:ibl_mobile_core_frontend/api.dart';
```

All URIs are relative to *https://base.manager.mentor.iblai.tech*

Method | HTTP request | Description
------------- | ------------- | -------------
[**skillsOrgsSkillsList**](SkillsApi.md#skillsorgsskillslist) | **GET** /api/skills/orgs/{org}/skills | 
[**skillsOrgsSkillsPercentileList**](SkillsApi.md#skillsorgsskillspercentilelist) | **GET** /api/skills/orgs/{org}/skills/percentile/ | 
[**skillsOrgsSkillsPercentileRetrieve**](SkillsApi.md#skillsorgsskillspercentileretrieve) | **GET** /api/skills/orgs/{org}/skills/{skill_id}/percentile/ | 
[**skillsOrgsSkillsRetrieve**](SkillsApi.md#skillsorgsskillsretrieve) | **GET** /api/skills/orgs/{org}/skills/{skill_name}/ | 
[**skillsOrgsSkillsThresholdsCreate**](SkillsApi.md#skillsorgsskillsthresholdscreate) | **POST** /api/skills/orgs/{org}/skills/thresholds/ | 
[**skillsOrgsSkillsThresholdsDestroy**](SkillsApi.md#skillsorgsskillsthresholdsdestroy) | **DELETE** /api/skills/orgs/{org}/skills/thresholds/ | 
[**skillsOrgsSkillsThresholdsPartialUpdate**](SkillsApi.md#skillsorgsskillsthresholdspartialupdate) | **PATCH** /api/skills/orgs/{org}/skills/thresholds/ | 
[**skillsOrgsSkillsThresholdsRetrieve**](SkillsApi.md#skillsorgsskillsthresholdsretrieve) | **GET** /api/skills/orgs/{org}/skills/thresholds/ | 
[**skillsOrgsSkillsUsersDesiredSkillsRetrieve**](SkillsApi.md#skillsorgsskillsusersdesiredskillsretrieve) | **GET** /api/skills/orgs/{org}/skills/users/{user_id}/desired-skills/ | 
[**skillsOrgsSkillsUsersPointPercentileRetrieve**](SkillsApi.md#skillsorgsskillsuserspointpercentileretrieve) | **GET** /api/skills/orgs/{org}/skills/users/{user_id}/point-percentile/ | 
[**skillsOrgsSkillsUsersReportedSkillsRetrieve**](SkillsApi.md#skillsorgsskillsusersreportedskillsretrieve) | **GET** /api/skills/orgs/{org}/skills/users/{user_id}/reported-skills/ | 
[**skillsOrgsSkillsUsersRetrieve**](SkillsApi.md#skillsorgsskillsusersretrieve) | **GET** /api/skills/orgs/{org}/skills/users/{user_id}/ | 


# **skillsOrgsSkillsList**
> List<SkillInfo> skillsOrgsSkillsList(org)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SkillsApi();
final org = org_example; // String | 

try {
    final result = api_instance.skillsOrgsSkillsList(org);
    print(result);
} catch (e) {
    print('Exception when calling SkillsApi->skillsOrgsSkillsList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**List<SkillInfo>**](SkillInfo.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **skillsOrgsSkillsPercentileList**
> List<PointsPercentile> skillsOrgsSkillsPercentileList(org)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SkillsApi();
final org = org_example; // String | 

try {
    final result = api_instance.skillsOrgsSkillsPercentileList(org);
    print(result);
} catch (e) {
    print('Exception when calling SkillsApi->skillsOrgsSkillsPercentileList: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**List<PointsPercentile>**](PointsPercentile.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **skillsOrgsSkillsPercentileRetrieve**
> PointsPercentile skillsOrgsSkillsPercentileRetrieve(org, skillId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SkillsApi();
final org = org_example; // String | 
final skillId = 56; // int | 

try {
    final result = api_instance.skillsOrgsSkillsPercentileRetrieve(org, skillId);
    print(result);
} catch (e) {
    print('Exception when calling SkillsApi->skillsOrgsSkillsPercentileRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **skillId** | **int**|  | 

### Return type

[**PointsPercentile**](PointsPercentile.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **skillsOrgsSkillsRetrieve**
> SkillDetail skillsOrgsSkillsRetrieve(org, skillName)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SkillsApi();
final org = org_example; // String | 
final skillName = skillName_example; // String | 

try {
    final result = api_instance.skillsOrgsSkillsRetrieve(org, skillName);
    print(result);
} catch (e) {
    print('Exception when calling SkillsApi->skillsOrgsSkillsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **skillName** | **String**|  | 

### Return type

[**SkillDetail**](SkillDetail.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **skillsOrgsSkillsThresholdsCreate**
> SkillThreshold skillsOrgsSkillsThresholdsCreate(org, skillThreshold)



### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SkillsApi();
final org = org_example; // String | 
final skillThreshold = SkillThreshold(); // SkillThreshold | 

try {
    final result = api_instance.skillsOrgsSkillsThresholdsCreate(org, skillThreshold);
    print(result);
} catch (e) {
    print('Exception when calling SkillsApi->skillsOrgsSkillsThresholdsCreate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **skillThreshold** | [**SkillThreshold**](SkillThreshold.md)|  | 

### Return type

[**SkillThreshold**](SkillThreshold.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **skillsOrgsSkillsThresholdsDestroy**
> skillsOrgsSkillsThresholdsDestroy(org)



### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SkillsApi();
final org = org_example; // String | 

try {
    api_instance.skillsOrgsSkillsThresholdsDestroy(org);
} catch (e) {
    print('Exception when calling SkillsApi->skillsOrgsSkillsThresholdsDestroy: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **skillsOrgsSkillsThresholdsPartialUpdate**
> SkillThreshold skillsOrgsSkillsThresholdsPartialUpdate(org, patchedSkillThreshold)



### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SkillsApi();
final org = org_example; // String | 
final patchedSkillThreshold = PatchedSkillThreshold(); // PatchedSkillThreshold | 

try {
    final result = api_instance.skillsOrgsSkillsThresholdsPartialUpdate(org, patchedSkillThreshold);
    print(result);
} catch (e) {
    print('Exception when calling SkillsApi->skillsOrgsSkillsThresholdsPartialUpdate: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **patchedSkillThreshold** | [**PatchedSkillThreshold**](PatchedSkillThreshold.md)|  | [optional] 

### Return type

[**SkillThreshold**](SkillThreshold.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json, application/x-www-form-urlencoded, multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **skillsOrgsSkillsThresholdsRetrieve**
> SkillThreshold skillsOrgsSkillsThresholdsRetrieve(org)



### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SkillsApi();
final org = org_example; // String | 

try {
    final result = api_instance.skillsOrgsSkillsThresholdsRetrieve(org);
    print(result);
} catch (e) {
    print('Exception when calling SkillsApi->skillsOrgsSkillsThresholdsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 

### Return type

[**SkillThreshold**](SkillThreshold.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **skillsOrgsSkillsUsersDesiredSkillsRetrieve**
> DesiredSkill skillsOrgsSkillsUsersDesiredSkillsRetrieve(org, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SkillsApi();
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.skillsOrgsSkillsUsersDesiredSkillsRetrieve(org, userId);
    print(result);
} catch (e) {
    print('Exception when calling SkillsApi->skillsOrgsSkillsUsersDesiredSkillsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**DesiredSkill**](DesiredSkill.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **skillsOrgsSkillsUsersPointPercentileRetrieve**
> UserSkillPointsPercentile skillsOrgsSkillsUsersPointPercentileRetrieve(org, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SkillsApi();
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.skillsOrgsSkillsUsersPointPercentileRetrieve(org, userId);
    print(result);
} catch (e) {
    print('Exception when calling SkillsApi->skillsOrgsSkillsUsersPointPercentileRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**UserSkillPointsPercentile**](UserSkillPointsPercentile.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **skillsOrgsSkillsUsersReportedSkillsRetrieve**
> ReportedSkill skillsOrgsSkillsUsersReportedSkillsRetrieve(org, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SkillsApi();
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.skillsOrgsSkillsUsersReportedSkillsRetrieve(org, userId);
    print(result);
} catch (e) {
    print('Exception when calling SkillsApi->skillsOrgsSkillsUsersReportedSkillsRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**ReportedSkill**](ReportedSkill.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **skillsOrgsSkillsUsersRetrieve**
> UserSkill skillsOrgsSkillsUsersRetrieve(org, userId)



Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent

### Example
```dart
import 'package:ibl_mobile_core_frontend/api.dart';

final api_instance = SkillsApi();
final org = org_example; // String | 
final userId = userId_example; // String | 

try {
    final result = api_instance.skillsOrgsSkillsUsersRetrieve(org, userId);
    print(result);
} catch (e) {
    print('Exception when calling SkillsApi->skillsOrgsSkillsUsersRetrieve: $e\n');
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **org** | **String**|  | 
 **userId** | **String**|  | 

### Return type

[**UserSkill**](UserSkill.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

