//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.12

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class CredentialsApi {
  CredentialsApi([ApiClient? apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Endpoint to retrieve the issued credentials for a given tenant
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [int] limit:
  ///   Number of results to return per page.
  ///
  /// * [int] offset:
  ///   The initial index from which to return the results.
  Future<Response> credentialsOrgsAssertionsListWithHttpInfo(String org, { String? format, int? groupId, int? limit, int? offset, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/credentials/orgs/{org}/assertions/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (limit != null) {
      queryParams.addAll(_queryParams('', 'limit', limit));
    }
    if (offset != null) {
      queryParams.addAll(_queryParams('', 'offset', offset));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Endpoint to retrieve the issued credentials for a given tenant
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [int] limit:
  ///   Number of results to return per page.
  ///
  /// * [int] offset:
  ///   The initial index from which to return the results.
  Future<PaginatedAssertionsList?> credentialsOrgsAssertionsList(String org, { String? format, int? groupId, int? limit, int? offset, }) async {
    final response = await credentialsOrgsAssertionsListWithHttpInfo(org,  format: format, groupId: groupId, limit: limit, offset: offset, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PaginatedAssertionsList',) as PaginatedAssertionsList;
    
    }
    return null;
  }

  /// Get all credentials of a given tenant
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> credentialsOrgsAssertionsOverTimeRetrieveWithHttpInfo(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/credentials/orgs/{org}/assertions-over-time/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Get all credentials of a given tenant
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<OverTime?> credentialsOrgsAssertionsOverTimeRetrieve(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await credentialsOrgsAssertionsOverTimeRetrieveWithHttpInfo(org,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'OverTime',) as OverTime;
    
    }
    return null;
  }

  /// Get all credentials of a given tenant
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> credentialsOrgsCourseAssertionsOverTimeRetrieveWithHttpInfo(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/credentials/orgs/{org}/course-assertions-over-time/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Get all credentials of a given tenant
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<OverTime?> credentialsOrgsCourseAssertionsOverTimeRetrieve(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await credentialsOrgsCourseAssertionsOverTimeRetrieveWithHttpInfo(org,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'OverTime',) as OverTime;
    
    }
    return null;
  }

  /// Endpoint to retrieve the credentials of a given tenant
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [int] limit:
  ///   Number of results to return per page.
  ///
  /// * [int] offset:
  ///   The initial index from which to return the results.
  Future<Response> credentialsOrgsCourseCredentialsListWithHttpInfo(String org, { int? limit, int? offset, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/credentials/orgs/{org}/course-credentials/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (limit != null) {
      queryParams.addAll(_queryParams('', 'limit', limit));
    }
    if (offset != null) {
      queryParams.addAll(_queryParams('', 'offset', offset));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Endpoint to retrieve the credentials of a given tenant
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [int] limit:
  ///   Number of results to return per page.
  ///
  /// * [int] offset:
  ///   The initial index from which to return the results.
  Future<void> credentialsOrgsCourseCredentialsList(String org, { int? limit, int? offset, }) async {
    final response = await credentialsOrgsCourseCredentialsListWithHttpInfo(org,  limit: limit, offset: offset, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Get all credentials of a given tenant
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> credentialsOrgsCredentialsOverTimeRetrieveWithHttpInfo(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/credentials/orgs/{org}/credentials-over-time/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Get all credentials of a given tenant
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<OverTime?> credentialsOrgsCredentialsOverTimeRetrieve(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await credentialsOrgsCredentialsOverTimeRetrieveWithHttpInfo(org,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'OverTime',) as OverTime;
    
    }
    return null;
  }

  /// Endpoint to retrieve the credentials of a given tenant
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///
  /// * [String] org (required):
  Future<Response> credentialsOrgsCredentialsRetrieveWithHttpInfo(int id, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/credentials/orgs/{org}/credentials/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Endpoint to retrieve the credentials of a given tenant
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///
  /// * [String] org (required):
  Future<Credential?> credentialsOrgsCredentialsRetrieve(int id, String org,) async {
    final response = await credentialsOrgsCredentialsRetrieveWithHttpInfo(id, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Credential',) as Credential;
    
    }
    return null;
  }

  /// Endpoint to retrieve the credentials of a given tenant
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [int] limit:
  ///   Number of results to return per page.
  ///
  /// * [int] offset:
  ///   The initial index from which to return the results.
  Future<Response> credentialsOrgsListWithHttpInfo(String org, { int? limit, int? offset, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/credentials/orgs/{org}/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (limit != null) {
      queryParams.addAll(_queryParams('', 'limit', limit));
    }
    if (offset != null) {
      queryParams.addAll(_queryParams('', 'offset', offset));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Endpoint to retrieve the credentials of a given tenant
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [int] limit:
  ///   Number of results to return per page.
  ///
  /// * [int] offset:
  ///   The initial index from which to return the results.
  Future<PaginatedCredentialList?> credentialsOrgsList(String org, { int? limit, int? offset, }) async {
    final response = await credentialsOrgsListWithHttpInfo(org,  limit: limit, offset: offset, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PaginatedCredentialList',) as PaginatedCredentialList;
    
    }
    return null;
  }
}
