//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.12

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class EngagementApi {
  EngagementApi([ApiClient? apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Engagement information on a per-course basis
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [int] length:
  ///   Size of data to return
  ///
  /// * [int] page:
  ///   Page offset
  Future<Response> engagementOrgsActivityRetrieveWithHttpInfo(String org, { String? format, int? groupId, int? length, int? page, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/activity'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (length != null) {
      queryParams.addAll(_queryParams('', 'length', length));
    }
    if (page != null) {
      queryParams.addAll(_queryParams('', 'page', page));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Engagement information on a per-course basis
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [int] length:
  ///   Size of data to return
  ///
  /// * [int] page:
  ///   Page offset
  Future<EngagementPerCourse?> engagementOrgsActivityRetrieve(String org, { String? format, int? groupId, int? length, int? page, }) async {
    final response = await engagementOrgsActivityRetrieveWithHttpInfo(org,  format: format, groupId: groupId, length: length, page: page, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'EngagementPerCourse',) as EngagementPerCourse;
    
    }
    return null;
  }

  /// Aggregated table of enrollments,and completed count on a per-course basis
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [int] length:
  ///   Size of data to return
  ///
  /// * [int] page:
  ///   Page offset
  Future<Response> engagementOrgsCourseCompletionPerCourseRetrieveWithHttpInfo(String org, { String? format, int? groupId, int? length, int? page, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/course_completion/per-course'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (length != null) {
      queryParams.addAll(_queryParams('', 'length', length));
    }
    if (page != null) {
      queryParams.addAll(_queryParams('', 'page', page));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Aggregated table of enrollments,and completed count on a per-course basis
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [int] length:
  ///   Size of data to return
  ///
  /// * [int] page:
  ///   Page offset
  Future<CourseCompletionPerCourse?> engagementOrgsCourseCompletionPerCourseRetrieve(String org, { String? format, int? groupId, int? length, int? page, }) async {
    final response = await engagementOrgsCourseCompletionPerCourseRetrieveWithHttpInfo(org,  format: format, groupId: groupId, length: length, page: page, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'CourseCompletionPerCourse',) as CourseCompletionPerCourse;
    
    }
    return null;
  }

  /// Average time spent in secs on a per-day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10 3. course_id <optional>  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> engagementOrgsCoursesTimeAverageRetrieveWithHttpInfo(String courseId, String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/courses/{course_id}/time/average'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Average time spent in secs on a per-day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10 3. course_id <optional>  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<AverageOvertime?> engagementOrgsCoursesTimeAverageRetrieve(String courseId, String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await engagementOrgsCoursesTimeAverageRetrieveWithHttpInfo(courseId, org,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'AverageOvertime',) as AverageOvertime;
    
    }
    return null;
  }

  /// Time spent per course in secs in a tree like form  Kwargs course_id e.g course-v1:Org+Course4+Run  Query Params 1. start_date <optional> e.g 2020-10-01 2. end_date <optional> e.g 2020-10-10
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> engagementOrgsCoursesTimeDetailRetrieveWithHttpInfo(String courseId, String org, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/courses/{course_id}/time/detail'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Time spent per course in secs in a tree like form  Kwargs course_id e.g course-v1:Org+Course4+Run  Query Params 1. start_date <optional> e.g 2020-10-01 2. end_date <optional> e.g 2020-10-10
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<TimeDetail?> engagementOrgsCoursesTimeDetailRetrieve(String courseId, String org, { String? format, int? groupId, }) async {
    final response = await engagementOrgsCoursesTimeDetailRetrieveWithHttpInfo(courseId, org,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'TimeDetail',) as TimeDetail;
    
    }
    return null;
  }

  /// Time spent per course in secs on a per-day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10 Kwargs 3. course_id  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> engagementOrgsCoursesTimeOverTimeRetrieveWithHttpInfo(String courseId, String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/courses/{course_id}/time/over-time'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Time spent per course in secs on a per-day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10 Kwargs 3. course_id  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Overtime?> engagementOrgsCoursesTimeOverTimeRetrieve(String courseId, String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await engagementOrgsCoursesTimeOverTimeRetrieveWithHttpInfo(courseId, org,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Overtime',) as Overtime;
    
    }
    return null;
  }

  /// Time spent within a course in ordered hierarchical format  Kwargs 1. course_id  e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email) Query Params 3. start_date <optional> e.g 2020-10-01 4. end_date <optional> e.g 2020-10-10
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> engagementOrgsCoursesTimeUsersDetailRetrieveWithHttpInfo(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/courses/{course_id}/time/users/{user_id}/detail'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Time spent within a course in ordered hierarchical format  Kwargs 1. course_id  e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email) Query Params 3. start_date <optional> e.g 2020-10-01 4. end_date <optional> e.g 2020-10-10
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<PerLearnerTimeSpentInCourseTree?> engagementOrgsCoursesTimeUsersDetailRetrieve(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await engagementOrgsCoursesTimeUsersDetailRetrieveWithHttpInfo(courseId, org, userId,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PerLearnerTimeSpentInCourseTree',) as PerLearnerTimeSpentInCourseTree;
    
    }
    return null;
  }

  /// Time spent in secs on a per-day basis  Query Params 1. course_id <optional> e.g course-v1:Org+Course4+Run 2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email) 3. start_date e.g 2020-10-01 4. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> engagementOrgsCoursesTimeUsersOverTimeRetrieveWithHttpInfo(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/courses/{course_id}/time/users/{user_id}/over-time'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Time spent in secs on a per-day basis  Query Params 1. course_id <optional> e.g course-v1:Org+Course4+Run 2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email) 3. start_date e.g 2020-10-01 4. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Overtime?> engagementOrgsCoursesTimeUsersOverTimeRetrieve(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await engagementOrgsCoursesTimeUsersOverTimeRetrieveWithHttpInfo(courseId, org, userId,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Overtime',) as Overtime;
    
    }
    return null;
  }

  /// Time spent by users in a course  Query Params course_id  e.g course-v1:Org+Course4+Run
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [int] length:
  ///   Size of data to return
  ///
  /// * [int] page:
  ///   Page offset
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> engagementOrgsCoursesTimeUsersRetrieveWithHttpInfo(String courseId, String org, { String? endDate, String? format, int? groupId, int? length, int? page, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/courses/{course_id}/time/users'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (length != null) {
      queryParams.addAll(_queryParams('', 'length', length));
    }
    if (page != null) {
      queryParams.addAll(_queryParams('', 'page', page));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Time spent by users in a course  Query Params course_id  e.g course-v1:Org+Course4+Run
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [int] length:
  ///   Size of data to return
  ///
  /// * [int] page:
  ///   Page offset
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<TimeSpentByUsersInCourse?> engagementOrgsCoursesTimeUsersRetrieve(String courseId, String org, { String? endDate, String? format, int? groupId, int? length, int? page, String? startDate, }) async {
    final response = await engagementOrgsCoursesTimeUsersRetrieveWithHttpInfo(courseId, org,  endDate: endDate, format: format, groupId: groupId, length: length, page: page, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'TimeSpentByUsersInCourse',) as TimeSpentByUsersInCourse;
    
    }
    return null;
  }

  ///  Watched Videos count on a per-day basis  Kwargs  1. course_id <optional> e.g course-v1:Org+Course4+Run  2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)   Query Params  3. start_date e.g 2020-10-01  4. end_date e.g 2020-10-10   Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> engagementOrgsCoursesVideosOverTimeRetrieveWithHttpInfo(String courseId, String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/courses/{course_id}/videos/over-time'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///  Watched Videos count on a per-day basis  Kwargs  1. course_id <optional> e.g course-v1:Org+Course4+Run  2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)   Query Params  3. start_date e.g 2020-10-01  4. end_date e.g 2020-10-10   Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Overtime?> engagementOrgsCoursesVideosOverTimeRetrieve(String courseId, String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await engagementOrgsCoursesVideosOverTimeRetrieveWithHttpInfo(courseId, org,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Overtime',) as Overtime;
    
    }
    return null;
  }

  /// Engagement information (video) for a specific course
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> engagementOrgsCoursesVideosRetrieveWithHttpInfo(String courseId, String org, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/courses/{course_id}/videos/'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Engagement information (video) for a specific course
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<VideosSpecificCourse?> engagementOrgsCoursesVideosRetrieve(String courseId, String org, { String? format, int? groupId, }) async {
    final response = await engagementOrgsCoursesVideosRetrieveWithHttpInfo(courseId, org,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'VideosSpecificCourse',) as VideosSpecificCourse;
    
    }
    return null;
  }

  /// Returns a Simplified tree structure of videos watched in course Kwargs course_id  e.g course-v1:Org+Course4+Run
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> engagementOrgsCoursesVideosSummaryRetrieveWithHttpInfo(String courseId, String org, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/courses/{course_id}/videos/summary'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Returns a Simplified tree structure of videos watched in course Kwargs course_id  e.g course-v1:Org+Course4+Run
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<VideosInCourseSummary?> engagementOrgsCoursesVideosSummaryRetrieve(String courseId, String org, { String? format, int? groupId, }) async {
    final response = await engagementOrgsCoursesVideosSummaryRetrieveWithHttpInfo(courseId, org,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'VideosInCourseSummary',) as VideosInCourseSummary;
    
    }
    return null;
  }

  /// List of users' videos completed records for a specific course  Kwargs course_id  e.g course-v1:Org+Course4+Run
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> engagementOrgsCoursesVideosUsersRetrieveWithHttpInfo(String courseId, String org, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/courses/{course_id}/videos/users'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// List of users' videos completed records for a specific course  Kwargs course_id  e.g course-v1:Org+Course4+Run
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<WatchedVideosPerUser?> engagementOrgsCoursesVideosUsersRetrieve(String courseId, String org, { String? format, int? groupId, }) async {
    final response = await engagementOrgsCoursesVideosUsersRetrieveWithHttpInfo(courseId, org,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'WatchedVideosPerUser',) as WatchedVideosPerUser;
    
    }
    return null;
  }

  /// Average time spent by a learner in enrolled courses. Gives a rough estimate of whats the average time that would be spent by a learner in a course  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> engagementOrgsTimeAveragePerlearnerPercourseRetrieveWithHttpInfo(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/time/average-perlearner-percourse'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Average time spent by a learner in enrolled courses. Gives a rough estimate of whats the average time that would be spent by a learner in a course  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<AverageOvertime?> engagementOrgsTimeAveragePerlearnerPercourseRetrieve(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await engagementOrgsTimeAveragePerlearnerPercourseRetrieveWithHttpInfo(org,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'AverageOvertime',) as AverageOvertime;
    
    }
    return null;
  }

  /// Average time spent in secs on a per-day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10 3. course_id <optional>  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> engagementOrgsTimeAverageWithOverTimeRetrieveWithHttpInfo(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/time/average-with-over-time'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Average time spent in secs on a per-day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10 3. course_id <optional>  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<AverageOvertime?> engagementOrgsTimeAverageWithOverTimeRetrieve(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await engagementOrgsTimeAverageWithOverTimeRetrieveWithHttpInfo(org,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'AverageOvertime',) as AverageOvertime;
    
    }
    return null;
  }

  /// Time spent in secs on a per-day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> engagementOrgsTimeOverTimeRetrieveWithHttpInfo(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/time/over-time'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Time spent in secs on a per-day basis  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<OvertimeWithChangeInfo?> engagementOrgsTimeOverTimeRetrieve(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await engagementOrgsTimeOverTimeRetrieveWithHttpInfo(org,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'OvertimeWithChangeInfo',) as OvertimeWithChangeInfo;
    
    }
    return null;
  }

  /// Aggregated time spent value on a per course basis
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [int] length:
  ///   Size of data to return
  ///
  /// * [int] page:
  ///   Page offset
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> engagementOrgsTimePerCourseRetrieveWithHttpInfo(String org, { String? endDate, String? format, int? groupId, int? length, int? page, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/time/per-course'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (length != null) {
      queryParams.addAll(_queryParams('', 'length', length));
    }
    if (page != null) {
      queryParams.addAll(_queryParams('', 'page', page));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Aggregated time spent value on a per course basis
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [int] length:
  ///   Size of data to return
  ///
  /// * [int] page:
  ///   Page offset
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<TimeSpentPerCourse?> engagementOrgsTimePerCourseRetrieve(String org, { String? endDate, String? format, int? groupId, int? length, int? page, String? startDate, }) async {
    final response = await engagementOrgsTimePerCourseRetrieveWithHttpInfo(org,  endDate: endDate, format: format, groupId: groupId, length: length, page: page, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'TimeSpentPerCourse',) as TimeSpentPerCourse;
    
    }
    return null;
  }

  ///  Watched Videos count on a per-day basis  Kwargs  1. course_id <optional> e.g course-v1:Org+Course4+Run  2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)   Query Params  3. start_date e.g 2020-10-01  4. end_date e.g 2020-10-10   Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> engagementOrgsVideosOverTimeRetrieveWithHttpInfo(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/videos/over-time'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///  Watched Videos count on a per-day basis  Kwargs  1. course_id <optional> e.g course-v1:Org+Course4+Run  2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)   Query Params  3. start_date e.g 2020-10-01  4. end_date e.g 2020-10-10   Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Overtime?> engagementOrgsVideosOverTimeRetrieve(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await engagementOrgsVideosOverTimeRetrieveWithHttpInfo(org,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Overtime',) as Overtime;
    
    }
    return null;
  }

  /// Video Engagement information on a per-course basis
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [int] length:
  ///   Size of data to return
  ///
  /// * [int] page:
  ///   Page offset
  Future<Response> engagementOrgsVideosRetrieveWithHttpInfo(String org, { String? format, int? groupId, int? length, int? page, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/engagement/orgs/{org}/videos/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (length != null) {
      queryParams.addAll(_queryParams('', 'length', length));
    }
    if (page != null) {
      queryParams.addAll(_queryParams('', 'page', page));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Video Engagement information on a per-course basis
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [int] length:
  ///   Size of data to return
  ///
  /// * [int] page:
  ///   Page offset
  Future<VideoEngagementPerCourse?> engagementOrgsVideosRetrieve(String org, { String? format, int? groupId, int? length, int? page, }) async {
    final response = await engagementOrgsVideosRetrieveWithHttpInfo(org,  format: format, groupId: groupId, length: length, page: page, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'VideoEngagementPerCourse',) as VideoEngagementPerCourse;
    
    }
    return null;
  }
}
