//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.12

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class FinanceApi {
  FinanceApi([ApiClient? apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Return list of WooCommerce orders for product slug over optional date range
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] slug (required):
  ///
  /// * [String] endDate:
  ///   End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
  ///
  /// * [String] startDate:
  ///   Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
  Future<Response> financeOrgsProductsOrdersRetrieveWithHttpInfo(String org, String slug, { String? endDate, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/finance/orgs/{org}/products/{slug}/orders'
      .replaceAll('{org}', org)
      .replaceAll('{slug}', slug);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Return list of WooCommerce orders for product slug over optional date range
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] slug (required):
  ///
  /// * [String] endDate:
  ///   End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
  ///
  /// * [String] startDate:
  ///   Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
  Future<Order?> financeOrgsProductsOrdersRetrieve(String org, String slug, { String? endDate, String? startDate, }) async {
    final response = await financeOrgsProductsOrdersRetrieveWithHttpInfo(org, slug,  endDate: endDate, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Order',) as Order;
    
    }
    return null;
  }

  /// Returns table listing products and product info for all or specific org
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> financeOrgsProductsRetrieveWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/finance/orgs/{org}/products'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Returns table listing products and product info for all or specific org
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Product?> financeOrgsProductsRetrieve(String org,) async {
    final response = await financeOrgsProductsRetrieveWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Product',) as Product;
    
    }
    return null;
  }

  /// Returns Net Revenue over time for org and slug
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] slug (required):
  ///
  /// * [String] endDate:
  ///   End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
  ///
  /// * [String] startDate:
  ///   Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
  Future<Response> financeOrgsProductsSalesOverTimeRetrieveWithHttpInfo(String org, String slug, { String? endDate, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/finance/orgs/{org}/products/{slug}/sales-over-time'
      .replaceAll('{org}', org)
      .replaceAll('{slug}', slug);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Returns Net Revenue over time for org and slug
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] slug (required):
  ///
  /// * [String] endDate:
  ///   End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
  ///
  /// * [String] startDate:
  ///   Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
  Future<NetRevenueOverTime?> financeOrgsProductsSalesOverTimeRetrieve(String org, String slug, { String? endDate, String? startDate, }) async {
    final response = await financeOrgsProductsSalesOverTimeRetrieveWithHttpInfo(org, slug,  endDate: endDate, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'NetRevenueOverTime',) as NetRevenueOverTime;
    
    }
    return null;
  }

  /// Returns Net Revenue over time for org and slug
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
  ///
  /// * [String] startDate:
  ///   Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
  Future<Response> financeOrgsRevenueNetOverTimeRetrieveWithHttpInfo(String org, { String? endDate, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/finance/orgs/{org}/revenue/net-over-time'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Returns Net Revenue over time for org and slug
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
  ///
  /// * [String] startDate:
  ///   Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
  Future<NetRevenueOverTime?> financeOrgsRevenueNetOverTimeRetrieve(String org, { String? endDate, String? startDate, }) async {
    final response = await financeOrgsRevenueNetOverTimeRetrieveWithHttpInfo(org,  endDate: endDate, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'NetRevenueOverTime',) as NetRevenueOverTime;
    
    }
    return null;
  }

  /// Returns Revenue by Product + summary for specific org
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
  ///
  /// * [String] startDate:
  ///   Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
  Future<Response> financeOrgsRevenueProductsRetrieveWithHttpInfo(String org, { String? endDate, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/finance/orgs/{org}/revenue/products'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Returns Revenue by Product + summary for specific org
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   End of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
  ///
  /// * [String] startDate:
  ///   Start of date range, not-inclusive. ISO8601 Date or DateTime. Dates will have 00:00:00 set as the time.
  Future<RevenueByProduct?> financeOrgsRevenueProductsRetrieve(String org, { String? endDate, String? startDate, }) async {
    final response = await financeOrgsRevenueProductsRetrieveWithHttpInfo(org,  endDate: endDate, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'RevenueByProduct',) as RevenueByProduct;
    
    }
    return null;
  }
}
