//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.12

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class PerformanceApi {
  PerformanceApi([ApiClient? apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Average grade value for platform, course, or user.  Query Params course_id <optional>  e.g course-v1:Org+Course4+Run learner_id <optional> e.g std123 , student@email.com
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> performanceOrgsCoursesGradingAverageRetrieveWithHttpInfo(String courseId, String org, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/performance/orgs/{org}/courses/{course_id}/grading/average'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Average grade value for platform, course, or user.  Query Params course_id <optional>  e.g course-v1:Org+Course4+Run learner_id <optional> e.g std123 , student@email.com
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Average?> performanceOrgsCoursesGradingAverageRetrieve(String courseId, String org, { String? format, int? groupId, }) async {
    final response = await performanceOrgsCoursesGradingAverageRetrieveWithHttpInfo(courseId, org,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Average',) as Average;
    
    }
    return null;
  }

  /// Returns average course grade and grade cuttoff  e.g ``` {     \"data\": {         \"grade_cutoffs\": {             \"A\": 90,             \"B\": 80,             \"C\": 70,         },         \"average_grade\": 50.0,     } } ```  Kwargs course_id
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> performanceOrgsCoursesGradingAverageWithCutoffRetrieveWithHttpInfo(String courseId, String org, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/performance/orgs/{org}/courses/{course_id}/grading/average-with-cutoff'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Returns average course grade and grade cuttoff  e.g ``` {     \"data\": {         \"grade_cutoffs\": {             \"A\": 90,             \"B\": 80,             \"C\": 70,         },         \"average_grade\": 50.0,     } } ```  Kwargs course_id
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<AvgCourseGradeWithCutoff?> performanceOrgsCoursesGradingAverageWithCutoffRetrieve(String courseId, String org, { String? format, int? groupId, }) async {
    final response = await performanceOrgsCoursesGradingAverageWithCutoffRetrieveWithHttpInfo(courseId, org,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'AvgCourseGradeWithCutoff',) as AvgCourseGradeWithCutoff;
    
    }
    return null;
  }

  /// Grading summary for the entire course overview in a tree-like format  Kwargs course_id <required>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> performanceOrgsCoursesGradingDetailRetrieveWithHttpInfo(String courseId, String org, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/performance/orgs/{org}/courses/{course_id}/grading/detail'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Grading summary for the entire course overview in a tree-like format  Kwargs course_id <required>
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<CourseGradingDetail?> performanceOrgsCoursesGradingDetailRetrieve(String courseId, String org, { String? format, int? groupId, }) async {
    final response = await performanceOrgsCoursesGradingDetailRetrieveWithHttpInfo(courseId, org,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'CourseGradingDetail',) as CourseGradingDetail;
    
    }
    return null;
  }

  /// Grading information per enrolled user in a course  Kwargs course_id <required>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> performanceOrgsCoursesGradingPerLearnerRetrieveWithHttpInfo(String courseId, String org, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/performance/orgs/{org}/courses/{course_id}/grading/per-learner'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Grading information per enrolled user in a course  Kwargs course_id <required>
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<GradingPerUser?> performanceOrgsCoursesGradingPerLearnerRetrieve(String courseId, String org, { String? format, int? groupId, }) async {
    final response = await performanceOrgsCoursesGradingPerLearnerRetrieveWithHttpInfo(courseId, org,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'GradingPerUser',) as GradingPerUser;
    
    }
    return null;
  }

  /// Returns average grades across various assignment types in a course  Query Params course_id  Returns:     dict     {         \"data\": [             {                 \"assignment_type': <str>,                 \"weight\": <float>,                 \"average_weighted_grade\": <float>,                 \"average_section_grade\": <float>             }, ...         ]     }
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> performanceOrgsCoursesGradingSummaryRetrieveWithHttpInfo(String courseId, String org, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/performance/orgs/{org}/courses/{course_id}/grading/summary'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Returns average grades across various assignment types in a course  Query Params course_id  Returns:     dict     {         \"data\": [             {                 \"assignment_type': <str>,                 \"weight\": <float>,                 \"average_weighted_grade\": <float>,                 \"average_section_grade\": <float>             }, ...         ]     }
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<CourseGradeSummary?> performanceOrgsCoursesGradingSummaryRetrieve(String courseId, String org, { String? format, int? groupId, }) async {
    final response = await performanceOrgsCoursesGradingSummaryRetrieveWithHttpInfo(courseId, org,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'CourseGradeSummary',) as CourseGradeSummary;
    
    }
    return null;
  }

  /// Average grade value for platform, course, or user.  Query Params course_id <optional>  e.g course-v1:Org+Course4+Run learner_id <optional> e.g std123 , student@email.com
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> performanceOrgsGradingAverageRetrieveWithHttpInfo(String org, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/performance/orgs/{org}/grading/average'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Average grade value for platform, course, or user.  Query Params course_id <optional>  e.g course-v1:Org+Course4+Run learner_id <optional> e.g std123 , student@email.com
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Average?> performanceOrgsGradingAverageRetrieve(String org, { String? format, int? groupId, }) async {
    final response = await performanceOrgsGradingAverageRetrieveWithHttpInfo(org,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Average',) as Average;
    
    }
    return null;
  }

  /// Returns grade related performance data per course  Returns:     dict     {         \"data\": [             {                 \"course_id': <str>,                 \"name': <str>,                 \"num_enrollments\": <int>,                 \"num_passed\": <int>,                 \"avg_grade\": <int>             }, ...         ]     }
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [int] length:
  ///   Size of data to return
  ///
  /// * [int] page:
  ///   Page offset
  Future<Response> performanceOrgsGradingPerCourseRetrieveWithHttpInfo(String org, { String? format, int? groupId, int? length, int? page, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/performance/orgs/{org}/grading/per-course'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (length != null) {
      queryParams.addAll(_queryParams('', 'length', length));
    }
    if (page != null) {
      queryParams.addAll(_queryParams('', 'page', page));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Returns grade related performance data per course  Returns:     dict     {         \"data\": [             {                 \"course_id': <str>,                 \"name': <str>,                 \"num_enrollments\": <int>,                 \"num_passed\": <int>,                 \"avg_grade\": <int>             }, ...         ]     }
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [int] length:
  ///   Size of data to return
  ///
  /// * [int] page:
  ///   Page offset
  Future<PerformanceGradesPerCourse?> performanceOrgsGradingPerCourseRetrieve(String org, { String? format, int? groupId, int? length, int? page, }) async {
    final response = await performanceOrgsGradingPerCourseRetrieveWithHttpInfo(org,  format: format, groupId: groupId, length: length, page: page, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PerformanceGradesPerCourse',) as PerformanceGradesPerCourse;
    
    }
    return null;
  }
}
