//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.12

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class PerlearnerApi {
  PerlearnerApi([ApiClient? apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Provides information on user enrollments  Params user_id e.g developer@ibleducation.com| developer
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> perlearnerOrgsUsersActivityRetrieveWithHttpInfo(String org, String userId, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/activity/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Provides information on user enrollments  Params user_id e.g developer@ibleducation.com| developer
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<ActivityAPI?> perlearnerOrgsUsersActivityRetrieve(String org, String userId, { String? format, int? groupId, }) async {
    final response = await perlearnerOrgsUsersActivityRetrieveWithHttpInfo(org, userId,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ActivityAPI',) as ActivityAPI;
    
    }
    return null;
  }

  /// Provides about a learner current grade in a course with the course cut Kwargs 1. course_id e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> perlearnerOrgsUsersCoursesGradingCutoffsRetrieveWithHttpInfo(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/grading/cutoffs'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Provides about a learner current grade in a course with the course cut Kwargs 1. course_id e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<PerlearnerGradeWithCutOff?> perlearnerOrgsUsersCoursesGradingCutoffsRetrieve(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await perlearnerOrgsUsersCoursesGradingCutoffsRetrieveWithHttpInfo(courseId, org, userId,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PerlearnerGradeWithCutOff',) as PerlearnerGradeWithCutOff;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> perlearnerOrgsUsersCoursesGradingDetailRetrieveWithHttpInfo(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/grading/detail'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<DetailedGradeView?> perlearnerOrgsUsersCoursesGradingDetailRetrieve(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await perlearnerOrgsUsersCoursesGradingDetailRetrieveWithHttpInfo(courseId, org, userId,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'DetailedGradeView',) as DetailedGradeView;
    
    }
    return null;
  }

  /// Query Params 1. course_id e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> perlearnerOrgsUsersCoursesGradingSummaryRetrieveWithHttpInfo(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/grading/summary'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Query Params 1. course_id e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<PerlearnerGradeSummary?> perlearnerOrgsUsersCoursesGradingSummaryRetrieve(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await perlearnerOrgsUsersCoursesGradingSummaryRetrieveWithHttpInfo(courseId, org, userId,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PerlearnerGradeSummary',) as PerlearnerGradeSummary;
    
    }
    return null;
  }

  /// Average of days with atleast an activity within ENGAGEMENT_INDEX_PERIOD consecutive days for a learner in a course
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> perlearnerOrgsUsersCoursesOverviewEngagementIndexRetrieveWithHttpInfo(String courseId, String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/overview/engagement-index'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Average of days with atleast an activity within ENGAGEMENT_INDEX_PERIOD consecutive days for a learner in a course
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Value?> perlearnerOrgsUsersCoursesOverviewEngagementIndexRetrieve(String courseId, String org, String userId,) async {
    final response = await perlearnerOrgsUsersCoursesOverviewEngagementIndexRetrieveWithHttpInfo(courseId, org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Value',) as Value;
    
    }
    return null;
  }

  /// Provides about a learner current grade in a course with the course cut Kwargs 1. course_id e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> perlearnerOrgsUsersCoursesOverviewGradeRetrieveWithHttpInfo(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/overview/grade'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Provides about a learner current grade in a course with the course cut Kwargs 1. course_id e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<PerlearnerGradeWithCutOff?> perlearnerOrgsUsersCoursesOverviewGradeRetrieve(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await perlearnerOrgsUsersCoursesOverviewGradeRetrieveWithHttpInfo(courseId, org, userId,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PerlearnerGradeWithCutOff',) as PerlearnerGradeWithCutOff;
    
    }
    return null;
  }

  /// Evaluates performance index for platform, per course, per user and per user-per course  Query Params course_id <optional> learner_id <optional>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> perlearnerOrgsUsersCoursesOverviewPerformanceIndexRetrieveWithHttpInfo(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/overview/performance-index'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Evaluates performance index for platform, per course, per user and per user-per course  Query Params course_id <optional> learner_id <optional>
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Value?> perlearnerOrgsUsersCoursesOverviewPerformanceIndexRetrieve(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await perlearnerOrgsUsersCoursesOverviewPerformanceIndexRetrieveWithHttpInfo(courseId, org, userId,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Value',) as Value;
    
    }
    return null;
  }

  /// Time spent within a course in secs on a per-day basis  Kwargs 1. course_id  e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email) Query Params 3. start_date e.g 2020-10-01 4. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> perlearnerOrgsUsersCoursesOverviewTimeOverTimeRetrieveWithHttpInfo(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/overview/time/over-time'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Time spent within a course in secs on a per-day basis  Kwargs 1. course_id  e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email) Query Params 3. start_date e.g 2020-10-01 4. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Overtime?> perlearnerOrgsUsersCoursesOverviewTimeOverTimeRetrieve(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await perlearnerOrgsUsersCoursesOverviewTimeOverTimeRetrieveWithHttpInfo(courseId, org, userId,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Overtime',) as Overtime;
    
    }
    return null;
  }

  ///  Watched Videos count on a per-day basis  Kwargs  1. course_id <optional> e.g course-v1:Org+Course4+Run  2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)   Query Params  3. start_date e.g 2020-10-01  4. end_date e.g 2020-10-10   Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> perlearnerOrgsUsersCoursesVideosOverTimeRetrieveWithHttpInfo(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/videos/over-time'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///  Watched Videos count on a per-day basis  Kwargs  1. course_id <optional> e.g course-v1:Org+Course4+Run  2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)   Query Params  3. start_date e.g 2020-10-01  4. end_date e.g 2020-10-10   Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Overtime?> perlearnerOrgsUsersCoursesVideosOverTimeRetrieve(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await perlearnerOrgsUsersCoursesVideosOverTimeRetrieveWithHttpInfo(courseId, org, userId,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Overtime',) as Overtime;
    
    }
    return null;
  }

  /// List of videos within a course a learner has watched  Kwargs 1. course_id e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email)  Default result when no query param is added is [], 0
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> perlearnerOrgsUsersCoursesVideosRetrieveWithHttpInfo(String courseId, String org, String userId, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/courses/{course_id}/videos'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// List of videos within a course a learner has watched  Kwargs 1. course_id e.g course-v1:Org+Course4+Run 2. user_id e.g developer@ibleducation.com or dev123 (username|email)  Default result when no query param is added is [], 0
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<PerLearnerCourseVideosWatched?> perlearnerOrgsUsersCoursesVideosRetrieve(String courseId, String org, String userId, { String? format, int? groupId, }) async {
    final response = await perlearnerOrgsUsersCoursesVideosRetrieveWithHttpInfo(courseId, org, userId,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PerLearnerCourseVideosWatched',) as PerLearnerCourseVideosWatched;
    
    }
    return null;
  }

  /// Summary Grading Information for a learner on a per-enrollment basis  Query Params 1. user_id e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> perlearnerOrgsUsersGradesPerCourseRetrieveWithHttpInfo(String org, String userId, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/grades/per-course'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Summary Grading Information for a learner on a per-enrollment basis  Query Params 1. user_id e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<PerlearnerGradingPerCourseAPI?> perlearnerOrgsUsersGradesPerCourseRetrieve(String org, String userId, { String? format, int? groupId, }) async {
    final response = await perlearnerOrgsUsersGradesPerCourseRetrieveWithHttpInfo(org, userId,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PerlearnerGradingPerCourseAPI',) as PerlearnerGradingPerCourseAPI;
    
    }
    return null;
  }

  /// Returns dictionary of user PII
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] meta:
  ///   Include extra analytics information?  * `y` - y * `yes` - yes * `true` - true * `True` - True * `n` - n * `no` - no * `false` - false * `False` - False
  ///
  /// * [String] search:
  Future<Response> perlearnerOrgsUsersInfoRetrieveWithHttpInfo(String org, String userId, { String? format, int? groupId, String? meta, String? search, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/info'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (meta != null) {
      queryParams.addAll(_queryParams('', 'meta', meta));
    }
    if (search != null) {
      queryParams.addAll(_queryParams('', 'search', search));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Returns dictionary of user PII
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] meta:
  ///   Include extra analytics information?  * `y` - y * `yes` - yes * `true` - true * `True` - True * `n` - n * `no` - no * `false` - false * `False` - False
  ///
  /// * [String] search:
  Future<LearnerInformationAPI?> perlearnerOrgsUsersInfoRetrieve(String org, String userId, { String? format, int? groupId, String? meta, String? search, }) async {
    final response = await perlearnerOrgsUsersInfoRetrieveWithHttpInfo(org, userId,  format: format, groupId: groupId, meta: meta, search: search, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'LearnerInformationAPI',) as LearnerInformationAPI;
    
    }
    return null;
  }

  /// Last course accessed by a learner, includes upto unit information as well
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> perlearnerOrgsUsersLastAccessRetrieveWithHttpInfo(String org, String userId, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/last-access'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Last course accessed by a learner, includes upto unit information as well
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<PerLearnerLastAccess?> perlearnerOrgsUsersLastAccessRetrieve(String org, String userId, { String? format, int? groupId, }) async {
    final response = await perlearnerOrgsUsersLastAccessRetrieveWithHttpInfo(org, userId,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PerLearnerLastAccess',) as PerLearnerLastAccess;
    
    }
    return null;
  }

  /// Average of days with atleast an activity within ENGAGEMENT_INDEX_PERIOD consecutive days
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> perlearnerOrgsUsersOverviewEngagementIndexRetrieveWithHttpInfo(String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/overview/engagement-index'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Average of days with atleast an activity within ENGAGEMENT_INDEX_PERIOD consecutive days
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Value?> perlearnerOrgsUsersOverviewEngagementIndexRetrieve(String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await perlearnerOrgsUsersOverviewEngagementIndexRetrieveWithHttpInfo(org, userId,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Value',) as Value;
    
    }
    return null;
  }

  /// Average grade value for platform, course, or user.  Query Params course_id <optional>  e.g course-v1:Org+Course4+Run learner_id <optional> e.g std123 , student@email.com
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> perlearnerOrgsUsersOverviewGradesAverageRetrieveWithHttpInfo(String org, String userId, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/overview/grades/average'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Average grade value for platform, course, or user.  Query Params course_id <optional>  e.g course-v1:Org+Course4+Run learner_id <optional> e.g std123 , student@email.com
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Average?> perlearnerOrgsUsersOverviewGradesAverageRetrieve(String org, String userId, { String? format, int? groupId, }) async {
    final response = await perlearnerOrgsUsersOverviewGradesAverageRetrieveWithHttpInfo(org, userId,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Average',) as Average;
    
    }
    return null;
  }

  /// Evaluates performance index for platform, per course, per user and per user-per course  Query Params course_id <optional> learner_id <optional>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> perlearnerOrgsUsersOverviewPerformanceIndexRetrieveWithHttpInfo(String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/overview/performance-index'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Evaluates performance index for platform, per course, per user and per user-per course  Query Params course_id <optional> learner_id <optional>
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Value?> perlearnerOrgsUsersOverviewPerformanceIndexRetrieve(String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await perlearnerOrgsUsersOverviewPerformanceIndexRetrieveWithHttpInfo(org, userId,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Value',) as Value;
    
    }
    return null;
  }

  /// Time spent in secs on a per-day basis  Query Params 1. course_id <optional> e.g course-v1:Org+Course4+Run 2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email) 3. start_date e.g 2020-10-01 4. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> perlearnerOrgsUsersOverviewTimeOverTimeRetrieveWithHttpInfo(String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/overview/time/over-time'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Time spent in secs on a per-day basis  Query Params 1. course_id <optional> e.g course-v1:Org+Course4+Run 2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email) 3. start_date e.g 2020-10-01 4. end_date e.g 2020-10-10  Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Overtime?> perlearnerOrgsUsersOverviewTimeOverTimeRetrieve(String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await perlearnerOrgsUsersOverviewTimeOverTimeRetrieveWithHttpInfo(org, userId,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Overtime',) as Overtime;
    
    }
    return null;
  }

  /// List of entire learners on the platform with aggregated enrollments, completions and time spent
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [int] length:
  ///   Size of data to return
  ///
  /// * [int] page:
  ///   Page offset
  ///
  /// * [String] search:
  ///   Search string for learner
  Future<Response> perlearnerOrgsUsersRetrieveWithHttpInfo(String org, { String? format, int? groupId, int? length, int? page, String? search, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (length != null) {
      queryParams.addAll(_queryParams('', 'length', length));
    }
    if (page != null) {
      queryParams.addAll(_queryParams('', 'page', page));
    }
    if (search != null) {
      queryParams.addAll(_queryParams('', 'search', search));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// List of entire learners on the platform with aggregated enrollments, completions and time spent
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [int] length:
  ///   Size of data to return
  ///
  /// * [int] page:
  ///   Page offset
  ///
  /// * [String] search:
  ///   Search string for learner
  Future<PerlearnerUserList?> perlearnerOrgsUsersRetrieve(String org, { String? format, int? groupId, int? length, int? page, String? search, }) async {
    final response = await perlearnerOrgsUsersRetrieveWithHttpInfo(org,  format: format, groupId: groupId, length: length, page: page, search: search, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PerlearnerUserList',) as PerlearnerUserList;
    
    }
    return null;
  }

  ///  Watched Videos count on a per-day basis  Kwargs  1. course_id <optional> e.g course-v1:Org+Course4+Run  2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)   Query Params  3. start_date e.g 2020-10-01  4. end_date e.g 2020-10-10   Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> perlearnerOrgsUsersVideosOverTimeRetrieveWithHttpInfo(String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/videos/over-time'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///  Watched Videos count on a per-day basis  Kwargs  1. course_id <optional> e.g course-v1:Org+Course4+Run  2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)   Query Params  3. start_date e.g 2020-10-01  4. end_date e.g 2020-10-10   Default result when no query param is added is last_7_days (today inclusive)
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Overtime?> perlearnerOrgsUsersVideosOverTimeRetrieve(String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await perlearnerOrgsUsersVideosOverTimeRetrieveWithHttpInfo(org, userId,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Overtime',) as Overtime;
    
    }
    return null;
  }

  /// Summary Videos watched data for a learner per enrollment  Query Params 1. user_id e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> perlearnerOrgsUsersVideosPerCourseRetrieveWithHttpInfo(String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/perlearner/orgs/{org}/users/{user_id}/videos/per-course'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Summary Videos watched data for a learner per enrollment  Query Params 1. user_id e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<PerlearnerEngagementVideosWatchedPerCourse?> perlearnerOrgsUsersVideosPerCourseRetrieve(String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await perlearnerOrgsUsersVideosPerCourseRetrieveWithHttpInfo(org, userId,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PerlearnerEngagementVideosWatchedPerCourse',) as PerlearnerEngagementVideosWatchedPerCourse;
    
    }
    return null;
  }
}
