//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.12

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class PlatformApi {
  PlatformApi([ApiClient? apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Total courses on the platform
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> platformOrgsCoursesCountRetrieveWithHttpInfo(String org, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/courses/count'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Total courses on the platform
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Count?> platformOrgsCoursesCountRetrieve(String org, { String? format, int? groupId, }) async {
    final response = await platformOrgsCoursesCountRetrieveWithHttpInfo(org,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Count',) as Count;
    
    }
    return null;
  }

  /// Grading information on a per course basis
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> platformOrgsCoursesGradesRetrieveWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/courses/grades'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Grading information on a per course basis
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<void> platformOrgsCoursesGradesRetrieve(String org,) async {
    final response = await platformOrgsCoursesGradesRetrieveWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Average days used to complete a course  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  Future<Response> platformOrgsCoursesProgressAverageDaysToCompleteRetrieveWithHttpInfo(String courseId, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/courses/{course_id}/progress/average-days-to-complete'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Average days used to complete a course  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  Future<void> platformOrgsCoursesProgressAverageDaysToCompleteRetrieve(String courseId, String org,) async {
    final response = await platformOrgsCoursesProgressAverageDaysToCompleteRetrieveWithHttpInfo(courseId, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Average time used to complete a course in secs  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  Future<Response> platformOrgsCoursesProgressAverageTimeToCompleteRetrieveWithHttpInfo(String courseId, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/courses/{course_id}/progress/average-time-to-complete'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Average time used to complete a course in secs  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  Future<void> platformOrgsCoursesProgressAverageTimeToCompleteRetrieve(String courseId, String org,) async {
    final response = await platformOrgsCoursesProgressAverageTimeToCompleteRetrieveWithHttpInfo(courseId, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// For platform :  Total users who have completed atleast a course on the platform For course : Total completions in course For learner : Total completed courses  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  Future<Response> platformOrgsCoursesProgressCompletedRetrieveWithHttpInfo(String courseId, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/courses/{course_id}/progress/completed'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// For platform :  Total users who have completed atleast a course on the platform For course : Total completions in course For learner : Total completed courses  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  Future<void> platformOrgsCoursesProgressCompletedRetrieve(String courseId, String org,) async {
    final response = await platformOrgsCoursesProgressCompletedRetrieveWithHttpInfo(courseId, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Average of total completed units
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  Future<Response> platformOrgsCoursesProgressCompletionRateRetrieveWithHttpInfo(String courseId, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/courses/{course_id}/progress/completion-rate'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Average of total completed units
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  Future<void> platformOrgsCoursesProgressCompletionRateRetrieve(String courseId, String org,) async {
    final response = await platformOrgsCoursesProgressCompletionRateRetrieveWithHttpInfo(courseId, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// In Progress means any unit completion in the past 30 days  For platform :  Total users who have atleast a course in_progress on the platform For course : Total users For learner : Total courses in progress  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  Future<Response> platformOrgsCoursesProgressInProgressRetrieveWithHttpInfo(String courseId, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/courses/{course_id}/progress/in-progress'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// In Progress means any unit completion in the past 30 days  For platform :  Total users who have atleast a course in_progress on the platform For course : Total users For learner : Total courses in progress  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  Future<void> platformOrgsCoursesProgressInProgressRetrieve(String courseId, String org,) async {
    final response = await platformOrgsCoursesProgressInProgressRetrieveWithHttpInfo(courseId, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Completion information per enrolled user  Gives Percentage of units completed in course  Query Params course_id <required> user_id <optional>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  Future<Response> platformOrgsCoursesProgressRetrieveWithHttpInfo(String courseId, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/courses/{course_id}/progress/'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Completion information per enrolled user  Gives Percentage of units completed in course  Query Params course_id <required> user_id <optional>
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  Future<void> platformOrgsCoursesProgressRetrieve(String courseId, String org,) async {
    final response = await platformOrgsCoursesProgressRetrieveWithHttpInfo(courseId, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Started means an enrollment  For platform :  Total users who have atleast an enrollment For course : Total users enrolled For learner : Total courses in progress  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  Future<Response> platformOrgsCoursesProgressStartedRetrieveWithHttpInfo(String courseId, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/courses/{course_id}/progress/started'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Started means an enrollment  For platform :  Total users who have atleast an enrollment For course : Total users enrolled For learner : Total courses in progress  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  Future<void> platformOrgsCoursesProgressStartedRetrieve(String courseId, String org,) async {
    final response = await platformOrgsCoursesProgressStartedRetrieveWithHttpInfo(courseId, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// A GET View that validates QueryParams and returns results to a serializer
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> platformOrgsCoursesUsersGradesPassedRetrieveWithHttpInfo(String courseId, String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/courses/{course_id}/users/{user_id}/grades/passed'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// A GET View that validates QueryParams and returns results to a serializer
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<void> platformOrgsCoursesUsersGradesPassedRetrieve(String courseId, String org, String userId,) async {
    final response = await platformOrgsCoursesUsersGradesPassedRetrieveWithHttpInfo(courseId, org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Average days used to complete a course  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> platformOrgsCoursesUsersProgressDaysToCompleteRetrieveWithHttpInfo(String courseId, String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/courses/{course_id}/users/{user_id}/progress/days-to-complete'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Average days used to complete a course  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<void> platformOrgsCoursesUsersProgressDaysToCompleteRetrieve(String courseId, String org, String userId,) async {
    final response = await platformOrgsCoursesUsersProgressDaysToCompleteRetrieveWithHttpInfo(courseId, org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Gives Percentage of units completed in course for a specific learner
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> platformOrgsCoursesUsersProgressRetrieveWithHttpInfo(String courseId, String org, String userId, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/courses/{course_id}/users/{user_id}/progress'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Gives Percentage of units completed in course for a specific learner
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<PerlearnerCourseProgress?> platformOrgsCoursesUsersProgressRetrieve(String courseId, String org, String userId, { String? format, int? groupId, }) async {
    final response = await platformOrgsCoursesUsersProgressRetrieveWithHttpInfo(courseId, org, userId,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PerlearnerCourseProgress',) as PerlearnerCourseProgress;
    
    }
    return null;
  }

  /// Time spent count in seconds within a course by a learner
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> platformOrgsCoursesUsersTimeCountRetrieveWithHttpInfo(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/courses/{course_id}/users/{user_id}/time/count'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Time spent count in seconds within a course by a learner
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Count?> platformOrgsCoursesUsersTimeCountRetrieve(String courseId, String org, String userId, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await platformOrgsCoursesUsersTimeCountRetrieveWithHttpInfo(courseId, org, userId,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Count',) as Count;
    
    }
    return null;
  }

  /// Total videos watched / Total Course Videos
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> platformOrgsCoursesUsersVideosCountRetrieveWithHttpInfo(String courseId, String org, String userId, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/courses/{course_id}/users/{user_id}/videos/count'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Total videos watched / Total Course Videos
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<VideosCount?> platformOrgsCoursesUsersVideosCountRetrieve(String courseId, String org, String userId, { String? format, int? groupId, }) async {
    final response = await platformOrgsCoursesUsersVideosCountRetrieveWithHttpInfo(courseId, org, userId,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'VideosCount',) as VideosCount;
    
    }
    return null;
  }

  /// Aggregated count of video plays on a per-course basis
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<Response> platformOrgsCoursesVideosRetrieveWithHttpInfo(String org, { String? format, int? groupId, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/courses/videos'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Aggregated count of video plays on a per-course basis
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  Future<WatchedVideosPerCourse?> platformOrgsCoursesVideosRetrieve(String org, { String? format, int? groupId, }) async {
    final response = await platformOrgsCoursesVideosRetrieveWithHttpInfo(org,  format: format, groupId: groupId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'WatchedVideosPerCourse',) as WatchedVideosPerCourse;
    
    }
    return null;
  }

  /// Count of total videos in a course  Query Params course_id  e.g course-v1:Org+Course4+Run
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  Future<Response> platformOrgsCoursesVideosRetrieve2WithHttpInfo(String courseId, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/courses/{course_id}/videos/'
      .replaceAll('{course_id}', courseId)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Count of total videos in a course  Query Params course_id  e.g course-v1:Org+Course4+Run
  ///
  /// Parameters:
  ///
  /// * [String] courseId (required):
  ///
  /// * [String] org (required):
  Future<void> platformOrgsCoursesVideosRetrieve2(String courseId, String org,) async {
    final response = await platformOrgsCoursesVideosRetrieve2WithHttpInfo(courseId, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// For platform :  Total users who have completed atleast a course on the platform For course : Total completions in course For learner : Total completed courses  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> platformOrgsProgressCompletedRetrieveWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/progress/completed'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// For platform :  Total users who have completed atleast a course on the platform For course : Total completions in course For learner : Total completed courses  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<void> platformOrgsProgressCompletedRetrieve(String org,) async {
    final response = await platformOrgsProgressCompletedRetrieveWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Average of total completed units
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> platformOrgsProgressCompletionRateRetrieveWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/progress/completion-rate'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Average of total completed units
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<void> platformOrgsProgressCompletionRateRetrieve(String org,) async {
    final response = await platformOrgsProgressCompletionRateRetrieveWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// In Progress means any unit completion in the past 30 days  For platform :  Total users who have atleast a course in_progress on the platform For course : Total users For learner : Total courses in progress  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> platformOrgsProgressInProgressRetrieveWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/progress/in-progress'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// In Progress means any unit completion in the past 30 days  For platform :  Total users who have atleast a course in_progress on the platform For course : Total users For learner : Total courses in progress  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<void> platformOrgsProgressInProgressRetrieve(String org,) async {
    final response = await platformOrgsProgressInProgressRetrieveWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Started means an enrollment  For platform :  Total users who have atleast an enrollment For course : Total users enrolled For learner : Total courses in progress  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> platformOrgsProgressStartedRetrieveWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/progress/started'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Started means an enrollment  For platform :  Total users who have atleast an enrollment For course : Total users enrolled For learner : Total courses in progress  Query Params     1. course_id <optional> e.g course-v1:Org+Course4+Run     2. user_id <optional> e.g developer@ibleducation.com or dev123 (username|email)
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<void> platformOrgsProgressStartedRetrieve(String org,) async {
    final response = await platformOrgsProgressStartedRetrieveWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Learners list with email name and date_joined
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> platformOrgsRetrieveWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Learners list with email name and date_joined
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<void> platformOrgsRetrieve(String org,) async {
    final response = await platformOrgsRetrieveWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Total time spent count on the platform within specified range or all time  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default result is all time
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> platformOrgsTimeCountRetrieveWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/time/count'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Total time spent count on the platform within specified range or all time  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default result is all time
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<void> platformOrgsTimeCountRetrieve(String org,) async {
    final response = await platformOrgsTimeCountRetrieveWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Count of users with activity on the platform within specified range or all time  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default is all time
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> platformOrgsUsersActiveCountRetrieveWithHttpInfo(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/users/active/count'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Count of users with activity on the platform within specified range or all time  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default is all time
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Overtime?> platformOrgsUsersActiveCountRetrieve(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await platformOrgsUsersActiveCountRetrieveWithHttpInfo(org,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Overtime',) as Overtime;
    
    }
    return null;
  }

  /// Count of users enrolled on the platform within specified range or all time  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default is all time
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> platformOrgsUsersCountRetrieveWithHttpInfo(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/users/count'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Count of users enrolled on the platform within specified range or all time  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default is all time
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Overtime?> platformOrgsUsersCountRetrieve(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await platformOrgsUsersCountRetrieveWithHttpInfo(org,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Overtime',) as Overtime;
    
    }
    return null;
  }

  /// Count of users who have completed a course on the platform within specified range or all time  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default is all time
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Response> platformOrgsUsersCoursesCompletedCountRetrieveWithHttpInfo(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/platform/orgs/{org}/users/courses-completed/count'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (endDate != null) {
      queryParams.addAll(_queryParams('', 'end_date', endDate));
    }
    if (format != null) {
      queryParams.addAll(_queryParams('', 'format', format));
    }
    if (groupId != null) {
      queryParams.addAll(_queryParams('', 'group_id', groupId));
    }
    if (startDate != null) {
      queryParams.addAll(_queryParams('', 'start_date', startDate));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Count of users who have completed a course on the platform within specified range or all time  Query Params 1. start_date e.g 2020-10-01 2. end_date e.g 2020-10-10  Default is all time
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] endDate:
  ///   end date. ISO 8601
  ///
  /// * [String] format:
  ///   Format  * `json` - json
  ///
  /// * [int] groupId:
  ///   Cohort Group ID
  ///
  /// * [String] startDate:
  ///   start date. ISO 8601
  Future<Overtime?> platformOrgsUsersCoursesCompletedCountRetrieve(String org, { String? endDate, String? format, int? groupId, String? startDate, }) async {
    final response = await platformOrgsUsersCoursesCompletedCountRetrieveWithHttpInfo(org,  endDate: endDate, format: format, groupId: groupId, startDate: startDate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Overtime',) as Overtime;
    
    }
    return null;
  }
}
