//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.12

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class ReportsApi {
  ReportsApi([ApiClient? apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Returns list of report available in the system to download.     `extra_query_params` defines additional query params that can be passed to the report create body If the report has been previously requested, it returns the status of the report
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> reportsOrgsListWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/reports/orgs/{org}/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Returns list of report available in the system to download.     `extra_query_params` defines additional query params that can be passed to the report create body If the report has been previously requested, it returns the status of the report
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<List<ReportList>?> reportsOrgsList(String org,) async {
    final response = await reportsOrgsListWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(responseBody, 'List<ReportList>') as List)
        .cast<ReportList>()
        .toList(growable: false);

    }
    return null;
  }

  /// Triggers a new report generation.  If the report has been previously requested, it returns the status of the report  The current duration for generated report `{settings.REPORT_EXPIRY_SECONDS/3600}` hours.  Given a sample result of the api call  ```json     [       {         \"data\": [           {             \"display_name\": \"User Report 1\",             \"description\": \"A short Description of Report 1\",             \"report_name\": \"report-1\",             \"icon\": \"http://some-icon.png\",             \"extra_query_params\": [               \"course_id\", \"learner_id\"             ],             \"status\": {}           }         ]       }     ] ```  The body of the request would be ```json     {         \"report_name\": \"report-1\",         \"owner\": \"owner-name\"         \"learner_id\": \"learner-id\",         \"course_id\": \"course-id\",     } ```
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [ReportRequest] reportRequest (required):
  Future<Response> reportsOrgsNewCreateWithHttpInfo(String org, ReportRequest reportRequest,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/reports/orgs/{org}/new'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = reportRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Triggers a new report generation.  If the report has been previously requested, it returns the status of the report  The current duration for generated report `{settings.REPORT_EXPIRY_SECONDS/3600}` hours.  Given a sample result of the api call  ```json     [       {         \"data\": [           {             \"display_name\": \"User Report 1\",             \"description\": \"A short Description of Report 1\",             \"report_name\": \"report-1\",             \"icon\": \"http://some-icon.png\",             \"extra_query_params\": [               \"course_id\", \"learner_id\"             ],             \"status\": {}           }         ]       }     ] ```  The body of the request would be ```json     {         \"report_name\": \"report-1\",         \"owner\": \"owner-name\"         \"learner_id\": \"learner-id\",         \"course_id\": \"course-id\",     } ```
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [ReportRequest] reportRequest (required):
  Future<ReportCreate?> reportsOrgsNewCreate(String org, ReportRequest reportRequest,) async {
    final response = await reportsOrgsNewCreateWithHttpInfo(org, reportRequest,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ReportCreate',) as ReportCreate;
    
    }
    return null;
  }
}
