//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.12

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;

class UserSkill {
  /// Returns a new [UserSkill] instance.
  UserSkill({
    required this.skill,
    this.courses = const [],
    this.resources = const [],
    required this.totalPoints,
    this.percentile,
  });

  Skill skill;

  /// Courses with skill and associated points
  List<CoursePoint> courses;

  /// Resources with skill and associated points
  List<ResourcePoint> resources;

  /// Total points for skill
  int totalPoints;

  /// Percentile of points for user.
  ///
  /// Please note: This property should have been non-nullable! Since the specification file
  /// does not include a default value (using the "default:" property), however, the generated
  /// source code must fall back to having a nullable type.
  /// Consider adding a "default:" property in the specification file to hide this note.
  ///
  double? percentile;

  @override
  bool operator ==(Object other) => identical(this, other) || other is UserSkill &&
    other.skill == skill &&
    _deepEquality.equals(other.courses, courses) &&
    _deepEquality.equals(other.resources, resources) &&
    other.totalPoints == totalPoints &&
    other.percentile == percentile;

  @override
  int get hashCode =>
    // ignore: unnecessary_parenthesis
    (skill.hashCode) +
    (courses.hashCode) +
    (resources.hashCode) +
    (totalPoints.hashCode) +
    (percentile == null ? 0 : percentile!.hashCode);

  @override
  String toString() => 'UserSkill[skill=$skill, courses=$courses, resources=$resources, totalPoints=$totalPoints, percentile=$percentile]';

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
      json[r'skill'] = this.skill;
      json[r'courses'] = this.courses;
      json[r'resources'] = this.resources;
      json[r'total_points'] = this.totalPoints;
    if (this.percentile != null) {
      json[r'percentile'] = this.percentile;
    } else {
      json[r'percentile'] = null;
    }
    return json;
  }

  /// Returns a new [UserSkill] instance and imports its values from
  /// [value] if it's a [Map], null otherwise.
  // ignore: prefer_constructors_over_static_methods
  static UserSkill? fromJson(dynamic value) {
    if (value is Map) {
      final json = value.cast<String, dynamic>();

      // Ensure that the map contains the required keys.
      // Note 1: the values aren't checked for validity beyond being non-null.
      // Note 2: this code is stripped in release mode!
      assert(() {
        requiredKeys.forEach((key) {
          assert(json.containsKey(key), 'Required key "UserSkill[$key]" is missing from JSON.');
          assert(json[key] != null, 'Required key "UserSkill[$key]" has a null value in JSON.');
        });
        return true;
      }());

      return UserSkill(
        skill: Skill.fromJson(json[r'skill'])!,
        courses: CoursePoint.listFromJson(json[r'courses']),
        resources: ResourcePoint.listFromJson(json[r'resources']),
        totalPoints: mapValueOfType<int>(json, r'total_points')!,
        percentile: mapValueOfType<double>(json, r'percentile'),
      );
    }
    return null;
  }

  static List<UserSkill> listFromJson(dynamic json, {bool growable = false,}) {
    final result = <UserSkill>[];
    if (json is List && json.isNotEmpty) {
      for (final row in json) {
        final value = UserSkill.fromJson(row);
        if (value != null) {
          result.add(value);
        }
      }
    }
    return result.toList(growable: growable);
  }

  static Map<String, UserSkill> mapFromJson(dynamic json) {
    final map = <String, UserSkill>{};
    if (json is Map && json.isNotEmpty) {
      json = json.cast<String, dynamic>(); // ignore: parameter_assignments
      for (final entry in json.entries) {
        final value = UserSkill.fromJson(entry.value);
        if (value != null) {
          map[entry.key] = value;
        }
      }
    }
    return map;
  }

  // maps a json object with a list of UserSkill-objects as value to a dart map
  static Map<String, List<UserSkill>> mapListFromJson(dynamic json, {bool growable = false,}) {
    final map = <String, List<UserSkill>>{};
    if (json is Map && json.isNotEmpty) {
      // ignore: parameter_assignments
      json = json.cast<String, dynamic>();
      for (final entry in json.entries) {
        map[entry.key] = UserSkill.listFromJson(entry.value, growable: growable,);
      }
    }
    return map;
  }

  /// The list of required keys that must be present in a JSON.
  static const requiredKeys = <String>{
    'skill',
    'courses',
    'resources',
    'total_points',
  };
}

