//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.12

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class AiApi {
  AiApi([ApiClient? apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// API View to manage LLM credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [LLMCredential] lLMCredential (required):
  Future<Response> aiAccountOrgsCredentialCreateWithHttpInfo(String org, LLMCredential lLMCredential,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/account/orgs/{org}/credential/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = lLMCredential;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// API View to manage LLM credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [LLMCredential] lLMCredential (required):
  Future<LLMCredential?> aiAccountOrgsCredentialCreate(String org, LLMCredential lLMCredential,) async {
    final response = await aiAccountOrgsCredentialCreateWithHttpInfo(org, lLMCredential,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'LLMCredential',) as LLMCredential;
    
    }
    return null;
  }

  /// API View to manage LLM credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [PatchedLLMCredential] patchedLLMCredential:
  Future<Response> aiAccountOrgsCredentialPartialUpdateWithHttpInfo(String org, { PatchedLLMCredential? patchedLLMCredential, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/account/orgs/{org}/credential/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = patchedLLMCredential;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// API View to manage LLM credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [PatchedLLMCredential] patchedLLMCredential:
  Future<LLMCredential?> aiAccountOrgsCredentialPartialUpdate(String org, { PatchedLLMCredential? patchedLLMCredential, }) async {
    final response = await aiAccountOrgsCredentialPartialUpdateWithHttpInfo(org,  patchedLLMCredential: patchedLLMCredential, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'LLMCredential',) as LLMCredential;
    
    }
    return null;
  }

  /// API View to manage LLM credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> aiAccountOrgsCredentialRetrieveWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/account/orgs/{org}/credential/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// API View to manage LLM credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<LLMCredential?> aiAccountOrgsCredentialRetrieve(String org,) async {
    final response = await aiAccountOrgsCredentialRetrieveWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'LLMCredential',) as LLMCredential;
    
    }
    return null;
  }

  /// API View to manage Integration credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [IntegrationCredential] integrationCredential (required):
  Future<Response> aiAccountOrgsIntegrationCredentialCreateWithHttpInfo(String org, IntegrationCredential integrationCredential,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/account/orgs/{org}/integration-credential/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = integrationCredential;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// API View to manage Integration credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [IntegrationCredential] integrationCredential (required):
  Future<IntegrationCredential?> aiAccountOrgsIntegrationCredentialCreate(String org, IntegrationCredential integrationCredential,) async {
    final response = await aiAccountOrgsIntegrationCredentialCreateWithHttpInfo(org, integrationCredential,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'IntegrationCredential',) as IntegrationCredential;
    
    }
    return null;
  }

  /// API View to manage Integration credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [PatchedIntegrationCredential] patchedIntegrationCredential:
  Future<Response> aiAccountOrgsIntegrationCredentialPartialUpdateWithHttpInfo(String org, { PatchedIntegrationCredential? patchedIntegrationCredential, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/account/orgs/{org}/integration-credential/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = patchedIntegrationCredential;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// API View to manage Integration credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [PatchedIntegrationCredential] patchedIntegrationCredential:
  Future<IntegrationCredential?> aiAccountOrgsIntegrationCredentialPartialUpdate(String org, { PatchedIntegrationCredential? patchedIntegrationCredential, }) async {
    final response = await aiAccountOrgsIntegrationCredentialPartialUpdateWithHttpInfo(org,  patchedIntegrationCredential: patchedIntegrationCredential, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'IntegrationCredential',) as IntegrationCredential;
    
    }
    return null;
  }

  /// API View to manage Integration credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> aiAccountOrgsIntegrationCredentialRetrieveWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/account/orgs/{org}/integration-credential/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// API View to manage Integration credentials.  Sample for `value` field : `{\"key\": \"sk-31343432432434324324324324\"}`
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<IntegrationCredential?> aiAccountOrgsIntegrationCredentialRetrieve(String org,) async {
    final response = await aiAccountOrgsIntegrationCredentialRetrieveWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'IntegrationCredential',) as IntegrationCredential;
    
    }
    return null;
  }

  /// In order to use google as your LLM provider, you need to specify `google_project` (your google cloud project id) and `google_location`, which defaults to `us-central1`
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [IBLAIPlatformMeta] iBLAIPlatformMeta:
  Future<Response> aiAccountOrgsPlatformMetadataCreateWithHttpInfo(String org, { IBLAIPlatformMeta? iBLAIPlatformMeta, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/account/orgs/{org}/platform-metadata/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = iBLAIPlatformMeta;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// In order to use google as your LLM provider, you need to specify `google_project` (your google cloud project id) and `google_location`, which defaults to `us-central1`
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [IBLAIPlatformMeta] iBLAIPlatformMeta:
  Future<IBLAIPlatformMeta?> aiAccountOrgsPlatformMetadataCreate(String org, { IBLAIPlatformMeta? iBLAIPlatformMeta, }) async {
    final response = await aiAccountOrgsPlatformMetadataCreateWithHttpInfo(org,  iBLAIPlatformMeta: iBLAIPlatformMeta, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'IBLAIPlatformMeta',) as IBLAIPlatformMeta;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> aiAccountOrgsPlatformMetadataRetrieveWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/account/orgs/{org}/platform-metadata/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<IBLAIPlatformMeta?> aiAccountOrgsPlatformMetadataRetrieve(String org,) async {
    final response = await aiAccountOrgsPlatformMetadataRetrieveWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'IBLAIPlatformMeta',) as IBLAIPlatformMeta;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [IBLAIPlatformMeta] iBLAIPlatformMeta:
  Future<Response> aiAccountOrgsPlatformMetadataUpdateWithHttpInfo(String org, { IBLAIPlatformMeta? iBLAIPlatformMeta, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/account/orgs/{org}/platform-metadata/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = iBLAIPlatformMeta;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [IBLAIPlatformMeta] iBLAIPlatformMeta:
  Future<IBLAIPlatformMeta?> aiAccountOrgsPlatformMetadataUpdate(String org, { IBLAIPlatformMeta? iBLAIPlatformMeta, }) async {
    final response = await aiAccountOrgsPlatformMetadataUpdateWithHttpInfo(org,  iBLAIPlatformMeta: iBLAIPlatformMeta, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'IBLAIPlatformMeta',) as IBLAIPlatformMeta;
    
    }
    return null;
  }

  ///      Token count     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> aiAccountOrgsTokensListWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/account/orgs/{org}/tokens/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Token count     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<List<APITokenCost>?> aiAccountOrgsTokensList(String org,) async {
    final response = await aiAccountOrgsTokensListWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(responseBody, 'List<APITokenCost>') as List)
        .cast<APITokenCost>()
        .toList(growable: false);

    }
    return null;
  }

  /// Create slash commands for a specific bot eg. /iblai-baseline
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [BotCommand] botCommand (required):
  Future<Response> aiBotV1BotsBotCommandsCreateWithHttpInfo(String org, BotCommand botCommand,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/{org}/bot-commands/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = botCommand;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create slash commands for a specific bot eg. /iblai-baseline
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [BotCommand] botCommand (required):
  Future<BotCommand?> aiBotV1BotsBotCommandsCreate(String org, BotCommand botCommand,) async {
    final response = await aiBotV1BotsBotCommandsCreateWithHttpInfo(org, botCommand,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'BotCommand',) as BotCommand;
    
    }
    return null;
  }

  /// Create slash commands for a specific bot eg. /iblai-baseline
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this bot command.
  ///
  /// * [String] org (required):
  Future<Response> aiBotV1BotsBotCommandsDestroyWithHttpInfo(int id, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/{org}/bot-commands/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create slash commands for a specific bot eg. /iblai-baseline
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this bot command.
  ///
  /// * [String] org (required):
  Future<void> aiBotV1BotsBotCommandsDestroy(int id, String org,) async {
    final response = await aiBotV1BotsBotCommandsDestroyWithHttpInfo(id, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Create slash commands for a specific bot eg. /iblai-baseline
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> aiBotV1BotsBotCommandsListWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/{org}/bot-commands/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create slash commands for a specific bot eg. /iblai-baseline
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<List<BotCommand>?> aiBotV1BotsBotCommandsList(String org,) async {
    final response = await aiBotV1BotsBotCommandsListWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(responseBody, 'List<BotCommand>') as List)
        .cast<BotCommand>()
        .toList(growable: false);

    }
    return null;
  }

  /// Create slash commands for a specific bot eg. /iblai-baseline
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this bot command.
  ///
  /// * [String] org (required):
  ///
  /// * [PatchedBotCommand] patchedBotCommand:
  Future<Response> aiBotV1BotsBotCommandsPartialUpdateWithHttpInfo(int id, String org, { PatchedBotCommand? patchedBotCommand, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/{org}/bot-commands/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = patchedBotCommand;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create slash commands for a specific bot eg. /iblai-baseline
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this bot command.
  ///
  /// * [String] org (required):
  ///
  /// * [PatchedBotCommand] patchedBotCommand:
  Future<BotCommand?> aiBotV1BotsBotCommandsPartialUpdate(int id, String org, { PatchedBotCommand? patchedBotCommand, }) async {
    final response = await aiBotV1BotsBotCommandsPartialUpdateWithHttpInfo(id, org,  patchedBotCommand: patchedBotCommand, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'BotCommand',) as BotCommand;
    
    }
    return null;
  }

  /// Create slash commands for a specific bot eg. /iblai-baseline
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this bot command.
  ///
  /// * [String] org (required):
  Future<Response> aiBotV1BotsBotCommandsRetrieveWithHttpInfo(int id, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/{org}/bot-commands/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create slash commands for a specific bot eg. /iblai-baseline
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this bot command.
  ///
  /// * [String] org (required):
  Future<BotCommand?> aiBotV1BotsBotCommandsRetrieve(int id, String org,) async {
    final response = await aiBotV1BotsBotCommandsRetrieveWithHttpInfo(id, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'BotCommand',) as BotCommand;
    
    }
    return null;
  }

  /// Create slash commands for a specific bot eg. /iblai-baseline
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this bot command.
  ///
  /// * [String] org (required):
  ///
  /// * [BotCommand] botCommand (required):
  Future<Response> aiBotV1BotsBotCommandsUpdateWithHttpInfo(int id, String org, BotCommand botCommand,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/{org}/bot-commands/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = botCommand;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create slash commands for a specific bot eg. /iblai-baseline
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this bot command.
  ///
  /// * [String] org (required):
  ///
  /// * [BotCommand] botCommand (required):
  Future<BotCommand?> aiBotV1BotsBotCommandsUpdate(int id, String org, BotCommand botCommand,) async {
    final response = await aiBotV1BotsBotCommandsUpdateWithHttpInfo(id, org, botCommand,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'BotCommand',) as BotCommand;
    
    }
    return null;
  }

  /// Create modify and update bot information for a specific tenant.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [BotCreate] botCreate (required):
  Future<Response> aiBotV1BotsBotCreateWithHttpInfo(String org, BotCreate botCreate,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/{org}/bot/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = botCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create modify and update bot information for a specific tenant.
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [BotCreate] botCreate (required):
  Future<BotCreate?> aiBotV1BotsBotCreate(String org, BotCreate botCreate,) async {
    final response = await aiBotV1BotsBotCreateWithHttpInfo(org, botCreate,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'BotCreate',) as BotCreate;
    
    }
    return null;
  }

  /// Create modify and update bot information for a specific tenant.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this bot.
  ///
  /// * [String] org (required):
  Future<Response> aiBotV1BotsBotDestroyWithHttpInfo(int id, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/{org}/bot/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create modify and update bot information for a specific tenant.
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this bot.
  ///
  /// * [String] org (required):
  Future<void> aiBotV1BotsBotDestroy(int id, String org,) async {
    final response = await aiBotV1BotsBotDestroyWithHttpInfo(id, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Create modify and update bot information for a specific tenant.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> aiBotV1BotsBotListWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/{org}/bot/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create modify and update bot information for a specific tenant.
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<List<Bot>?> aiBotV1BotsBotList(String org,) async {
    final response = await aiBotV1BotsBotListWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(responseBody, 'List<Bot>') as List)
        .cast<Bot>()
        .toList(growable: false);

    }
    return null;
  }

  /// Create modify and update bot information for a specific tenant.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this bot.
  ///
  /// * [String] org (required):
  ///
  /// * [PatchedBotCreate] patchedBotCreate:
  Future<Response> aiBotV1BotsBotPartialUpdateWithHttpInfo(int id, String org, { PatchedBotCreate? patchedBotCreate, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/{org}/bot/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = patchedBotCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create modify and update bot information for a specific tenant.
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this bot.
  ///
  /// * [String] org (required):
  ///
  /// * [PatchedBotCreate] patchedBotCreate:
  Future<BotCreate?> aiBotV1BotsBotPartialUpdate(int id, String org, { PatchedBotCreate? patchedBotCreate, }) async {
    final response = await aiBotV1BotsBotPartialUpdateWithHttpInfo(id, org,  patchedBotCreate: patchedBotCreate, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'BotCreate',) as BotCreate;
    
    }
    return null;
  }

  /// Create modify and update bot information for a specific tenant.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this bot.
  ///
  /// * [String] org (required):
  Future<Response> aiBotV1BotsBotRetrieveWithHttpInfo(int id, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/{org}/bot/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create modify and update bot information for a specific tenant.
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this bot.
  ///
  /// * [String] org (required):
  Future<Bot?> aiBotV1BotsBotRetrieve(int id, String org,) async {
    final response = await aiBotV1BotsBotRetrieveWithHttpInfo(id, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Bot',) as Bot;
    
    }
    return null;
  }

  /// Create modify and update bot information for a specific tenant.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this bot.
  ///
  /// * [String] org (required):
  ///
  /// * [BotCreate] botCreate (required):
  Future<Response> aiBotV1BotsBotUpdateWithHttpInfo(int id, String org, BotCreate botCreate,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/{org}/bot/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = botCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create modify and update bot information for a specific tenant.
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this bot.
  ///
  /// * [String] org (required):
  ///
  /// * [BotCreate] botCreate (required):
  Future<BotCreate?> aiBotV1BotsBotUpdate(int id, String org, BotCreate botCreate,) async {
    final response = await aiBotV1BotsBotUpdateWithHttpInfo(id, org, botCreate,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'BotCreate',) as BotCreate;
    
    }
    return null;
  }

  /// Webhook endpoint to receive and process discord messages.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [DiscordWebhook] discordWebhook (required):
  Future<Response> aiBotV1BotsWebhooksDiscordCreateWithHttpInfo(String org, DiscordWebhook discordWebhook,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/webhooks/{org}/discord/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = discordWebhook;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'multipart/form-data', 'application/x-www-form-urlencoded'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Webhook endpoint to receive and process discord messages.
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [DiscordWebhook] discordWebhook (required):
  Future<DiscordWebhook?> aiBotV1BotsWebhooksDiscordCreate(String org, DiscordWebhook discordWebhook,) async {
    final response = await aiBotV1BotsWebhooksDiscordCreateWithHttpInfo(org, discordWebhook,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'DiscordWebhook',) as DiscordWebhook;
    
    }
    return null;
  }

  /// Performs an HTTP 'POST /api/ai/bot/v1/bots/webhooks/{org}/slack/' operation and returns the [Response].
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [SlackWebhook] slackWebhook (required):
  Future<Response> aiBotV1BotsWebhooksSlackCreateWithHttpInfo(String org, SlackWebhook slackWebhook,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/webhooks/{org}/slack/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = slackWebhook;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'multipart/form-data', 'application/x-www-form-urlencoded'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [SlackWebhook] slackWebhook (required):
  Future<SlackWebhook?> aiBotV1BotsWebhooksSlackCreate(String org, SlackWebhook slackWebhook,) async {
    final response = await aiBotV1BotsWebhooksSlackCreateWithHttpInfo(org, slackWebhook,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'SlackWebhook',) as SlackWebhook;
    
    }
    return null;
  }

  /// Webhook endpoint to receive and process discord messages.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [WebexWebhook] webexWebhook (required):
  Future<Response> aiBotV1BotsWebhooksWebexCreateWithHttpInfo(String org, WebexWebhook webexWebhook,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/webhooks/{org}/webex/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = webexWebhook;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'multipart/form-data', 'application/x-www-form-urlencoded'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Webhook endpoint to receive and process discord messages.
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [WebexWebhook] webexWebhook (required):
  Future<WebexWebhook?> aiBotV1BotsWebhooksWebexCreate(String org, WebexWebhook webexWebhook,) async {
    final response = await aiBotV1BotsWebhooksWebexCreateWithHttpInfo(org, webexWebhook,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'WebexWebhook',) as WebexWebhook;
    
    }
    return null;
  }

  /// Webhook endpoint to receive and process whatsapp messages.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [WhatAppWebHook] whatAppWebHook (required):
  Future<Response> aiBotV1BotsWebhooksWhatsappCreateWithHttpInfo(String org, WhatAppWebHook whatAppWebHook,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/webhooks/{org}/whatsapp/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = whatAppWebHook;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'multipart/form-data', 'application/x-www-form-urlencoded'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Webhook endpoint to receive and process whatsapp messages.
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [WhatAppWebHook] whatAppWebHook (required):
  Future<WhatAppWebHook?> aiBotV1BotsWebhooksWhatsappCreate(String org, WhatAppWebHook whatAppWebHook,) async {
    final response = await aiBotV1BotsWebhooksWhatsappCreateWithHttpInfo(org, whatAppWebHook,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'WhatAppWebHook',) as WhatAppWebHook;
    
    }
    return null;
  }

  /// Respond to whatsapp's webhook challenge.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> aiBotV1BotsWebhooksWhatsappRetrieveWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/bot/v1/bots/webhooks/{org}/whatsapp/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Respond to whatsapp's webhook challenge.
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<WhatAppWebHook?> aiBotV1BotsWebhooksWhatsappRetrieve(String org,) async {
    final response = await aiBotV1BotsWebhooksWhatsappRetrieveWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'WhatAppWebHook',) as WhatAppWebHook;
    
    }
    return null;
  }

  ///      Get document resource details for a tenant     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] documentId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiIndexOrgsUsersDocumentsRetrieverDocumentsRetrieveWithHttpInfo(String documentId, String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/index/orgs/{org}/users/{user_id}/documents/{document_id}/retriever_documents/'
      .replaceAll('{document_id}', documentId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Get document resource details for a tenant     
  ///
  /// Parameters:
  ///
  /// * [String] documentId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<RetrieverDocumentEmbedding?> aiIndexOrgsUsersDocumentsRetrieverDocumentsRetrieve(String documentId, String org, String userId,) async {
    final response = await aiIndexOrgsUsersDocumentsRetrieverDocumentsRetrieveWithHttpInfo(documentId, org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'RetrieverDocumentEmbedding',) as RetrieverDocumentEmbedding;
    
    }
    return null;
  }

  ///      Update document resource details for a tenant     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] documentId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [RetrieverDocumentEmbeddingRequest] retrieverDocumentEmbeddingRequest (required):
  Future<Response> aiIndexOrgsUsersDocumentsRetrieverDocumentsUpdateWithHttpInfo(String documentId, String org, String userId, RetrieverDocumentEmbeddingRequest retrieverDocumentEmbeddingRequest,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/index/orgs/{org}/users/{user_id}/documents/{document_id}/retriever_documents/'
      .replaceAll('{document_id}', documentId)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = retrieverDocumentEmbeddingRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Update document resource details for a tenant     
  ///
  /// Parameters:
  ///
  /// * [String] documentId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [RetrieverDocumentEmbeddingRequest] retrieverDocumentEmbeddingRequest (required):
  Future<RetrieverDocumentEmbedding?> aiIndexOrgsUsersDocumentsRetrieverDocumentsUpdate(String documentId, String org, String userId, RetrieverDocumentEmbeddingRequest retrieverDocumentEmbeddingRequest,) async {
    final response = await aiIndexOrgsUsersDocumentsRetrieverDocumentsUpdateWithHttpInfo(documentId, org, userId, retrieverDocumentEmbeddingRequest,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'RetrieverDocumentEmbedding',) as RetrieverDocumentEmbedding;
    
    }
    return null;
  }

  ///      Train document from other languages to english     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [RetreiverTrainViewRequest] retreiverTrainViewRequest (required):
  Future<Response> aiIndexOrgsUsersMultilingualRetrieverTrainCreateWithHttpInfo(String org, String userId, RetreiverTrainViewRequest retreiverTrainViewRequest,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/index/orgs/{org}/users/{user_id}/multilingual_retriever_train/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = retreiverTrainViewRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Train document from other languages to english     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [RetreiverTrainViewRequest] retreiverTrainViewRequest (required):
  Future<RetreiverTrainViewResponse?> aiIndexOrgsUsersMultilingualRetrieverTrainCreate(String org, String userId, RetreiverTrainViewRequest retreiverTrainViewRequest,) async {
    final response = await aiIndexOrgsUsersMultilingualRetrieverTrainCreateWithHttpInfo(org, userId, retreiverTrainViewRequest,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'RetreiverTrainViewResponse',) as RetreiverTrainViewResponse;
    
    }
    return null;
  }

  ///      Get document resources for a tenant     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] pathway (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiIndexOrgsUsersPathwaysRetrieverDocumentsRetrieveWithHttpInfo(String org, String pathway, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/index/orgs/{org}/users/{user_id}/pathways/{pathway}/retriever_documents/'
      .replaceAll('{org}', org)
      .replaceAll('{pathway}', pathway)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Get document resources for a tenant     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] pathway (required):
  ///
  /// * [String] userId (required):
  Future<RetrieverDocumentEmbedding?> aiIndexOrgsUsersPathwaysRetrieverDocumentsRetrieve(String org, String pathway, String userId,) async {
    final response = await aiIndexOrgsUsersPathwaysRetrieverDocumentsRetrieveWithHttpInfo(org, pathway, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'RetrieverDocumentEmbedding',) as RetrieverDocumentEmbedding;
    
    }
    return null;
  }

  ///      Retrieve similar documents to the query     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [RetrieverRequestSearch] retrieverRequestSearch (required):
  Future<Response> aiIndexOrgsUsersRetrieverSearchCreateWithHttpInfo(String org, String userId, RetrieverRequestSearch retrieverRequestSearch,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/index/orgs/{org}/users/{user_id}/retriever_search/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = retrieverRequestSearch;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Retrieve similar documents to the query     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [RetrieverRequestSearch] retrieverRequestSearch (required):
  Future<RetrieverResponseSearch?> aiIndexOrgsUsersRetrieverSearchCreate(String org, String userId, RetrieverRequestSearch retrieverRequestSearch,) async {
    final response = await aiIndexOrgsUsersRetrieverSearchCreateWithHttpInfo(org, userId, retrieverRequestSearch,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'RetrieverResponseSearch',) as RetrieverResponseSearch;
    
    }
    return null;
  }

  ///      Train documents     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [RetreiverTrainViewRequest] retreiverTrainViewRequest (required):
  Future<Response> aiIndexOrgsUsersRetrieverTrainCreateWithHttpInfo(String org, String userId, RetreiverTrainViewRequest retreiverTrainViewRequest,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/index/orgs/{org}/users/{user_id}/retriever_train/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = retreiverTrainViewRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Train documents     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [RetreiverTrainViewRequest] retreiverTrainViewRequest (required):
  Future<RetreiverTrainViewResponse?> aiIndexOrgsUsersRetrieverTrainCreate(String org, String userId, RetreiverTrainViewRequest retreiverTrainViewRequest,) async {
    final response = await aiIndexOrgsUsersRetrieverTrainCreateWithHttpInfo(org, userId, retreiverTrainViewRequest,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'RetreiverTrainViewResponse',) as RetreiverTrainViewResponse;
    
    }
    return null;
  }

  ///      Retrieve similar documents sources to the query     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [RetrieverRequestSearch] retrieverRequestSearch (required):
  Future<Response> aiIndexOrgsUsersSourcesCreateWithHttpInfo(String org, String userId, RetrieverRequestSearch retrieverRequestSearch,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/index/orgs/{org}/users/{user_id}/sources/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = retrieverRequestSearch;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Retrieve similar documents sources to the query     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [RetrieverRequestSearch] retrieverRequestSearch (required):
  Future<RetrieverRequestSearchDocument?> aiIndexOrgsUsersSourcesCreate(String org, String userId, RetrieverRequestSearch retrieverRequestSearch,) async {
    final response = await aiIndexOrgsUsersSourcesCreateWithHttpInfo(org, userId, retrieverRequestSearch,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'RetrieverRequestSearchDocument',) as RetrieverRequestSearchDocument;
    
    }
    return null;
  }

  ///      Check document status of training     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] taskId (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiIndexOrgsUsersTasksRetrieveWithHttpInfo(String org, String taskId, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/index/orgs/{org}/users/{user_id}/tasks/{task_id}/'
      .replaceAll('{org}', org)
      .replaceAll('{task_id}', taskId)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Check document status of training     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] taskId (required):
  ///
  /// * [String] userId (required):
  Future<CheckDocumentTrainingStatus?> aiIndexOrgsUsersTasksRetrieve(String org, String taskId, String userId,) async {
    final response = await aiIndexOrgsUsersTasksRetrieveWithHttpInfo(org, taskId, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'CheckDocumentTrainingStatus',) as CheckDocumentTrainingStatus;
    
    }
    return null;
  }

  ///      Train documents     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [TrainDocumentViewRequest] trainDocumentViewRequest (required):
  Future<Response> aiIndexOrgsUsersTrainDocumentCreateWithHttpInfo(String org, String userId, TrainDocumentViewRequest trainDocumentViewRequest,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/index/orgs/{org}/users/{user_id}/train-document/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = trainDocumentViewRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Train documents     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [TrainDocumentViewRequest] trainDocumentViewRequest (required):
  Future<TrainDocumentViewResponse?> aiIndexOrgsUsersTrainDocumentCreate(String org, String userId, TrainDocumentViewRequest trainDocumentViewRequest,) async {
    final response = await aiIndexOrgsUsersTrainDocumentCreateWithHttpInfo(org, userId, trainDocumentViewRequest,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'TrainDocumentViewResponse',) as TrainDocumentViewResponse;
    
    }
    return null;
  }

  ///      Train in chat session documents     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiIndexOrgsUsersTrainSessionDocumentSessionsCreateWithHttpInfo(String org, String sessionId, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/index/orgs/{org}/users/{user_id}/train-session-document/sessions/{session_id}/'
      .replaceAll('{org}', org)
      .replaceAll('{session_id}', sessionId)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Train in chat session documents     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  Future<TrainChatSessionDocumentView?> aiIndexOrgsUsersTrainSessionDocumentSessionsCreate(String org, String sessionId, String userId,) async {
    final response = await aiIndexOrgsUsersTrainSessionDocumentSessionsCreateWithHttpInfo(org, sessionId, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'TrainChatSessionDocumentView',) as TrainChatSessionDocumentView;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [MathStudent] mathStudent:
  Future<Response> aiMathMathMathStudentsCreateWithHttpInfo(String org, { MathStudent? mathStudent, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/math-students/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = mathStudent;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [MathStudent] mathStudent:
  Future<MathStudent?> aiMathMathMathStudentsCreate(String org, { MathStudent? mathStudent, }) async {
    final response = await aiMathMathMathStudentsCreateWithHttpInfo(org,  mathStudent: mathStudent, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MathStudent',) as MathStudent;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this math student.
  ///
  /// * [String] org (required):
  Future<Response> aiMathMathMathStudentsDestroyWithHttpInfo(int id, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/math-students/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this math student.
  ///
  /// * [String] org (required):
  Future<void> aiMathMathMathStudentsDestroy(int id, String org,) async {
    final response = await aiMathMathMathStudentsDestroyWithHttpInfo(id, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> aiMathMathMathStudentsListWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/math-students/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<List<MathStudent>?> aiMathMathMathStudentsList(String org,) async {
    final response = await aiMathMathMathStudentsListWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(responseBody, 'List<MathStudent>') as List)
        .cast<MathStudent>()
        .toList(growable: false);

    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this math student.
  ///
  /// * [String] org (required):
  ///
  /// * [PatchedMathStudent] patchedMathStudent:
  Future<Response> aiMathMathMathStudentsPartialUpdateWithHttpInfo(int id, String org, { PatchedMathStudent? patchedMathStudent, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/math-students/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = patchedMathStudent;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this math student.
  ///
  /// * [String] org (required):
  ///
  /// * [PatchedMathStudent] patchedMathStudent:
  Future<MathStudent?> aiMathMathMathStudentsPartialUpdate(int id, String org, { PatchedMathStudent? patchedMathStudent, }) async {
    final response = await aiMathMathMathStudentsPartialUpdateWithHttpInfo(id, org,  patchedMathStudent: patchedMathStudent, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MathStudent',) as MathStudent;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this math student.
  ///
  /// * [String] org (required):
  Future<Response> aiMathMathMathStudentsRetrieveWithHttpInfo(int id, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/math-students/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this math student.
  ///
  /// * [String] org (required):
  Future<MathStudent?> aiMathMathMathStudentsRetrieve(int id, String org,) async {
    final response = await aiMathMathMathStudentsRetrieveWithHttpInfo(id, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MathStudent',) as MathStudent;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this math student.
  ///
  /// * [String] org (required):
  ///
  /// * [MathStudent] mathStudent:
  Future<Response> aiMathMathMathStudentsUpdateWithHttpInfo(int id, String org, { MathStudent? mathStudent, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/math-students/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = mathStudent;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this math student.
  ///
  /// * [String] org (required):
  ///
  /// * [MathStudent] mathStudent:
  Future<MathStudent?> aiMathMathMathStudentsUpdate(int id, String org, { MathStudent? mathStudent, }) async {
    final response = await aiMathMathMathStudentsUpdateWithHttpInfo(id, org,  mathStudent: mathStudent, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MathStudent',) as MathStudent;
    
    }
    return null;
  }

  /// Retrieve, update and delete math questions.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this math question.
  ///
  /// * [String] org (required):
  Future<Response> aiMathMathQuestionsDestroyWithHttpInfo(int id, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/questions/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Retrieve, update and delete math questions.
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this math question.
  ///
  /// * [String] org (required):
  Future<void> aiMathMathQuestionsDestroy(int id, String org,) async {
    final response = await aiMathMathQuestionsDestroyWithHttpInfo(id, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Retrieve, update and delete math questions.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> aiMathMathQuestionsListWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/questions/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Retrieve, update and delete math questions.
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<List<MathQuestion>?> aiMathMathQuestionsList(String org,) async {
    final response = await aiMathMathQuestionsListWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(responseBody, 'List<MathQuestion>') as List)
        .cast<MathQuestion>()
        .toList(growable: false);

    }
    return null;
  }

  /// Retrieve, update and delete math questions.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this math question.
  ///
  /// * [String] org (required):
  ///
  /// * [PatchedMathQuestion] patchedMathQuestion:
  Future<Response> aiMathMathQuestionsPartialUpdateWithHttpInfo(int id, String org, { PatchedMathQuestion? patchedMathQuestion, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/questions/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = patchedMathQuestion;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Retrieve, update and delete math questions.
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this math question.
  ///
  /// * [String] org (required):
  ///
  /// * [PatchedMathQuestion] patchedMathQuestion:
  Future<MathQuestion?> aiMathMathQuestionsPartialUpdate(int id, String org, { PatchedMathQuestion? patchedMathQuestion, }) async {
    final response = await aiMathMathQuestionsPartialUpdateWithHttpInfo(id, org,  patchedMathQuestion: patchedMathQuestion, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MathQuestion',) as MathQuestion;
    
    }
    return null;
  }

  /// Retrieve, update and delete math questions.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this math question.
  ///
  /// * [String] org (required):
  Future<Response> aiMathMathQuestionsRetrieveWithHttpInfo(int id, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/questions/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Retrieve, update and delete math questions.
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this math question.
  ///
  /// * [String] org (required):
  Future<MathQuestion?> aiMathMathQuestionsRetrieve(int id, String org,) async {
    final response = await aiMathMathQuestionsRetrieveWithHttpInfo(id, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MathQuestion',) as MathQuestion;
    
    }
    return null;
  }

  /// Upload documents to provide sample questions of reference to generate more math questions from.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [SampleQuestionsDocument] sampleQuestionsDocument (required):
  Future<Response> aiMathMathSampleQuestionsCreateWithHttpInfo(String org, SampleQuestionsDocument sampleQuestionsDocument,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/sample-questions/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = sampleQuestionsDocument;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Upload documents to provide sample questions of reference to generate more math questions from.
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [SampleQuestionsDocument] sampleQuestionsDocument (required):
  Future<SampleQuestionsDocument?> aiMathMathSampleQuestionsCreate(String org, SampleQuestionsDocument sampleQuestionsDocument,) async {
    final response = await aiMathMathSampleQuestionsCreateWithHttpInfo(org, sampleQuestionsDocument,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'SampleQuestionsDocument',) as SampleQuestionsDocument;
    
    }
    return null;
  }

  /// Upload documents to provide sample questions of reference to generate more math questions from.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this sample questions document.
  ///
  /// * [String] org (required):
  Future<Response> aiMathMathSampleQuestionsDestroyWithHttpInfo(int id, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/sample-questions/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Upload documents to provide sample questions of reference to generate more math questions from.
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this sample questions document.
  ///
  /// * [String] org (required):
  Future<void> aiMathMathSampleQuestionsDestroy(int id, String org,) async {
    final response = await aiMathMathSampleQuestionsDestroyWithHttpInfo(id, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Upload documents to provide sample questions of reference to generate more math questions from.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> aiMathMathSampleQuestionsListWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/sample-questions/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Upload documents to provide sample questions of reference to generate more math questions from.
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<List<SampleQuestionsDocument>?> aiMathMathSampleQuestionsList(String org,) async {
    final response = await aiMathMathSampleQuestionsListWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(responseBody, 'List<SampleQuestionsDocument>') as List)
        .cast<SampleQuestionsDocument>()
        .toList(growable: false);

    }
    return null;
  }

  /// Upload documents to provide sample questions of reference to generate more math questions from.
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this sample questions document.
  ///
  /// * [String] org (required):
  Future<Response> aiMathMathSampleQuestionsRetrieveWithHttpInfo(int id, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/sample-questions/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Upload documents to provide sample questions of reference to generate more math questions from.
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this sample questions document.
  ///
  /// * [String] org (required):
  Future<SampleQuestionsDocument?> aiMathMathSampleQuestionsRetrieve(int id, String org,) async {
    final response = await aiMathMathSampleQuestionsRetrieveWithHttpInfo(id, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'SampleQuestionsDocument',) as SampleQuestionsDocument;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [Skill] skill (required):
  Future<Response> aiMathMathSkillsCreateWithHttpInfo(String org, Skill skill,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/skills/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = skill;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [Skill] skill (required):
  Future<Skill?> aiMathMathSkillsCreate(String org, Skill skill,) async {
    final response = await aiMathMathSkillsCreateWithHttpInfo(org, skill,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Skill',) as Skill;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this skill.
  ///
  /// * [String] org (required):
  Future<Response> aiMathMathSkillsDestroyWithHttpInfo(int id, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/skills/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this skill.
  ///
  /// * [String] org (required):
  Future<void> aiMathMathSkillsDestroy(int id, String org,) async {
    final response = await aiMathMathSkillsDestroyWithHttpInfo(id, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> aiMathMathSkillsListWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/skills/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<List<Skill>?> aiMathMathSkillsList(String org,) async {
    final response = await aiMathMathSkillsListWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(responseBody, 'List<Skill>') as List)
        .cast<Skill>()
        .toList(growable: false);

    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this skill.
  ///
  /// * [String] org (required):
  ///
  /// * [PatchedSkill] patchedSkill:
  Future<Response> aiMathMathSkillsPartialUpdateWithHttpInfo(int id, String org, { PatchedSkill? patchedSkill, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/skills/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = patchedSkill;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this skill.
  ///
  /// * [String] org (required):
  ///
  /// * [PatchedSkill] patchedSkill:
  Future<Skill?> aiMathMathSkillsPartialUpdate(int id, String org, { PatchedSkill? patchedSkill, }) async {
    final response = await aiMathMathSkillsPartialUpdateWithHttpInfo(id, org,  patchedSkill: patchedSkill, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Skill',) as Skill;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this skill.
  ///
  /// * [String] org (required):
  Future<Response> aiMathMathSkillsRetrieveWithHttpInfo(int id, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/skills/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this skill.
  ///
  /// * [String] org (required):
  Future<Skill?> aiMathMathSkillsRetrieve(int id, String org,) async {
    final response = await aiMathMathSkillsRetrieveWithHttpInfo(id, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Skill',) as Skill;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this skill.
  ///
  /// * [String] org (required):
  ///
  /// * [Skill] skill (required):
  Future<Response> aiMathMathSkillsUpdateWithHttpInfo(int id, String org, Skill skill,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/skills/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = skill;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this skill.
  ///
  /// * [String] org (required):
  ///
  /// * [Skill] skill (required):
  Future<Skill?> aiMathMathSkillsUpdate(int id, String org, Skill skill,) async {
    final response = await aiMathMathSkillsUpdateWithHttpInfo(id, org, skill,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Skill',) as Skill;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [StudentAnswer] studentAnswer (required):
  Future<Response> aiMathMathStudentAnswersCreateWithHttpInfo(String org, StudentAnswer studentAnswer,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/student-answers/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = studentAnswer;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [StudentAnswer] studentAnswer (required):
  Future<StudentAnswer?> aiMathMathStudentAnswersCreate(String org, StudentAnswer studentAnswer,) async {
    final response = await aiMathMathStudentAnswersCreateWithHttpInfo(org, studentAnswer,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'StudentAnswer',) as StudentAnswer;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this student answer.
  ///
  /// * [String] org (required):
  Future<Response> aiMathMathStudentAnswersDestroyWithHttpInfo(int id, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/student-answers/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this student answer.
  ///
  /// * [String] org (required):
  Future<void> aiMathMathStudentAnswersDestroy(int id, String org,) async {
    final response = await aiMathMathStudentAnswersDestroyWithHttpInfo(id, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> aiMathMathStudentAnswersListWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/student-answers/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<List<StudentAnswer>?> aiMathMathStudentAnswersList(String org,) async {
    final response = await aiMathMathStudentAnswersListWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(responseBody, 'List<StudentAnswer>') as List)
        .cast<StudentAnswer>()
        .toList(growable: false);

    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this student answer.
  ///
  /// * [String] org (required):
  ///
  /// * [PatchedStudentAnswer] patchedStudentAnswer:
  Future<Response> aiMathMathStudentAnswersPartialUpdateWithHttpInfo(int id, String org, { PatchedStudentAnswer? patchedStudentAnswer, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/student-answers/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = patchedStudentAnswer;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this student answer.
  ///
  /// * [String] org (required):
  ///
  /// * [PatchedStudentAnswer] patchedStudentAnswer:
  Future<StudentAnswer?> aiMathMathStudentAnswersPartialUpdate(int id, String org, { PatchedStudentAnswer? patchedStudentAnswer, }) async {
    final response = await aiMathMathStudentAnswersPartialUpdateWithHttpInfo(id, org,  patchedStudentAnswer: patchedStudentAnswer, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'StudentAnswer',) as StudentAnswer;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this student answer.
  ///
  /// * [String] org (required):
  Future<Response> aiMathMathStudentAnswersRetrieveWithHttpInfo(int id, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/student-answers/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this student answer.
  ///
  /// * [String] org (required):
  Future<StudentAnswer?> aiMathMathStudentAnswersRetrieve(int id, String org,) async {
    final response = await aiMathMathStudentAnswersRetrieveWithHttpInfo(id, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'StudentAnswer',) as StudentAnswer;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this student answer.
  ///
  /// * [String] org (required):
  ///
  /// * [StudentAnswer] studentAnswer (required):
  Future<Response> aiMathMathStudentAnswersUpdateWithHttpInfo(int id, String org, StudentAnswer studentAnswer,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/math/math/{org}/student-answers/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = studentAnswer;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this student answer.
  ///
  /// * [String] org (required):
  ///
  /// * [StudentAnswer] studentAnswer (required):
  Future<StudentAnswer?> aiMathMathStudentAnswersUpdate(int id, String org, StudentAnswer studentAnswer,) async {
    final response = await aiMathMathStudentAnswersUpdateWithHttpInfo(id, org, studentAnswer,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'StudentAnswer',) as StudentAnswer;
    
    }
    return null;
  }

  ///      Stop websocket generation     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] generationId (required):
  Future<Response> aiMentorGenerationsStopGenerationCreateWithHttpInfo(String generationId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/generations/{generation_id}/stop-generation/'
      .replaceAll('{generation_id}', generationId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Stop websocket generation     
  ///
  /// Parameters:
  ///
  /// * [String] generationId (required):
  Future<WebSocketStopGenerationView?> aiMentorGenerationsStopGenerationCreate(String generationId,) async {
    final response = await aiMentorGenerationsStopGenerationCreateWithHttpInfo(generationId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'WebSocketStopGenerationView',) as WebSocketStopGenerationView;
    
    }
    return null;
  }

  /// Retrieve the number of questions left for a tenant
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> aiMentorOrgsFreeUsageCountRetrieveWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/free-usage-count/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Retrieve the number of questions left for a tenant
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<FreeUsageCount?> aiMentorOrgsFreeUsageCountRetrieve(String org,) async {
    final response = await aiMentorOrgsFreeUsageCountRetrieveWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'FreeUsageCount',) as FreeUsageCount;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [UserChatFeedback] userChatFeedback (required):
  Future<Response> aiMentorOrgsMentorFeedbackCreateCreateWithHttpInfo(String org, UserChatFeedback userChatFeedback,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/mentor-feedback/create/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = userChatFeedback;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [UserChatFeedback] userChatFeedback (required):
  Future<UserChatFeedback?> aiMentorOrgsMentorFeedbackCreateCreate(String org, UserChatFeedback userChatFeedback,) async {
    final response = await aiMentorOrgsMentorFeedbackCreateCreateWithHttpInfo(org, userChatFeedback,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'UserChatFeedback',) as UserChatFeedback;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] feedbackId (required):
  ///
  /// * [String] org (required):
  Future<Response> aiMentorOrgsMentorFeedbackRetrieveWithHttpInfo(int feedbackId, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/mentor-feedback/{feedback_id}/'
      .replaceAll('{feedback_id}', feedbackId.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [int] feedbackId (required):
  ///
  /// * [String] org (required):
  Future<UserChatFeedback?> aiMentorOrgsMentorFeedbackRetrieve(int feedbackId, String org,) async {
    final response = await aiMentorOrgsMentorFeedbackRetrieveWithHttpInfo(feedbackId, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'UserChatFeedback',) as UserChatFeedback;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] feedbackId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [UserChatFeedback] userChatFeedback (required):
  Future<Response> aiMentorOrgsMentorFeedbackUpdateWithHttpInfo(int feedbackId, String org, UserChatFeedback userChatFeedback,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/mentor-feedback/{feedback_id}/'
      .replaceAll('{feedback_id}', feedbackId.toString())
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = userChatFeedback;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [int] feedbackId (required):
  ///
  /// * [String] org (required):
  ///
  /// * [UserChatFeedback] userChatFeedback (required):
  Future<UserChatFeedback?> aiMentorOrgsMentorFeedbackUpdate(int feedbackId, String org, UserChatFeedback userChatFeedback,) async {
    final response = await aiMentorOrgsMentorFeedbackUpdateWithHttpInfo(feedbackId, org, userChatFeedback,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'UserChatFeedback',) as UserChatFeedback;
    
    }
    return null;
  }

  /// View to create a mentor from a template
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [MentorFromTemplateRequest] mentorFromTemplateRequest (required):
  Future<Response> aiMentorOrgsMentorFromTemplateCreateWithHttpInfo(String org, MentorFromTemplateRequest mentorFromTemplateRequest,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/mentor-from-template/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = mentorFromTemplateRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to create a mentor from a template
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [MentorFromTemplateRequest] mentorFromTemplateRequest (required):
  Future<Mentor?> aiMentorOrgsMentorFromTemplateCreate(String org, MentorFromTemplateRequest mentorFromTemplateRequest,) async {
    final response = await aiMentorOrgsMentorFromTemplateCreateWithHttpInfo(org, mentorFromTemplateRequest,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Mentor',) as Mentor;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> aiMentorOrgsMentorLlmsRetrieveWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/mentor-llms/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<MentorLLMFlowResponse?> aiMentorOrgsMentorLlmsRetrieve(String org,) async {
    final response = await aiMentorOrgsMentorLlmsRetrieveWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MentorLLMFlowResponse',) as MentorLLMFlowResponse;
    
    }
    return null;
  }

  /// View to create a mentor from a template with settings
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [MentorFromTemplateWithSettingRequest] mentorFromTemplateWithSettingRequest (required):
  Future<Response> aiMentorOrgsMentorWithSettingsCreateWithHttpInfo(String org, MentorFromTemplateWithSettingRequest mentorFromTemplateWithSettingRequest,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/mentor-with-settings/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = mentorFromTemplateWithSettingRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to create a mentor from a template with settings
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [MentorFromTemplateWithSettingRequest] mentorFromTemplateWithSettingRequest (required):
  Future<Mentor?> aiMentorOrgsMentorWithSettingsCreate(String org, MentorFromTemplateWithSettingRequest mentorFromTemplateWithSettingRequest,) async {
    final response = await aiMentorOrgsMentorWithSettingsCreateWithHttpInfo(org, mentorFromTemplateWithSettingRequest,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Mentor',) as Mentor;
    
    }
    return null;
  }

  /// Get mentor settings
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  Future<Response> aiMentorOrgsMentorsPublicSettingsRetrieveWithHttpInfo(String mentor, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/mentors/{mentor}/public-settings/'
      .replaceAll('{mentor}', mentor)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Get mentor settings
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  Future<MentorSettings?> aiMentorOrgsMentorsPublicSettingsRetrieve(String mentor, String org,) async {
    final response = await aiMentorOrgsMentorsPublicSettingsRetrieveWithHttpInfo(mentor, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MentorSettings',) as MentorSettings;
    
    }
    return null;
  }

  /// Get mentor settings
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  Future<Response> aiMentorOrgsMentorsSettingsRetrieveWithHttpInfo(String mentor, String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/mentors/{mentor}/settings/'
      .replaceAll('{mentor}', mentor)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Get mentor settings
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  Future<MentorSettings?> aiMentorOrgsMentorsSettingsRetrieve(String mentor, String org,) async {
    final response = await aiMentorOrgsMentorsSettingsRetrieveWithHttpInfo(mentor, org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MentorSettings',) as MentorSettings;
    
    }
    return null;
  }

  /// Update mentor settings
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  ///
  /// * [MentorSettingsRequest] mentorSettingsRequest:
  Future<Response> aiMentorOrgsMentorsSettingsUpdateWithHttpInfo(String mentor, String org, { MentorSettingsRequest? mentorSettingsRequest, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/mentors/{mentor}/settings/'
      .replaceAll('{mentor}', mentor)
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = mentorSettingsRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Update mentor settings
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  ///
  /// * [MentorSettingsRequest] mentorSettingsRequest:
  Future<MentorSettings?> aiMentorOrgsMentorsSettingsUpdate(String mentor, String org, { MentorSettingsRequest? mentorSettingsRequest, }) async {
    final response = await aiMentorOrgsMentorsSettingsUpdateWithHttpInfo(mentor, org,  mentorSettingsRequest: mentorSettingsRequest, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MentorSettings',) as MentorSettings;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsMentorsUsersRetrieveWithHttpInfo(String mentor, String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/mentors/{mentor}/users/{user_id}/'
      .replaceAll('{mentor}', mentor)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsPlatformAdmin
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<SessionDetail?> aiMentorOrgsMentorsUsersRetrieve(String mentor, String org, String userId,) async {
    final response = await aiMentorOrgsMentorsUsersRetrieveWithHttpInfo(mentor, org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'SessionDetail',) as SessionDetail;
    
    }
    return null;
  }

  ///      Send data  for  predictions     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [PredictiveAnalyticsRequest] predictiveAnalyticsRequest (required):
  Future<Response> aiMentorOrgsPredictiveAnalyticsCreateWithHttpInfo(String org, PredictiveAnalyticsRequest predictiveAnalyticsRequest,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/predictive-analytics/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = predictiveAnalyticsRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Send data  for  predictions     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [PredictiveAnalyticsRequest] predictiveAnalyticsRequest (required):
  Future<PredictiveAnalyticsResponse?> aiMentorOrgsPredictiveAnalyticsCreate(String org, PredictiveAnalyticsRequest predictiveAnalyticsRequest,) async {
    final response = await aiMentorOrgsPredictiveAnalyticsCreateWithHttpInfo(org, predictiveAnalyticsRequest,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PredictiveAnalyticsResponse',) as PredictiveAnalyticsResponse;
    
    }
    return null;
  }

  ///      Send a custom json from langflow to answer a question     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [AskMentorRequest] askMentorRequest:
  Future<Response> aiMentorOrgsSessionsAskCreateWithHttpInfo(String org, String sessionId, { AskMentorRequest? askMentorRequest, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/sessions/{session_id}/ask/'
      .replaceAll('{org}', org)
      .replaceAll('{session_id}', sessionId);

    // ignore: prefer_final_locals
    Object? postBody = askMentorRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'multipart/form-data', 'application/x-www-form-urlencoded'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Send a custom json from langflow to answer a question     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [AskMentorRequest] askMentorRequest:
  Future<AskMentorResponse?> aiMentorOrgsSessionsAskCreate(String org, String sessionId, { AskMentorRequest? askMentorRequest, }) async {
    final response = await aiMentorOrgsSessionsAskCreateWithHttpInfo(org, sessionId,  askMentorRequest: askMentorRequest, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'AskMentorResponse',) as AskMentorResponse;
    
    }
    return null;
  }

  /// Create a new chat session
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [ChatSessionRequest] chatSessionRequest (required):
  Future<Response> aiMentorOrgsSessionsCreateWithHttpInfo(String org, ChatSessionRequest chatSessionRequest,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/sessions/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody = chatSessionRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create a new chat session
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [ChatSessionRequest] chatSessionRequest (required):
  Future<ChatSessionResponse?> aiMentorOrgsSessionsCreate(String org, ChatSessionRequest chatSessionRequest,) async {
    final response = await aiMentorOrgsSessionsCreateWithHttpInfo(org, chatSessionRequest,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ChatSessionResponse',) as ChatSessionResponse;
    
    }
    return null;
  }

  ///      Send a custom json from langflow to answer a question     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [AskMentorRequest] askMentorRequest:
  Future<Response> aiMentorOrgsSessionsUsersAskCreateWithHttpInfo(String org, String sessionId, String userId, { AskMentorRequest? askMentorRequest, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/sessions/{session_id}/users/{user_id}/ask/'
      .replaceAll('{org}', org)
      .replaceAll('{session_id}', sessionId)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = askMentorRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'multipart/form-data', 'application/x-www-form-urlencoded'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Send a custom json from langflow to answer a question     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [AskMentorRequest] askMentorRequest:
  Future<AskMentorResponse?> aiMentorOrgsSessionsUsersAskCreate(String org, String sessionId, String userId, { AskMentorRequest? askMentorRequest, }) async {
    final response = await aiMentorOrgsSessionsUsersAskCreateWithHttpInfo(org, sessionId, userId,  askMentorRequest: askMentorRequest, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'AskMentorResponse',) as AskMentorResponse;
    
    }
    return null;
  }

  /// View to return the usage summary of a tenant
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Response> aiMentorOrgsUsageRetrieveWithHttpInfo(String org,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/usage/'
      .replaceAll('{org}', org);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to return the usage summary of a tenant
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  Future<Usage?> aiMentorOrgsUsageRetrieve(String org,) async {
    final response = await aiMentorOrgsUsageRetrieveWithHttpInfo(org,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Usage',) as Usage;
    
    }
    return null;
  }

  ///      Convert audio to text     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [AudioToTextRequest] audioToTextRequest (required):
  Future<Response> aiMentorOrgsUsersAudioToTextCreateWithHttpInfo(String org, String userId, AudioToTextRequest audioToTextRequest,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/audio-to-text/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = audioToTextRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Convert audio to text     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [AudioToTextRequest] audioToTextRequest (required):
  Future<AudioToTextResponse?> aiMentorOrgsUsersAudioToTextCreate(String org, String userId, AudioToTextRequest audioToTextRequest,) async {
    final response = await aiMentorOrgsUsersAudioToTextCreateWithHttpInfo(org, userId, audioToTextRequest,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'AudioToTextResponse',) as AudioToTextResponse;
    
    }
    return null;
  }

  /// View to create/retrieve a prompt category  Only users with the IsAdminUserOrStudentDRFMixin permission can view the categories Only users with the IsPlatformAdminDRFMixin permission can create categories
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [PromptCategory] promptCategory (required):
  Future<Response> aiMentorOrgsUsersCategoryCreateWithHttpInfo(String org, String userId, PromptCategory promptCategory,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/category'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = promptCategory;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to create/retrieve a prompt category  Only users with the IsAdminUserOrStudentDRFMixin permission can view the categories Only users with the IsPlatformAdminDRFMixin permission can create categories
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [PromptCategory] promptCategory (required):
  Future<PromptCategory?> aiMentorOrgsUsersCategoryCreate(String org, String userId, PromptCategory promptCategory,) async {
    final response = await aiMentorOrgsUsersCategoryCreateWithHttpInfo(org, userId, promptCategory,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PromptCategory',) as PromptCategory;
    
    }
    return null;
  }

  /// View to create/retrieve a prompt category  Only users with the IsAdminUserOrStudentDRFMixin permission can view the categories Only users with the IsPlatformAdminDRFMixin permission can create categories
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersCategoryDestroyWithHttpInfo(String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/category'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to create/retrieve a prompt category  Only users with the IsAdminUserOrStudentDRFMixin permission can view the categories Only users with the IsPlatformAdminDRFMixin permission can create categories
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<void> aiMentorOrgsUsersCategoryDestroy(String org, String userId,) async {
    final response = await aiMentorOrgsUsersCategoryDestroyWithHttpInfo(org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// View to create/retrieve a prompt category  Only users with the IsAdminUserOrStudentDRFMixin permission can view the categories Only users with the IsPlatformAdminDRFMixin permission can create categories
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersCategoryRetrieveWithHttpInfo(String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/category'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to create/retrieve a prompt category  Only users with the IsAdminUserOrStudentDRFMixin permission can view the categories Only users with the IsPlatformAdminDRFMixin permission can create categories
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<PromptCategory?> aiMentorOrgsUsersCategoryRetrieve(String org, String userId,) async {
    final response = await aiMentorOrgsUsersCategoryRetrieveWithHttpInfo(org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PromptCategory',) as PromptCategory;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [Mentor] mentor (required):
  Future<Response> aiMentorOrgsUsersCreateWithHttpInfo(String org, String userId, Mentor mentor,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = mentor;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [Mentor] mentor (required):
  Future<Mentor?> aiMentorOrgsUsersCreate(String org, String userId, Mentor mentor,) async {
    final response = await aiMentorOrgsUsersCreateWithHttpInfo(org, userId, mentor,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Mentor',) as Mentor;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] name (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersDestroyWithHttpInfo(String name, String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/{name}/'
      .replaceAll('{name}', name)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Parameters:
  ///
  /// * [String] name (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<void> aiMentorOrgsUsersDestroy(String name, String org, String userId,) async {
    final response = await aiMentorOrgsUsersDestroyWithHttpInfo(name, org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  ///      Get suggested AI prompts based on chat history     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersGuidedPromptsSessionsRetrieveWithHttpInfo(String org, String sessionId, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/guided-prompts/sessions/{session_id}/'
      .replaceAll('{org}', org)
      .replaceAll('{session_id}', sessionId)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Get suggested AI prompts based on chat history     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  Future<GuidedPromptsResponse?> aiMentorOrgsUsersGuidedPromptsSessionsRetrieve(String org, String sessionId, String userId,) async {
    final response = await aiMentorOrgsUsersGuidedPromptsSessionsRetrieveWithHttpInfo(org, sessionId, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'GuidedPromptsResponse',) as GuidedPromptsResponse;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [int] page:
  ///   A page number within the paginated result set.
  ///
  /// * [int] pageSize:
  ///   Number of results to return per page.
  Future<Response> aiMentorOrgsUsersListWithHttpInfo(String org, String userId, { int? page, int? pageSize, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (page != null) {
      queryParams.addAll(_queryParams('', 'page', page));
    }
    if (pageSize != null) {
      queryParams.addAll(_queryParams('', 'page_size', pageSize));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [int] page:
  ///   A page number within the paginated result set.
  ///
  /// * [int] pageSize:
  ///   Number of results to return per page.
  Future<PaginatedMentorList?> aiMentorOrgsUsersList(String org, String userId, { int? page, int? pageSize, }) async {
    final response = await aiMentorOrgsUsersListWithHttpInfo(org, userId,  page: page, pageSize: pageSize, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PaginatedMentorList',) as PaginatedMentorList;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersMentorsRetrieveWithHttpInfo(String mentor, String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/'
      .replaceAll('{mentor}', mentor)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Mentor?> aiMentorOrgsUsersMentorsRetrieve(String mentor, String org, String userId,) async {
    final response = await aiMentorOrgsUsersMentorsRetrieveWithHttpInfo(mentor, org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Mentor',) as Mentor;
    
    }
    return null;
  }

  /// Suggested Prompts Endpoint
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [SuggestedPrompt] suggestedPrompt (required):
  Future<Response> aiMentorOrgsUsersMentorsSuggestedPromptsCreateWithHttpInfo(String mentor, String org, String userId, SuggestedPrompt suggestedPrompt,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/suggested-prompts/'
      .replaceAll('{mentor}', mentor)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = suggestedPrompt;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Suggested Prompts Endpoint
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [SuggestedPrompt] suggestedPrompt (required):
  Future<DefaultResponse?> aiMentorOrgsUsersMentorsSuggestedPromptsCreate(String mentor, String org, String userId, SuggestedPrompt suggestedPrompt,) async {
    final response = await aiMentorOrgsUsersMentorsSuggestedPromptsCreateWithHttpInfo(mentor, org, userId, suggestedPrompt,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'DefaultResponse',) as DefaultResponse;
    
    }
    return null;
  }

  /// Request body  {\"index\": 0}
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersMentorsSuggestedPromptsDestroyWithHttpInfo(String mentor, String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/suggested-prompts/'
      .replaceAll('{mentor}', mentor)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Request body  {\"index\": 0}
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<void> aiMentorOrgsUsersMentorsSuggestedPromptsDestroy(String mentor, String org, String userId,) async {
    final response = await aiMentorOrgsUsersMentorsSuggestedPromptsDestroyWithHttpInfo(mentor, org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Suggested Prompts Endpoint
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersMentorsSuggestedPromptsRetrieveWithHttpInfo(String mentor, String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/suggested-prompts/'
      .replaceAll('{mentor}', mentor)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Suggested Prompts Endpoint
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<SuggestedPrompts?> aiMentorOrgsUsersMentorsSuggestedPromptsRetrieve(String mentor, String org, String userId,) async {
    final response = await aiMentorOrgsUsersMentorsSuggestedPromptsRetrieveWithHttpInfo(mentor, org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'SuggestedPrompts',) as SuggestedPrompts;
    
    }
    return null;
  }

  /// Suggested Prompts Endpoint
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [SuggestedPromptIndex] suggestedPromptIndex (required):
  Future<Response> aiMentorOrgsUsersMentorsSuggestedPromptsUpdateWithHttpInfo(String mentor, String org, String userId, SuggestedPromptIndex suggestedPromptIndex,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/mentors/{mentor}/suggested-prompts/'
      .replaceAll('{mentor}', mentor)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = suggestedPromptIndex;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Suggested Prompts Endpoint
  ///
  /// Parameters:
  ///
  /// * [String] mentor (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [SuggestedPromptIndex] suggestedPromptIndex (required):
  Future<DefaultResponse?> aiMentorOrgsUsersMentorsSuggestedPromptsUpdate(String mentor, String org, String userId, SuggestedPromptIndex suggestedPromptIndex,) async {
    final response = await aiMentorOrgsUsersMentorsSuggestedPromptsUpdateWithHttpInfo(mentor, org, userId, suggestedPromptIndex,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'DefaultResponse',) as DefaultResponse;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] name (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [PatchedMentor] patchedMentor:
  Future<Response> aiMentorOrgsUsersPartialUpdateWithHttpInfo(String name, String org, String userId, { PatchedMentor? patchedMentor, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/{name}/'
      .replaceAll('{name}', name)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = patchedMentor;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Parameters:
  ///
  /// * [String] name (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [PatchedMentor] patchedMentor:
  Future<Mentor?> aiMentorOrgsUsersPartialUpdate(String name, String org, String userId, { PatchedMentor? patchedMentor, }) async {
    final response = await aiMentorOrgsUsersPartialUpdateWithHttpInfo(name, org, userId,  patchedMentor: patchedMentor, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Mentor',) as Mentor;
    
    }
    return null;
  }

  /// View to create/retrieve a pinned message
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [PinnedMessageCreate] pinnedMessageCreate (required):
  Future<Response> aiMentorOrgsUsersPinMessageCreateWithHttpInfo(String org, String userId, PinnedMessageCreate pinnedMessageCreate,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/pin-message/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = pinnedMessageCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to create/retrieve a pinned message
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [PinnedMessageCreate] pinnedMessageCreate (required):
  Future<PinnedMessageCreate?> aiMentorOrgsUsersPinMessageCreate(String org, String userId, PinnedMessageCreate pinnedMessageCreate,) async {
    final response = await aiMentorOrgsUsersPinMessageCreateWithHttpInfo(org, userId, pinnedMessageCreate,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PinnedMessageCreate',) as PinnedMessageCreate;
    
    }
    return null;
  }

  /// View to create/retrieve a pinned message
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersPinMessageDestroyWithHttpInfo(String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/pin-message/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to create/retrieve a pinned message
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<void> aiMentorOrgsUsersPinMessageDestroy(String org, String userId,) async {
    final response = await aiMentorOrgsUsersPinMessageDestroyWithHttpInfo(org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// View to create/retrieve a pinned message
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersPinMessageRetrieveWithHttpInfo(String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/pin-message/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to create/retrieve a pinned message
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<PinnedMessageCreate?> aiMentorOrgsUsersPinMessageRetrieve(String org, String userId,) async {
    final response = await aiMentorOrgsUsersPinMessageRetrieveWithHttpInfo(org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'PinnedMessageCreate',) as PinnedMessageCreate;
    
    }
    return null;
  }

  /// View to create/retrieve a prompt
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [Prompt] prompt (required):
  Future<Response> aiMentorOrgsUsersPromptCreateWithHttpInfo(String org, String userId, Prompt prompt,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/prompt/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = prompt;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to create/retrieve a prompt
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [Prompt] prompt (required):
  Future<Prompt?> aiMentorOrgsUsersPromptCreate(String org, String userId, Prompt prompt,) async {
    final response = await aiMentorOrgsUsersPromptCreateWithHttpInfo(org, userId, prompt,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Prompt',) as Prompt;
    
    }
    return null;
  }

  /// View to create/retrieve a prompt
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this prompt.
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersPromptDestroyWithHttpInfo(int id, String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/prompt/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to create/retrieve a prompt
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this prompt.
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<void> aiMentorOrgsUsersPromptDestroy(int id, String org, String userId,) async {
    final response = await aiMentorOrgsUsersPromptDestroyWithHttpInfo(id, org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// View to create/retrieve a prompt
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersPromptListWithHttpInfo(String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/prompt/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to create/retrieve a prompt
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<List<Prompt>?> aiMentorOrgsUsersPromptList(String org, String userId,) async {
    final response = await aiMentorOrgsUsersPromptListWithHttpInfo(org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(responseBody, 'List<Prompt>') as List)
        .cast<Prompt>()
        .toList(growable: false);

    }
    return null;
  }

  /// View to create/retrieve a prompt
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this prompt.
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [PatchedPrompt] patchedPrompt:
  Future<Response> aiMentorOrgsUsersPromptPartialUpdateWithHttpInfo(int id, String org, String userId, { PatchedPrompt? patchedPrompt, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/prompt/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = patchedPrompt;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to create/retrieve a prompt
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this prompt.
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [PatchedPrompt] patchedPrompt:
  Future<Prompt?> aiMentorOrgsUsersPromptPartialUpdate(int id, String org, String userId, { PatchedPrompt? patchedPrompt, }) async {
    final response = await aiMentorOrgsUsersPromptPartialUpdateWithHttpInfo(id, org, userId,  patchedPrompt: patchedPrompt, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Prompt',) as Prompt;
    
    }
    return null;
  }

  /// View to create/retrieve a prompt
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this prompt.
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersPromptRetrieveWithHttpInfo(int id, String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/prompt/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to create/retrieve a prompt
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this prompt.
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Prompt?> aiMentorOrgsUsersPromptRetrieve(int id, String org, String userId,) async {
    final response = await aiMentorOrgsUsersPromptRetrieveWithHttpInfo(id, org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Prompt',) as Prompt;
    
    }
    return null;
  }

  /// View to create/retrieve a prompt
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this prompt.
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [Prompt] prompt (required):
  Future<Response> aiMentorOrgsUsersPromptUpdateWithHttpInfo(int id, String org, String userId, Prompt prompt,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/prompt/{id}/'
      .replaceAll('{id}', id.toString())
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = prompt;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to create/retrieve a prompt
  ///
  /// Parameters:
  ///
  /// * [int] id (required):
  ///   A unique integer value identifying this prompt.
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [Prompt] prompt (required):
  Future<Prompt?> aiMentorOrgsUsersPromptUpdate(int id, String org, String userId, Prompt prompt,) async {
    final response = await aiMentorOrgsUsersPromptUpdateWithHttpInfo(id, org, userId, prompt,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Prompt',) as Prompt;
    
    }
    return null;
  }

  /// Paginated view to return recent messages
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersRecentMessagesRetrieveWithHttpInfo(String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/recent-messages/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Paginated view to return recent messages
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<ChatSessionWithMessage?> aiMentorOrgsUsersRecentMessagesRetrieve(String org, String userId,) async {
    final response = await aiMentorOrgsUsersRecentMessagesRetrieveWithHttpInfo(org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ChatSessionWithMessage',) as ChatSessionWithMessage;
    
    }
    return null;
  }

  ///      Recommend courses for a user     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [bool] includeLearnerSkills:
  ///   Include available learner skills for search
  ///
  /// * [bool] rankByDifficulty:
  ///   Rank by course difficulty
  ///
  /// * [bool] returnCourseData:
  ///   Return course data
  ///
  /// * [int] returnNumber:
  ///   Number of courses to return
  ///
  /// * [String] searchTerms:
  ///   Terms to be searched
  Future<Response> aiMentorOrgsUsersRecommendCoursesRetrieveWithHttpInfo(String org, String userId, { bool? includeLearnerSkills, bool? rankByDifficulty, bool? returnCourseData, int? returnNumber, String? searchTerms, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/recommend-courses/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (includeLearnerSkills != null) {
      queryParams.addAll(_queryParams('', 'include_learner_skills', includeLearnerSkills));
    }
    if (rankByDifficulty != null) {
      queryParams.addAll(_queryParams('', 'rank_by_difficulty', rankByDifficulty));
    }
    if (returnCourseData != null) {
      queryParams.addAll(_queryParams('', 'return_course_data', returnCourseData));
    }
    if (returnNumber != null) {
      queryParams.addAll(_queryParams('', 'return_number', returnNumber));
    }
    if (searchTerms != null) {
      queryParams.addAll(_queryParams('', 'search_terms', searchTerms));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Recommend courses for a user     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [bool] includeLearnerSkills:
  ///   Include available learner skills for search
  ///
  /// * [bool] rankByDifficulty:
  ///   Rank by course difficulty
  ///
  /// * [bool] returnCourseData:
  ///   Return course data
  ///
  /// * [int] returnNumber:
  ///   Number of courses to return
  ///
  /// * [String] searchTerms:
  ///   Terms to be searched
  Future<RecommendCourseResponse?> aiMentorOrgsUsersRecommendCoursesRetrieve(String org, String userId, { bool? includeLearnerSkills, bool? rankByDifficulty, bool? returnCourseData, int? returnNumber, String? searchTerms, }) async {
    final response = await aiMentorOrgsUsersRecommendCoursesRetrieveWithHttpInfo(org, userId,  includeLearnerSkills: includeLearnerSkills, rankByDifficulty: rankByDifficulty, returnCourseData: returnCourseData, returnNumber: returnNumber, searchTerms: searchTerms, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'RecommendCourseResponse',) as RecommendCourseResponse;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] name (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersRetrieveWithHttpInfo(String name, String org, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/{name}/'
      .replaceAll('{name}', name)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Parameters:
  ///
  /// * [String] name (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  Future<Mentor?> aiMentorOrgsUsersRetrieve(String name, String org, String userId,) async {
    final response = await aiMentorOrgsUsersRetrieveWithHttpInfo(name, org, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Mentor',) as Mentor;
    
    }
    return null;
  }

  /// View to get the sessions of a particular user filterable by start date and end date without pagination
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] endDate (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] startDate (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersSessionidListWithHttpInfo(String endDate, String org, String startDate, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/sessionid/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

      queryParams.addAll(_queryParams('', 'end_date', endDate));
      queryParams.addAll(_queryParams('', 'start_date', startDate));

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to get the sessions of a particular user filterable by start date and end date without pagination
  ///
  /// Parameters:
  ///
  /// * [String] endDate (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] startDate (required):
  ///
  /// * [String] userId (required):
  Future<List<ChatHistorySessionId>?> aiMentorOrgsUsersSessionidList(String endDate, String org, String startDate, String userId,) async {
    final response = await aiMentorOrgsUsersSessionidListWithHttpInfo(endDate, org, startDate, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(responseBody, 'List<ChatHistorySessionId>') as List)
        .cast<ChatHistorySessionId>()
        .toList(growable: false);

    }
    return null;
  }

  /// Create a new chat session
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [ChatSessionRequest] chatSessionRequest (required):
  Future<Response> aiMentorOrgsUsersSessionsCreateWithHttpInfo(String org, String userId, ChatSessionRequest chatSessionRequest,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/sessions/'
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = chatSessionRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Create a new chat session
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [ChatSessionRequest] chatSessionRequest (required):
  Future<ChatSessionResponse?> aiMentorOrgsUsersSessionsCreate(String org, String userId, ChatSessionRequest chatSessionRequest,) async {
    final response = await aiMentorOrgsUsersSessionsCreateWithHttpInfo(org, userId, chatSessionRequest,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ChatSessionResponse',) as ChatSessionResponse;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersSessionsDestroyWithHttpInfo(String org, String sessionId, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/'
      .replaceAll('{org}', org)
      .replaceAll('{session_id}', sessionId)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  Future<void> aiMentorOrgsUsersSessionsDestroy(String org, String sessionId, String userId,) async {
    final response = await aiMentorOrgsUsersSessionsDestroyWithHttpInfo(org, sessionId, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// View to add the downloadable message for a session
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersSessionsDownloadSessionRetrieveWithHttpInfo(String org, String sessionId, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/download-session'
      .replaceAll('{org}', org)
      .replaceAll('{session_id}', sessionId)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// View to add the downloadable message for a session
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  Future<ChatHistoryItem?> aiMentorOrgsUsersSessionsDownloadSessionRetrieve(String org, String sessionId, String userId,) async {
    final response = await aiMentorOrgsUsersSessionsDownloadSessionRetrieveWithHttpInfo(org, sessionId, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ChatHistoryItem',) as ChatHistoryItem;
    
    }
    return null;
  }

  ///      Get chat messages     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [bool] share:
  Future<Response> aiMentorOrgsUsersSessionsRetrieveWithHttpInfo(String org, String sessionId, String userId, { bool? share, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/'
      .replaceAll('{org}', org)
      .replaceAll('{session_id}', sessionId)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (share != null) {
      queryParams.addAll(_queryParams('', 'share', share));
    }

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Get chat messages     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [bool] share:
  Future<MessageView?> aiMentorOrgsUsersSessionsRetrieve(String org, String sessionId, String userId, { bool? share, }) async {
    final response = await aiMentorOrgsUsersSessionsRetrieveWithHttpInfo(org, sessionId, userId,  share: share, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MessageView',) as MessageView;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersSessionsSuggestionRetrieveWithHttpInfo(String org, String sessionId, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/suggestion'
      .replaceAll('{org}', org)
      .replaceAll('{session_id}', sessionId)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  Future<RelatedText?> aiMentorOrgsUsersSessionsSuggestionRetrieve(String org, String sessionId, String userId,) async {
    final response = await aiMentorOrgsUsersSessionsSuggestionRetrieveWithHttpInfo(org, sessionId, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'RelatedText',) as RelatedText;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] taskId (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersSessionsTasksRetrieveWithHttpInfo(String org, String sessionId, String taskId, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/tasks/{task_id}/'
      .replaceAll('{org}', org)
      .replaceAll('{session_id}', sessionId)
      .replaceAll('{task_id}', taskId)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] taskId (required):
  ///
  /// * [String] userId (required):
  Future<ChatHistoryItem?> aiMentorOrgsUsersSessionsTasksRetrieve(String org, String sessionId, String taskId, String userId,) async {
    final response = await aiMentorOrgsUsersSessionsTasksRetrieveWithHttpInfo(org, sessionId, taskId, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ChatHistoryItem',) as ChatHistoryItem;
    
    }
    return null;
  }

  ///      Update Chat session details     
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [MessageViewRequest] messageViewRequest:
  Future<Response> aiMentorOrgsUsersSessionsUpdateWithHttpInfo(String org, String sessionId, String userId, { MessageViewRequest? messageViewRequest, }) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/sessions/{session_id}/'
      .replaceAll('{org}', org)
      .replaceAll('{session_id}', sessionId)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = messageViewRequest;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  ///      Update Chat session details     
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [MessageViewRequest] messageViewRequest:
  Future<MessageViewUpdatResponse?> aiMentorOrgsUsersSessionsUpdate(String org, String sessionId, String userId, { MessageViewRequest? messageViewRequest, }) async {
    final response = await aiMentorOrgsUsersSessionsUpdateWithHttpInfo(org, sessionId, userId,  messageViewRequest: messageViewRequest, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MessageViewUpdatResponse',) as MessageViewUpdatResponse;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] taskId (required):
  ///
  /// * [String] userId (required):
  Future<Response> aiMentorOrgsUsersTasksRetrieveWithHttpInfo(String org, String taskId, String userId,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/tasks/{task_id}'
      .replaceAll('{org}', org)
      .replaceAll('{task_id}', taskId)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] taskId (required):
  ///
  /// * [String] userId (required):
  Future<RetrieveTask?> aiMentorOrgsUsersTasksRetrieve(String org, String taskId, String userId,) async {
    final response = await aiMentorOrgsUsersTasksRetrieveWithHttpInfo(org, taskId, userId,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'RetrieveTask',) as RetrieveTask;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [TaskView] taskView (required):
  Future<Response> aiMentorOrgsUsersTasksSessionsCreateWithHttpInfo(String org, String sessionId, String userId, TaskView taskView,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/tasks/sessions/{session_id}/'
      .replaceAll('{org}', org)
      .replaceAll('{session_id}', sessionId)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = taskView;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Parameters:
  ///
  /// * [String] org (required):
  ///
  /// * [String] sessionId (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [TaskView] taskView (required):
  Future<TaskView?> aiMentorOrgsUsersTasksSessionsCreate(String org, String sessionId, String userId, TaskView taskView,) async {
    final response = await aiMentorOrgsUsersTasksSessionsCreateWithHttpInfo(org, sessionId, userId, taskView,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'TaskView',) as TaskView;
    
    }
    return null;
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] name (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [Mentor] mentor (required):
  Future<Response> aiMentorOrgsUsersUpdateWithHttpInfo(String name, String org, String userId, Mentor mentor,) async {
    // ignore: prefer_const_declarations
    final path = r'/api/ai/mentor/orgs/{org}/users/{user_id}/{name}/'
      .replaceAll('{name}', name)
      .replaceAll('{org}', org)
      .replaceAll('{user_id}', userId);

    // ignore: prefer_final_locals
    Object? postBody = mentor;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const contentTypes = <String>['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'];


    return apiClient.invokeAPI(
      path,
      'PUT',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes.first,
    );
  }

  /// Mixin that includes the StudentTokenAuthentication and IsAdminUserOrStudent
  ///
  /// Parameters:
  ///
  /// * [String] name (required):
  ///
  /// * [String] org (required):
  ///
  /// * [String] userId (required):
  ///
  /// * [Mentor] mentor (required):
  Future<Mentor?> aiMentorOrgsUsersUpdate(String name, String org, String userId, Mentor mentor,) async {
    final response = await aiMentorOrgsUsersUpdateWithHttpInfo(name, org, userId, mentor,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body.isNotEmpty && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Mentor',) as Mentor;
    
    }
    return null;
  }
}
